#!/bin/bash
. /etc/default/locale
. /etc/environment
for lt_var in $(env -i locale | sed -e 's/=.*$//') LANGUAGE
do
	eval "if test \"\${$lt_var+set}\" = set; then
		export $lt_var
		fi"
done

case $1 in
  Sawfish)
     sawfish 
     ;;
  Flwm)
     flwm 
     ;;
  metacity)
     icon-menu metacity &
     exec metacity 
     ;;
  Jwm)
     jwm 
     ;;
  evilwm)
     icon-menu evilwm &
     evilwm 
     ;;
  Icewm)
     icewm 
     ;;
  kde_window_manager)
     icon-menu kwin &
     kwin 
     ;;
  Oroborus)
     icon-menu oroborus &
     oroborus 
     ;;
  fluxbox)
     fluxbox 
     ;;
  blackbox)
     blackbox 
     ;;
  Openbox)
     openbox 
     ;;
  Sapphire)
     sapphire 
     ;;
  fvwm)
     exec fvwm 
     ;;
  Wmaker)
     exec wmaker 
     ;;
  AfterStep)
     afterstep
     ;;
  e17)
     enlightenment_start 
     ;;
  olvwm)
     olvwm 
     ;;
  VTWM)
     vtwm 
     ;;
  awesome)
     awesome 
     ;;
  dwm)
     icon-menu dwm &
     dwm 
     ;;
  i3)
     i3 
     ;;
  ratpoison)
     ratpoison 
     ;;
  StumpWM)
     stumpwm 
     ;;
  wmii)
     wmii 
     ;;
  Bluetile)
     icon-menu bluetile &
     bluetile 
     ;;
  ctwm)
     ctwm 
     ;;
  LWM)
     icon-menu lwm &
     lwm 
     ;;
  MIWM)
     icon-menu miwm &
     miwm 
     ;;
  pekwm)
     pekwm 
     ;;
  TinyWM)
     icon-menu tinywm &
     tinywm 
     ;;
  WindowLab)
     icon-menu windowlab &
     windowlab 
     ;;
  wm2)
     icon-menu wm2 &
     wm2 
     ;;
  9wm)
     icon-menu 9wm &
     9wm 
     ;;
  aewm)
     icon-menu aewm &
     aewm 
     ;;
  aewm++)
     aewm++_appbar &
     aewm++_fspanel &
     aewm++
     ;;
  olwm)
     olwm 
     ;;
  w9wm)
     icon-menu w9wm &
     w9wm 
     ;;
  Scrotwm)
     icon-menu scrotwm &
     scrotwm 
     ;;
  tritium)
     icon-menu tritium &
     tritium 
     ;;
  amiwm)
     icon-menu amiwm &
     amiwm 
     ;;
  compiz)
     icon-menu compiz &
     compiz 
     ;;
  mutter)
     icon-menu mutter &
     mutter 
     ;;
  metacity)
     icon-menu metacity &
     metacity 
     ;;
  kwin)
     icon-menu kwin &
     kwin 
     ;;
  xfwm4)
     icon-menu xfwm4 &
     xfwm4 
     ;;
  unity)
     unity
     ;;
  gnome-shell)
     gnome-shell
     ;;
  kde)
     startkde 
     ;;
  xfce4)
     startxfce4
     ;;
  lxde)
     startlxde
     ;;
  icon-de)
     icon_de
     ;;
  随机启动)
     icon-de
     ;;
  select_wm)
     konsole -e select_wm
     ;;
  *)
     ;;
  esac
