// g++ -o ./bin/icon-clock ./src/icon-clock.c -lX11 -lImlib2 -lXmu `pkg-config --cflags --libs glib-2.0`
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <X11/Xlib.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <X11/Xmu/WinUtil.h>
#include <glib-2.0/glib.h>
#include "Imlib2.h"

Display                        *disp;
Window                          win3;
Visual                         *vis;
Colormap                        cm;
int                             depth;
XSetWindowAttributes            attr;
int i3;
int mytoggle = 0;
Imlib_Image                 buffer3;
Imlib_Font                    font3;
int clock_move=0;
char Alarm1[3][32];
char say_text[3][1024];
int open_close[3];
int f_red=0,f_green=0,f_blue=0,f_alpha=255;

#include "./other_src/wm_ctrl.c"
#include "./other_src/rc_str.c"

#define MWM_HINTS_FUNCTIONS       (1L << 0) /* wheter the functions member of the struct schould be listened to */
#define MWM_HINTS_DECORATIONS     (1L << 1) /* same for decorations member */

#define MWM_FUNC_ALL              (1L << 0) /* means as much as we schould reversely interpret all other bits */
#define MWM_FUNC_RESIZE           (1L << 1) /* self explanatory */
#define MWM_FUNC_MOVE             (1L << 2)
#define MWM_FUNC_MINIMIZE         (1L << 3)
#define MWM_FUNC_MAXIMIZE         (1L << 4)
#define MWM_FUNC_CLOSE            (1L << 5)

#define MWM_DECOR_ALL             (1L << 0) /* equivalent of MWM_HINTS_FUNCTIONS */
#define MWM_DECOR_BORDER          (1L << 1) /* show border */
#define MWM_DECOR_RESIZEH         (1L << 2) /* show resize handle */
#define MWM_DECOR_TITLE           (1L << 3) /* show title bar */
#define MWM_DECOR_MENU            (1L << 4) /* wich buttons to show */
#define MWM_DECOR_MINIMIZE        (1L << 5)
#define MWM_DECOR_MAXIMIZE        (1L << 6)
#define PROP_MWM_HINTS_ELEMENTS 5
typedef struct _mwmhints {
                                uint32_t flags;
                                uint32_t functions;
                                uint32_t decorations;
                                int32_t  input_mode;
                                uint32_t status;
                } MWMHints;

void showwin3(int screenX,int screenY)
{
    char text[1024];    
    int text_w,text_h;
    char aa[32];
    imlib_context_set_font(font3);
    imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
    time_t now_time;
    now_time=time(0);
    if (i3==1)
    {
        strftime(text, sizeof(text), "  %H:%M  ",localtime(&now_time) );
        i3=0;
    } else {
        strftime(text, sizeof(text), "  %H %M  ",localtime(&now_time) );
        i3=1;
        strftime(aa, sizeof(aa), "%H:%M",localtime(&now_time) );
        if ((open_close[0]==1) and (strcmp(aa,Alarm1[0])==0 ))
            sprintf(text,"%s",say_text[0]);
        if ((open_close[1]==1) and (strcmp(aa,Alarm1[1])==0 ))
            sprintf(text,"%s",say_text[1]);
        if ((open_close[2]==1) and (strcmp(aa,Alarm1[2])==0 ))
            sprintf(text,"%s",say_text[2]);
    }
    
    imlib_get_text_size(text, &text_w, &text_h);
    XRaiseWindow(disp,win3);
    XMapWindow(disp, win3);
    imlib_context_set_drawable(win3); 
         /* draw the range */
    imlib_context_set_image(buffer3);
    imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
         /* free it */
            //         imlib_free_color_range();
    imlib_context_set_image(buffer3);
    imlib_context_set_drawable(win3); 
    imlib_render_image_on_drawable(0, 0); 
    imlib_context_set_font(font3);
    imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
    imlib_text_draw(5,2,text);
    /* set the buffer image as our current image */
    imlib_context_set_image(buffer3);
    imlib_render_image_on_drawable(0, 0); 
    imlib_context_set_image(buffer3);
}

int main(int argc, char **argv)
{
    XEvent                      ev;
    const char                 *display_name = getenv("DISPLAY");
    char                        text[1024];
    char                       *skip;
    Imlib_Color_Range            range;
    int    text_w, text_h;
    if (display_name == NULL)
        display_name = ":0";
    disp = XOpenDisplay(display_name);
    if (disp == NULL)
    {
        fprintf(stderr, "Can't open display %s\n", display_name);
        return 1;
    }

    int screenX=10;
    int screenY=10;
    char submenue[1000];
    char ch2[1024];
    int n=0;
    int Tiling_mode=0;
    char title_win_xy2[6][50];
    char title_win_xy3[9][50];
    char title_win_xy4[12][50];
    char usermenufile[1024];
    char home[1024];
    sprintf(home,"%s",getenv("HOME"));
    int bord=1;
    if ( strcmp(home,"") == 0 )

    {
        printf("fatal error: no /home/xxx found!\n");
        return 1;
    }
//----arguments x y width height lower/raise(0/1) picture hidemode
    if ( argc == 1 )
    {
        printf("usage: icon-clock x y skip have_title(0/1)\n");
        return 1;
    }
    if ( argc != 5 )
    {
        return 1;
    }
 // printf("ok\n");
    sscanf(argv[1], "%d", &screenX);
    sscanf(argv[2], "%d", &screenY);
    skip=argv[3];
    sscanf(argv[4], "%d", &bord);
    char f_buffer[4096];
    FILE * fp2=NULL;
    int i;
    
    int c_red=255,c_green=200,c_blue=10,c_alpha=255;
    sprintf(usermenufile,"%s/.icon-DE/icon-de.rc",home);
    if (access(usermenufile,0)!=-1)
    {
        fp2=fopen(usermenufile,"r");
    }
    else if (access("usr/share/icon-DE/icon-de.rc",0)!=-1)
        fp2=fopen("usr/share/icon-DE/icon-de.rc","r");
    if (fp2==NULL)
    {
        printf("can't open ~/.icon-DE/icon-de.rc\n");
    }
    fgets(f_buffer,4096,fp2);
    for (i=0;i<4096;i++)
        if (f_buffer[i]=='\n') f_buffer[i]='\0';
    while ( ! feof(fp2) )
    {
        if (check_rc(f_buffer,"tag_color:")==0 )
        {
            get_str(ch2,f_buffer,"tag_color:");
            get_int2(c_red,ch2,1);
            get_int2(c_green,ch2,2);
            get_int2(c_blue,ch2,3);
            get_int2(c_alpha,ch2,4);
        }
        if (check_rc(f_buffer,"font_color:")==0 )
        {
            get_str(ch2,f_buffer,"font_color:");
            get_int2(f_red,ch2,1);
            get_int2(f_green,ch2,2);
            get_int2(f_blue,ch2,3);
            get_int2(f_alpha,ch2,4);
        }
        fgets(f_buffer,4096,fp2);
        for (i=0;i<4096;i++)
            if (f_buffer[i]=='\n') f_buffer[i]='\0';
    }
    fclose(fp2);

    vis = DefaultVisual(disp, DefaultScreen(disp));
    depth = DefaultDepth(disp, DefaultScreen(disp));
    cm = DefaultColormap(disp, DefaultScreen(disp));
                // text
    range = imlib_create_color_range();
    imlib_context_set_color_range(range);
    imlib_context_set_color(255, 255, 255, 255);
    imlib_add_color_to_color_range(0);
    /* add an orange color, semi-transparent 10 units from the first */
//    imlib_context_set_color(255, 200, 10, 255);
    imlib_context_set_color(c_red, c_green, c_blue, c_alpha);
    imlib_add_color_to_color_range(10);
    /* add black, fully transparent at the end 20 units away */
    imlib_context_set_color(70, 0, 0, 255);
    imlib_add_color_to_color_range(20);

    attr.override_redirect=True;

     /**
        * Start rendering
        */

    imlib_context_set_display(disp);
    imlib_context_set_visual(vis);
    imlib_context_set_colormap(cm);
    imlib_context_set_dither(1);
    imlib_context_set_blend(0);
    imlib_context_set_color_modifier(NULL);

//--
   
    i=1;
    i3=1;
    Window cur_win=0;
    Window cur_win2=0;
//    Window cur_win_id;
    MWMHints mwmhints;
    Atom prop;
    MWMHints *hints;
    Atom type;
    int format;
    unsigned long nitems;
    unsigned long bytes_after;

    int xfd = ConnectionNumber(disp);
    long ticks;
    fd_set rfds;
    time_t now_time;
    struct timeval now, tm,LastTime;
    now_time=time(0);

    list_windows(disp,skip);
    
    gettimeofday(&LastTime, 0);


    buffer3 = imlib_create_image(1000, 30);    
    char font_path[1024];
    sprintf(font_path,"%s/.icon-DE/fonts",home);
    imlib_add_path_to_font_path(font_path);
    imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
    imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");
    font3 = imlib_load_font("Vera/11");
    if (font3 == NULL)
        font3 = imlib_load_font("wqy-zenhei.ttc/11");
    imlib_context_set_font(font3);
    imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
    if (i3==1)
    {
        strftime(text, sizeof(text), "%H:%M",localtime(&now_time) );
        i3=0;
    } else {
        strftime(text, sizeof(text), "%H %M",localtime(&now_time) );
        i3=1;
    }
    imlib_get_text_size(text, &text_w, &text_h);
    win3=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,text_w+30,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
    XSelectInput(disp, win3, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
//    imlib_free_font();

    Tiling_mode=0;
    unsigned long action;
    gchar *tmp_prop2, *tmp2;
    gchar *tmp_prop1, *tmp1;

//    char command[1024]=" ";
    FILE *freeNum;

    char rcfile[10]="clock.rc";
    sprintf(usermenufile,"%s/.icon-DE/%s",home,rcfile);
    if (access(usermenufile,0)==-1)
    {
        system("mkdir ~/.icon-DE");
        system("cp /etc/icon-de/clock.rc ~/.icon-DE/");
    }
    freeNum=fopen(usermenufile,"r");
    if ( freeNum==NULL)
    { 
        printf("error on open %s\n",usermenufile); 
        exit(1); 
    }
    char buffer_rc[1024];

    while ( ! feof(freeNum) )
    {
        fgets(buffer_rc,1024,freeNum);
        for (n=0;n<1024;n++)
            if (buffer_rc[n]=='\n') buffer_rc[n]='\0';
//        printf("%s\n",buffer_rc); 
//        for (n=0;n<1024;n++)
//            command[n]='\0';
        if (strcmp(buffer_rc,"")!=0 )
        {
            sprintf(ch2,"%c",buffer_rc[0]);
            if (strcmp(ch2,"#")!=0 ) 
            {
                if (check_rc(buffer_rc,"Alarm1:")==0 )
                {
                    get_str(ch2,buffer_rc,"Alarm1:");
                    get_str2(Alarm1[0],ch2,1);
                    get_str2(say_text[0],ch2,2);
                    get_int2(open_close[0],ch2,3);
                }
                if (check_rc(buffer_rc,"Alarm2:")==0 )
                {
                    get_str(ch2,buffer_rc,"Alarm2:");
                    get_str2(Alarm1[1],ch2,1);
                    get_str2(say_text[1],ch2,2);
                    get_int2(open_close[1],ch2,3);
                }
                if (check_rc(buffer_rc,"Alarm3:")==0 )
                {
                    get_str(ch2,buffer_rc,"Alarm3:");
                    get_str2(Alarm1[2],ch2,1);
                    get_str2(say_text[2],ch2,2);
                    get_int2(open_close[2],ch2,3);
                }
                if (check_rc(buffer_rc,"Tiling_window02_1_1:")==0 ) get_str(title_win_xy2[0],buffer_rc,"Tiling_window02_1_1:");
                if (check_rc(buffer_rc,"Tiling_window02_1_2:")==0 ) get_str(title_win_xy2[1],buffer_rc,"Tiling_window02_1_2:");
                if (check_rc(buffer_rc,"Tiling_window02_2_1:")==0 ) get_str(title_win_xy2[2],buffer_rc,"Tiling_window02_2_1:");
                if (check_rc(buffer_rc,"Tiling_window02_2_2:")==0 ) get_str(title_win_xy2[3],buffer_rc,"Tiling_window02_2_2:");
                if (check_rc(buffer_rc,"Tiling_window02_3_1:")==0 ) get_str(title_win_xy2[4],buffer_rc,"Tiling_window02_3_1:");
                if (check_rc(buffer_rc,"Tiling_window02_3_2:")==0 ) get_str(title_win_xy2[5],buffer_rc,"Tiling_window02_3_2:");

                if (check_rc(buffer_rc,"Tiling_window03_1_1:")==0 ) get_str(title_win_xy3[0],buffer_rc,"Tiling_window02_1_1:");
                if (check_rc(buffer_rc,"Tiling_window03_1_2:")==0 ) get_str(title_win_xy3[1],buffer_rc,"Tiling_window02_1_2:");
                if (check_rc(buffer_rc,"Tiling_window03_1_3:")==0 ) get_str(title_win_xy3[2],buffer_rc,"Tiling_window02_1_3:");
                if (check_rc(buffer_rc,"Tiling_window03_2_1:")==0 ) get_str(title_win_xy3[3],buffer_rc,"Tiling_window02_2_1:");
                if (check_rc(buffer_rc,"Tiling_window03_2_2:")==0 ) get_str(title_win_xy3[4],buffer_rc,"Tiling_window02_2_2:");
                if (check_rc(buffer_rc,"Tiling_window03_2_3:")==0 ) get_str(title_win_xy3[5],buffer_rc,"Tiling_window02_2_3:");
                if (check_rc(buffer_rc,"Tiling_window03_3_1:")==0 ) get_str(title_win_xy3[6],buffer_rc,"Tiling_window02_3_1:");
                if (check_rc(buffer_rc,"Tiling_window03_3_2:")==0 ) get_str(title_win_xy3[7],buffer_rc,"Tiling_window02_3_2:");
                if (check_rc(buffer_rc,"Tiling_window03_3_3:")==0 ) get_str(title_win_xy3[8],buffer_rc,"Tiling_window02_3_3:");

                if (check_rc(buffer_rc,"Tiling_window04_1_1:")==0 ) get_str(title_win_xy4[0],buffer_rc,"Tiling_window04_1_1:");
                if (check_rc(buffer_rc,"Tiling_window04_1_2:")==0 ) get_str(title_win_xy4[1],buffer_rc,"Tiling_window04_1_2:");
                if (check_rc(buffer_rc,"Tiling_window04_1_3:")==0 ) get_str(title_win_xy4[2],buffer_rc,"Tiling_window04_1_3:");
                if (check_rc(buffer_rc,"Tiling_window04_1_4:")==0 ) get_str(title_win_xy4[3],buffer_rc,"Tiling_window04_1_4:");
                if (check_rc(buffer_rc,"Tiling_window04_2_1:")==0 ) get_str(title_win_xy4[4],buffer_rc,"Tiling_window04_2_1:");
                if (check_rc(buffer_rc,"Tiling_window04_2_2:")==0 ) get_str(title_win_xy4[5],buffer_rc,"Tiling_window04_2_2:");
                if (check_rc(buffer_rc,"Tiling_window04_2_3:")==0 ) get_str(title_win_xy4[6],buffer_rc,"Tiling_window04_2_3:");
                if (check_rc(buffer_rc,"Tiling_window04_2_4:")==0 ) get_str(title_win_xy4[7],buffer_rc,"Tiling_window04_2_4:");
                if (check_rc(buffer_rc,"Tiling_window04_3_1:")==0 ) get_str(title_win_xy4[8],buffer_rc,"Tiling_window04_3_1:");
                if (check_rc(buffer_rc,"Tiling_window04_3_2:")==0 ) get_str(title_win_xy4[9],buffer_rc,"Tiling_window04_3_2:");
                if (check_rc(buffer_rc,"Tiling_window04_3_3:")==0 ) get_str(title_win_xy4[10],buffer_rc,"Tiling_window04_3_3:");
                if (check_rc(buffer_rc,"Tiling_window04_3_4:")==0 ) get_str(title_win_xy4[11],buffer_rc,"Tiling_window04_3_4:");
            }
        }        
    }
    fclose(freeNum);

    int w_bord=0;
    while (1)
    {
        if (XPending(disp))
        {
            XNextEvent(disp, &ev);
            switch (ev.type)
            {
            case Expose:
                break;
            case MotionNotify:
                break;
            default:
                break;
            case EnterNotify:		
                break;
            case LeaveNotify:		
                if (clock_move==0)
                {
//                    XMoveWindow(disp, win, screenX, screenY+30);
                    XMoveWindow(disp, win3, screenX, screenY+30);
                    clock_move=1;
                } else {
//                    XMoveWindow(disp, win, screenX, screenY);
                    XMoveWindow(disp, win3, screenX, screenY);
                    clock_move=0;
                }
                break;
            case ButtonPress:				
                int is_5=0;
                int is_6=0;
                if(ev.xbutton.button==1)
                {
                    if (list_windows(disp,skip)!=EXIT_FAILURE)
                    {
                        bord=1;
                        memset(&mwmhints, 0, sizeof(mwmhints));
                        prop = XInternAtom(disp, "_MOTIF_WM_HINTS", False);
                        mwmhints.flags = MWM_HINTS_DECORATIONS;
                        mwmhints.decorations = 0;
                        for (i=0;i<win_count;i++)
                        {
                            if (win_pid_list[i]!=0)
                            {
                                XChangeProperty(disp, win_pid_list[i], prop, prop, 32, PropModeReplace,
                                            (unsigned char *) &mwmhints,
                                            PROP_MWM_HINTS_ELEMENTS);
                            }
                        }
                        system("killall icon-wharf 2>/dev/null");
                        sprintf(submenue,"icon-wharf 1 &");
                        system(submenue);
                    }    
                    break;
                }
                if(ev.xbutton.button==2)
                {
                    if (get_active_window(disp)!=0)
                    {    
                        if (strstr(skip,get_window_class(disp, get_active_window(disp)))==NULL)
                        {
                            if (w_bord==0)
                            {
                                w_bord=1;
                                printf("0\n");
                                memset(&mwmhints, 0, sizeof(mwmhints));
                                prop = XInternAtom(disp, "_MOTIF_WM_HINTS", False);
                                mwmhints.flags = MWM_HINTS_DECORATIONS;
                                mwmhints.decorations = 0;
                                XChangeProperty(disp, get_active_window(disp), prop, prop, 32, PropModeReplace,
                                                (unsigned char *) &mwmhints,
                                                PROP_MWM_HINTS_ELEMENTS);
                            } else if (w_bord==1) {
                                printf("1\n");
                                w_bord=2;
                                const char *p1="above";
                                Atom prop1 = 0;
                                action = _NET_WM_STATE_ADD;
                                tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                prop1 = XInternAtom(disp, tmp_prop1, False);
                                client_msg(disp, get_active_window(disp), "_NET_WM_STATE", 
                                    action, (unsigned long)prop1, 0, 0, 0);
                                XSync(disp, False);
                            } else if (w_bord==2) {
                                printf("2\n");
                                w_bord=0;
                                init_window(get_active_window(disp));
                                memset(&mwmhints, 0, sizeof(mwmhints));
                                prop = XInternAtom(disp, "_MOTIF_WM_HINTS", FALSE);
                                hints=(MWMHints*)&prop;
                                XGetWindowProperty( disp,get_active_window(disp),
                                                prop,0,5,
                                                False,AnyPropertyType,&type,&format,&nitems,
                                                &bytes_after,(unsigned char **)&hints );
                                if ( type != None )
                                {
                                    hints->flags=MWM_HINTS_FUNCTIONS | MWM_HINTS_DECORATIONS;
                                    hints->functions|=( MWM_FUNC_MOVE | MWM_FUNC_CLOSE | MWM_FUNC_MINIMIZE | MWM_FUNC_MAXIMIZE | MWM_FUNC_RESIZE );
                                    hints->decorations|=MWM_DECOR_ALL;
                                }
    /*                            else
                                {
                                    memset( &prop,0,sizeof( MWMHints ) );
                                    hints=(MWMHints*)&prop;
                                    hints->flags=( MWM_HINTS_FUNCTIONS | MWM_HINTS_DECORATIONS);
                                    hints->functions=( MWM_FUNC_MOVE | MWM_FUNC_CLOSE | MWM_FUNC_MINIMIZE | MWM_FUNC_MAXIMIZE | MWM_FUNC_RESIZE );
                                    hints->decorations=( MWM_DECOR_ALL );
                                } */

                                XChangeProperty( disp,get_active_window(disp),prop,prop,32,
                                        PropModeReplace,(const unsigned char*)&prop,5 );
                                if ( hints != (MWMHints*)&prop ) XFree( hints );
                            }
                        }
                    }
                    break;
                }
                if(ev.xbutton.button==3)
                {
                    if (list_windows(disp,skip)!=EXIT_FAILURE)
                    {
                        bord=0;
                        memset(&mwmhints, 0, sizeof(mwmhints));

                        for (i=0;i<win_count;i++)
                        {
                            if (win_pid_list[i]!=0)
                            {
                                prop = XInternAtom(disp, "_MOTIF_WM_HINTS", FALSE);
                                hints=(MWMHints*)&prop;
                                XGetWindowProperty( disp,win_pid_list[i],
                                            prop,0,5,
                                            False,AnyPropertyType,&type,&format,&nitems,
                                            &bytes_after,(unsigned char **)&hints );
                                if ( type != None )
                                {
                                    hints->flags=MWM_HINTS_FUNCTIONS | MWM_HINTS_DECORATIONS;
                                    hints->functions|=( MWM_FUNC_MOVE | MWM_FUNC_CLOSE | MWM_FUNC_MINIMIZE | MWM_FUNC_MAXIMIZE | MWM_FUNC_RESIZE );
                                    hints->decorations|=MWM_DECOR_ALL;
                                }
/*                                else
                                {
                                    memset( &prop,0,sizeof( MWMHints ) );
                                    hints=(MWMHints*)&prop;
                                    hints->flags=( MWM_HINTS_FUNCTIONS | MWM_HINTS_DECORATIONS);
                                    hints->functions=( MWM_FUNC_MOVE | MWM_FUNC_CLOSE | MWM_FUNC_MINIMIZE | MWM_FUNC_MAXIMIZE | MWM_FUNC_RESIZE );
                                    hints->decorations=( MWM_DECOR_ALL );
                                } */
                                XChangeProperty( disp,win_pid_list[i],prop,prop,32,
                                        PropModeReplace,(const unsigned char*)&prop,5 );
                            }
                        }
                        if ( hints != (MWMHints*)&prop ) XFree( hints );
                        system("killall icon-wharf 2>/dev/null");
                        sprintf(submenue,"icon-wharf 0 &");
                        system(submenue);
                    }    
                    break;
                }
                if(ev.xbutton.button==4)
                {
                    list_windows(disp,skip);
                    cur_win=get_active_window(disp);
                    cur_win2=0;
                    if ((win_count>0) and (cur_win!=0) and (strstr(skip,get_window_class(disp, cur_win))!=NULL))
                    {
                        cur_win=win_pid_list[0];
                        cur_win2=get_active_window(disp);
                        init_window(cur_win2);
                        init_window(cur_win);
                        action_window(disp,cur_win,'a');
                    }
//                    printf("%d\n",win_count);
                    if (win_count==2)
                    {
                        if (Tiling_mode==0)
                        {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[0]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[1]);
//                                    printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[0]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[1]);
                                }            
                                Tiling_mode=1;
                            }    
                        } else if (Tiling_mode==1) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[2]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[3]);
//                                    printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[2]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[3]);
                                }            
                            }        
                            Tiling_mode=2;
                        } else if (Tiling_mode==2)    {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[4]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[5]);
//                                    printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[4]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[5]);
                                }            
                            }        
                            Tiling_mode=3;
                        } else if (Tiling_mode==3) {
                            if (cur_win!=0)
                            {
                                if (cur_win2==0)
                                {
                                    const char *p1="fullscreen", *p2="above";
                                    Atom prop1 = 0;
                                    Atom prop2 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                                    p_verbose("State 2: %s\n", tmp_prop2); 
                                    prop2 = XInternAtom(disp, tmp_prop2, False);
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                                }
                                else
                                {
                                    const char *p1="fullscreen";
                                    Atom prop1 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1,0, 0, 0);
                                }
                            }	    
                            Tiling_mode=0;
                        }
                    } 
                    if (win_count==3)
                    {
                        if (Tiling_mode==0)
                        {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                        if (win_pid_list[i]==cur_win) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[0]);
                                        else
                                        {
                                            if (is_5==0)
                                            {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy3[1]);
                                                is_5=1;
                                            } else
                                                window_move_resize(disp,win_pid_list[i],title_win_xy3[2]);
                                        }    
                                } else { 
                                        if (i==0) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[0]);
                                        if (i==1) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[1]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[2]);
                                }            
                            }
                            Tiling_mode=1;
                        } else if (Tiling_mode==1) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[3]);
                                    else
                                    {
                                        if (is_5==0)
                                        {
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[4]);
                                            is_5=1;
                                        } else
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[5]);
                                    }    
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[3]);
                                    if (i==1) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[4]);
                                    if (i==2) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[5]);
                                } 
                            }    
                            Tiling_mode=2;
                        } else if (Tiling_mode==2) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[6]);
                                    else
                                    {
                                        if (is_5==0)
                                        {
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[7]);
                                            is_5=1;
                                        } else
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[8]);
                                    }    
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[6]);
                                    if (i==1) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[7]);
                                    if (i==2) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[8]);
                                } 
                            }    
                            Tiling_mode=3;
                        } else {
                            if (cur_win!=0) 
                            {
                                if (cur_win2==0)
                                {
                                    const char *p1="fullscreen", *p2="above";
                                    Atom prop1 = 0;
                                    Atom prop2 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                                    p_verbose("State 2: %s\n", tmp_prop2); 
                                    prop2 = XInternAtom(disp, tmp_prop2, False);
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                                }
                                else
                                {
                                    const char *p1="fullscreen";
                                    Atom prop1 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1,0, 0, 0);
                                }
                            }	    
                            Tiling_mode=0;
                        }
                        break;
                    }    
                    if (win_count==4)
                    {
                        if (Tiling_mode==0)
                        {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                        if (win_pid_list[i]==cur_win) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[0]);
                                        else
                                        {
                                            if (is_5==0)
                                            {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[1]);
                                                is_5=1;
                                                is_6=0;
                                            } else if (is_6==0) {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[2]);
                                                is_6=1;
                                            } else {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[3]);
                                                is_5=0;
                                                is_6=0;
				            }
                                        }    
                                } else { 
                                        if (i==0) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[0]);
                                        if (i==1) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[1]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[2]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[3]);
                                }            
                            }
                            Tiling_mode=1;
                        } else if (Tiling_mode==1) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                        if (win_pid_list[i]==cur_win) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[4]);
                                        else
                                        {
                                            if (is_5==0)
                                            {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[5]);
                                                is_5=1;
                                                is_6=0;
                                            } else if (is_6==0) {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[6]);
                                                is_6=1;
                                            } else {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[7]);
                                                is_5=0;
                                                is_6=0;
				            }
                                        }    
                                } else { 
                                        if (i==0) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[4]);
                                        if (i==1) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[5]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[6]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[7]);
                                }            
                            }
                            Tiling_mode=2;
                        } else if (Tiling_mode==2) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                        if (win_pid_list[i]==cur_win) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[8]);
                                        else
                                        {
                                            if (is_5==0)
                                            {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[9]);
                                                is_5=1;
                                                is_6=0;
                                            } else if (is_6==0) {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[10]);
                                                is_6=1;
                                            } else {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[11]);
                                                is_5=0;
                                                is_6=0;
				            }
                                        }    
                                } else { 
                                        if (i==0) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[8]);
                                        if (i==1) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[9]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[10]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[11]);
                                }            
                            }
                            Tiling_mode=3;
                        } else {
                            if (cur_win!=0)
                            {
                                if (cur_win2==0)
                                {
                                    const char *p1="fullscreen", *p2="above";
                                    Atom prop1 = 0;
                                    Atom prop2 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                                    p_verbose("State 2: %s\n", tmp_prop2); 
                                    prop2 = XInternAtom(disp, tmp_prop2, False);
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                                }
                                else
                                {
                                    const char *p1="fullscreen";
                                    Atom prop1 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1,0, 0, 0);
                                }
                            }	    
                            Tiling_mode=0;
                        }
                        break;
                    }    
                    if (cur_win2!=0)
                    {
                        init_window(cur_win2);
                        action_window(disp,cur_win2,'a');
                    }
                }
                if(ev.xbutton.button==5)
                {
                    list_windows(disp,skip);
                    cur_win=get_active_window(disp);
                    cur_win2=0;
                    if ((win_count>0) and (cur_win!=0) and (strstr(skip,get_window_class(disp, cur_win))!=NULL))
                    {
                        cur_win=win_pid_list[0];
                        cur_win2=get_active_window(disp);
                        init_window(cur_win2);
                        init_window(cur_win);
                        action_window(disp,cur_win,'a');
                    }
                    if (win_count==2)
                    {
                        if (Tiling_mode==0)
                        {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[0]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[1]);
//                                    printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[0]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[1]);
                                }            
                                Tiling_mode=1;
                            }    
                        } else if (Tiling_mode==1) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[2]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[3]);
//                                    printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[2]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[3]);
                                }            
                            }        
                            Tiling_mode=2;
                        } else if (Tiling_mode==2)    {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[4]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[5]);
//                                    printf("%s %d \n",title_win_xy[0],win_pid_list[i]);
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[4]);
                                    else
                                        window_move_resize(disp,win_pid_list[i],title_win_xy2[5]);
                                }            
                            }        
                            Tiling_mode=3;
                        } else if (Tiling_mode==3) {
                            if (cur_win!=0)
                            {
                                if (cur_win2==0)
                                {
                                    const char *p1="fullscreen", *p2="above";
                                    Atom prop1 = 0;
                                    Atom prop2 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                                    p_verbose("State 2: %s\n", tmp_prop2); 
                                    prop2 = XInternAtom(disp, tmp_prop2, False);
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                                }
                                else
                                {
                                    const char *p1="fullscreen";
                                    Atom prop1 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1,0, 0, 0);
                                }
                            }	    
                            Tiling_mode=0;
                        }
                    } 
                    if (win_count==3)
                    {
                        if (Tiling_mode==0)
                        {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                        if (win_pid_list[i]==cur_win) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[0]);
                                        else
                                        {
                                            if (is_5==0)
                                            {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy3[1]);
                                                is_5=1;
                                            } else
                                                window_move_resize(disp,win_pid_list[i],title_win_xy3[2]);
                                        }    
                                } else { 
                                        if (i==0) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[0]);
                                        if (i==1) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[1]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[2]);
                                }            
                            }
                            Tiling_mode=1;
                        } else if (Tiling_mode==1) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[3]);
                                    else
                                    {
                                        if (is_5==0)
                                        {
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[4]);
                                            is_5=1;
                                        } else
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[5]);
                                    }    
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[3]);
                                    if (i==1) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[4]);
                                    if (i==2) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[5]);
                                } 
                            }    
                            Tiling_mode=2;
                        } else if (Tiling_mode==2) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                    if (win_pid_list[i]==cur_win) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[6]);
                                    else
                                    {
                                        if (is_5==0)
                                        {
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[7]);
                                            is_5=1;
                                        } else
                                            window_move_resize(disp,win_pid_list[i],title_win_xy3[8]);
                                    }    
                                } else { 
                                    if (i==0) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[6]);
                                    if (i==1) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[7]);
                                    if (i==2) 
                                        window_move_resize(disp,win_pid_list[i],title_win_xy3[8]);
                                } 
                            }    
                            Tiling_mode=3;
                        } else {
                            if (cur_win!=0) 
                            {
                                if (cur_win2==0)
                                {
                                    const char *p1="fullscreen", *p2="above";
                                    Atom prop1 = 0;
                                    Atom prop2 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                                    p_verbose("State 2: %s\n", tmp_prop2); 
                                    prop2 = XInternAtom(disp, tmp_prop2, False);
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                                }
                                else
                                {
                                    const char *p1="fullscreen";
                                    Atom prop1 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1,0, 0, 0);
                                }
                            }	    
                            Tiling_mode=0;
                        }
                    }    
                    if (win_count==4)
                    {
                        if (Tiling_mode==0)
                        {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                        if (win_pid_list[i]==cur_win) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[0]);
                                        else
                                        {
                                            if (is_5==0)
                                            {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[1]);
                                                is_5=1;
                                                is_6=0;
                                            } else if (is_6==0) {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[2]);
                                                is_6=1;
                                            } else {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[3]);
                                                is_5=0;
                                                is_6=0;
				            }
                                        }    
                                } else { 
                                        if (i==0) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[0]);
                                        if (i==1) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[1]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[2]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[3]);
                                }            
                            }
                            Tiling_mode=1;
                        } else if (Tiling_mode==1) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                        if (win_pid_list[i]==cur_win) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[4]);
                                        else
                                        {
                                            if (is_5==0)
                                            {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[5]);
                                                is_5=1;
                                                is_6=0;
                                            } else if (is_6==0) {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[6]);
                                                is_6=1;
                                            } else {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[7]);
                                                is_5=0;
                                                is_6=0;
				            }
                                        }    
                                } else { 
                                        if (i==0) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[4]);
                                        if (i==1) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[5]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[6]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[7]);
                                }            
                            }
                            Tiling_mode=2;
                        } else if (Tiling_mode==2) {
                            for (i=0;i<win_count;i++)
                            {
                                init_window(win_pid_list[i]);
                                if (cur_win!=0)
                                {
                                        if (win_pid_list[i]==cur_win) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[8]);
                                        else
                                        {
                                            if (is_5==0)
                                            {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[9]);
                                                is_5=1;
                                                is_6=0;
                                            } else if (is_6==0) {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[10]);
                                                is_6=1;
                                            } else {
                                                window_move_resize(disp,win_pid_list[i],title_win_xy4[11]);
                                                is_5=0;
                                                is_6=0;
				            }
                                        }    
                                } else { 
                                        if (i==0) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[8]);
                                        if (i==1) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[9]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[10]);
                                        if (i==2) 
                                            window_move_resize(disp,win_pid_list[i],title_win_xy4[11]);
                                }            
                            }
                            Tiling_mode=3;
                        } else {
                            if (cur_win!=0)
                            {
                                if (cur_win2==0)
                                {
                                    const char *p1="fullscreen", *p2="above";
                                    Atom prop1 = 0;
                                    Atom prop2 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop2 = g_strdup_printf("_NET_WM_STATE_%s", tmp2 = g_ascii_strup(p2, -1));
                                    p_verbose("State 2: %s\n", tmp_prop2); 
                                    prop2 = XInternAtom(disp, tmp_prop2, False);
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1, (unsigned long)prop2, 0, 0);
                                }
                                else
                                {
                                    const char *p1="fullscreen";
                                    Atom prop1 = 0;
                                    action = _NET_WM_STATE_ADD;
                                    tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
                                    p_verbose("State 1: %s\n", tmp_prop1); 
                                    prop1 = XInternAtom(disp, tmp_prop1, False);
                                    client_msg(disp, cur_win, "_NET_WM_STATE", 
                                        action, (unsigned long)prop1,0, 0, 0);
                                }
                            }	    
                            Tiling_mode=0;
                        }
                    }    
                    if (cur_win2!=0)
                    {
                        init_window(cur_win2);
                        action_window(disp,cur_win2,'a');
                    }
                }    
                break;
            }
        } else {
                //display 是由 XopenDisplay 返回的 Display *
            FD_ZERO(&rfds);
            FD_SET(xfd, &rfds);
            gettimeofday(&now, 0);
//LastTime 是 timeval 类型的变量,保存上次时间
//ticks 的单位是毫秒 millisecond
            ticks=(now.tv_sec-LastTime.tv_sec)*1000+(now.tv_usec-LastTime.tv_usec)/1000;
            if (ticks>=1000)
            {
                gettimeofday(&LastTime, 0);
                showwin3(screenX,screenY);
            }
//如果到期则调用有关函数
//select 等待 100 毫秒
            tm.tv_sec=0l;
            tm.tv_usec=200000l;
            select(xfd + 1, &rfds, 0, 0, &tm);
        } /* End else*/
    }
    imlib_context_set_image(buffer3);
    imlib_context_set_drawable(win3); 
    imlib_render_image_on_drawable(0, 0); 
    imlib_context_set_image(buffer3);
    imlib_context_set_font(font3);
    imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
    imlib_text_draw(5,2,text);
    imlib_free_font();
    /* set the buffer image as our current image */
    imlib_context_set_image(buffer3);
    imlib_render_image_on_drawable(0, 0); 
    imlib_context_set_image(buffer3);
    imlib_free_image();

    return 0;
}

