// g++ -o ./bin/icon-wharf ./src/icon-wharf.c  -lX11 -lImlib2 -lXmu `pkg-config --cflags --libs glib-2.0`
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <map>
#include <vector>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <X11/cursorfont.h>
#include <glib-2.0/glib.h>

using namespace std;

#include "Imlib2.h"
Display                        *disp;
Window                          win4;
Window                          win2;
Visual                         *vis;
Colormap                        cm;
int                             depth;
XSetWindowAttributes attr;
int mytoggle = 0;
char home[1024];
int mode=1;
int lowerraise;
int screenX;
int screenY;
int sizemain;
int gapmain;
int sizesub;
int gapsub;
int autohidemainbutton;
int autohideSubbutton;
FILE *freeNum;
int MouseMoveOpenSubIcon;
char usermenufile[1024];
char *run_mode;
int i=0;
char submenue[1024]=" ";
char skip[1024]=" ";
char tiling_skip[1024]="N/A";
char win_move[1024]="0,0,0,1280,1024";
char windows_where[1024]="0,0,0,1280,1024";
char no_bord_where[1024]="0,0,0,1280,1024";
int bord=-1;
char rcfile[10];
char font_path[1024];
int gc=0;
int gd=1;
char ch2[1024];
char buffer_rc[4096];
char picname[1024];
char back_pic[1280],mouse_pic[1280];
int n=0;
char rc_group[1024]="0";
int show_sys_inf=0;
int store=0;
double trans_icon=0.65;
double trans_wind=0.85;
int l_id=0;
int x, y;

Atom XA_TARGETS;
Atom XA_multiple;
Atom XA_image_bmp;
Atom XA_image_jpg;
Atom XA_image_tiff;
Atom XA_image_png;
Atom XA_text_uri_list;
Atom XA_text_uri;
Atom XA_text_plain;
Atom XA_text;

Atom XA_XdndSelection;
Atom XA_XdndAware;
Atom XA_XdndEnter;
Atom XA_XdndLeave;
Atom XA_XdndTypeList;
Atom XA_XdndPosition;
Atom XA_XdndActionCopy;
Atom XA_XdndStatus;
Atom XA_XdndDrop;
Atom XA_XdndFinished;

#include "./other_src/wm_ctrl.c"
#include "./other_src/icon.c"

#define UNAWARE 0
#define UNRECEPTIVE 1
#define CAN_DROP 2

//Utility function for getting the atom name as a string.
string GetAtomName(Display* disp, Atom a)
{
    if(a == None)
        return "None";
    else
        return XGetAtomName(disp, a);
}



//Construct a list of targets and place them in the specified property This
//consists of all datatypes we know of as well as TARGETS and MULTIPLE. Reading
//this property tell the application wishing to paste which datatypes we offer.
void set_targets_property(Display* disp, Window w, map<Atom, string>& typed_data, Atom property)
{

    vector<Atom> targets; targets.push_back(XA_TARGETS);
    targets.push_back(XA_multiple);


    for(map<Atom,string>::const_iterator i=typed_data.begin(); i != typed_data.end(); i++)
        targets.push_back(i->first);

        
    cout << "Offering: ";
    for(unsigned int i=0; i < targets.size(); i++)
        cout << GetAtomName(disp, targets[i]) << "  ";
    cout << endl;

    //Fill up this property with a list of targets.
    XChangeProperty(disp, w, property, XA_ATOM, 32, PropModeReplace, 
                    (unsigned char*)&targets[0], targets.size());
}



//This function essentially performs the paste operation: by converting the
//stored data in to a format acceptable to the destination and replying
//with an acknowledgement.
void process_selection_request(XEvent e, map<Atom, string>& typed_data)
{

    if(e.type != SelectionRequest)
        return;

    //Extract the relavent data
    Window owner     = e.xselectionrequest.owner;
    Atom selection   = e.xselectionrequest.selection;
    Atom target      = e.xselectionrequest.target;
    Atom property    = e.xselectionrequest.property;
    Window requestor = e.xselectionrequest.requestor;
    Time timestamp   = e.xselectionrequest.time;
    Display* disp    = e.xselection.display;

    cout << "A selection request has arrived!\n";
    cout << hex << "Owner = 0x" << owner << endl;
    cout << "Selection atom = " << GetAtomName(disp, selection) << endl;    
    cout << "Target atom    = " << GetAtomName(disp, target)    << endl;    
    cout << "Property atom  = " << GetAtomName(disp, property) << endl;    
    cout << hex << "Requestor = 0x" << requestor << dec << endl;
    cout << "Timestamp = " << timestamp << endl;
    

    //X should only send requests for the selections since we own.
    //since we own exaclty one, we don't need to check it.

    //Replies to the application requesting a pasting are XEvenst
    //sent via XSendEvent
    XEvent s;

    //Start by constructing a refusal request.
    s.xselection.type = SelectionNotify;
    //s.xselection.serial     - filled in by server
    //s.xselection.send_event - filled in by server
    //s.xselection.display    - filled in by server
    s.xselection.requestor = requestor;
    s.xselection.selection = selection;
    s.xselection.target    = target;
    s.xselection.property  = None;   //This means refusal
    s.xselection.time      = timestamp;



    if(target ==XA_TARGETS)
    {
        cout << "Replying with a target list.\n";
        set_targets_property(disp, requestor, typed_data, property);
        s.xselection.property = property;
    }
    else if(typed_data.count(target))
    {
        //We're asked to convert to one the formate we know about
        cout << "Replying with which ever data I have" << endl;

        //Fill up the property with the URI.
        s.xselection.property = property;
        XChangeProperty(disp, requestor, property, target, 8, PropModeReplace, 
                        reinterpret_cast<const unsigned char*>(typed_data[target].c_str()), typed_data[target].size());
    }
    else if(target == XA_multiple)
    {
        //In this case, the property has been filled up with a list
        //of atom pairs. The pairs being (target, property). The 
        //processing should continue as if whole bunch of
        //SelectionRequest events had been received with the 
        //targets and properties specified.

        //The ICCCM is rather ambiguous and confusing on this particular point,
        //and I've never encountered a program which requests this (I can't 
        //test it), so I haven't implemented it.

        cout << "MULTIPLE is not implemented. It should be, according to the ICCCM, but\n"
             << "I've never encountered it, so I can't test it.\n";
    }
    else
    {    
        //We've been asked to converto to something we don't know 
        //about.
        cout << "No valid conversion. Replying with refusal.\n";
    }
    
    //Reply
    XSendEvent(disp, e.xselectionrequest.requestor, True, 0, &s);
    cout << endl;
}


//Find the applications top level window under the mouse.
Window find_app_window(Display* disp, Window w)
{
    //Drill down the windows under the mouse, looking for
    //the window with the XdndAware property.

    int nprops, i=0;
    Atom* a;

    if(w == 0)
        return 0;

    //Search for the WM_STATE property
    a = XListProperties(disp, w, &nprops);
    for(i=0; i < nprops; i++)
        if(a[i] == XA_XdndAware)
            break;

    if(nprops)
        XFree(a);

    if(i != nprops)
        return w;
    
    //Drill down one more level.
    Window child, wtmp;
    int tmp;
    unsigned int utmp;
    XQueryPointer(disp, w, &wtmp, &child, &tmp, &tmp, &tmp, &tmp, &utmp);

    return find_app_window(disp, child);
}

void reset_icon(vector<icon> &icon_l,int modes)
{
    sprintf(rcfile,"wharf.rc");
    sprintf(usermenufile,"%s/.icon-DE/%s",home,rcfile);
    freeNum=fopen(usermenufile,"r");
    if ( freeNum==NULL)
    { 
        printf("error on open %s\n",usermenufile); 
        exit;
    }
    system("killall icon-dock 2>/dev/null");
    system("killall icon-clock 2>/dev/null");
    system("killall iconrun 2>/dev/null");
    sprintf(font_path,"%s/.icon-DE/fonts",home);
    imlib_add_path_to_font_path(font_path);
    imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
    imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");
    imlib_add_path_to_font_path(".");
    imlib_add_path_to_font_path("/share/feh/fonts");

    sprintf(back_pic,"%s/.icon-DE/pics/background.png",home);
    if (access(back_pic,0)==-1)
        sprintf(back_pic,"/usr/share/icon-DE/pics/background.png");
    back = imlib_load_image(back_pic);
    gd=1;
    gc=0;

    while ( ! feof(freeNum) )
    {
        fgets(buffer_rc,1024,freeNum);
        l_id=l_id+1;
        for (n=0;n<1024;n++)
            if (buffer_rc[n]=='\n') buffer_rc[n]='\0';
//        printf("%s\n",buffer_rc); 
        for (n=0;n<1024;n++)
          submenue[n]='\0';
        if (strcmp(buffer_rc,"")!=0 )
        {
            sprintf(ch2,"%c",buffer_rc[0]);
            if (strcmp(ch2,"#")!=0 ) 
            {
                if (check_rc(buffer_rc,"skip:")==0 )  get_str(skip,buffer_rc,"skip:");
                if (check_rc(buffer_rc,"tiling_skip:")==0 )  get_str(tiling_skip,buffer_rc,"tiling_skip:");
                if ((bord==-1) and (check_rc(buffer_rc,"have_title:")==0 ))  get_int(bord,buffer_rc,"have_title:");
                if (check_rc(buffer_rc,"trans_icon:")==0 )  get_double(trans_icon,buffer_rc,"trans_icon:");
                if (check_rc(buffer_rc,"trans_wind:")==0 )  get_double(trans_wind,buffer_rc,"trans_wind:");
                if (check_rc(buffer_rc,"show_sys_inf:")==0 )  get_int(show_sys_inf,buffer_rc,"show_sys_inf:");
                if (check_rc(buffer_rc,"windows_where:")==0 )  get_str(windows_where,buffer_rc,"windows_where:");
                if (check_rc(buffer_rc,"no_bord_where:")==0 ) get_str(no_bord_where,buffer_rc,"no_bord_where:");
                if ((check_rc(buffer_rc,"run:")==0 ) and (modes==0))
                {
                    get_str(ch2,buffer_rc,"run:");
                    system(ch2);
                }
                if (bord==0)
                    sprintf(win_move,"%s",windows_where);
                else
                    sprintf(win_move,"%s",no_bord_where);
                if ((check_rc(buffer_rc,"run:")==0 ) and (mode==0))
                {
                    get_str(submenue,buffer_rc,"run:");
                    system(submenue);
                }
                if (check_rc(buffer_rc,"baseconfig:")==0 )
                {
                    get_str(ch2,buffer_rc,"baseconfig:");
                    get_int2(screenX,ch2,1);
                    get_int2(screenY,ch2,2);
                    get_int2(sizemain,ch2,3);
                    get_int2(gapmain,ch2,4);
                    get_int2(sizesub,ch2,5);
                    get_int2(gapsub,ch2,6);
                    get_int2(lowerraise,ch2,7);
                    get_int2(autohidemainbutton,ch2,8);
                    get_int2(autohideSubbutton,ch2,9);
                    get_int2(MouseMoveOpenSubIcon,ch2,10);
                    mode=1;
                }
                if (check_rc(buffer_rc,"group")==0 )
                {
                    get_group(rc_group,ch2,buffer_rc,"group");
                    if (gc==0)
                    {
                        sprintf(icon_l[0].group,"%s",rc_group);
                        get_str2(picname,ch2,1);
                        icon_l[0].s_g=0;
                        if (icon_l[0].w_id!=0)
                            XDestroyWindow(disp,icon_l[0].w_id);
                        Creat_icon(screenX,screenY,sizemain,0,l_id,picname,lowerraise,trans_icon,autohidemainbutton,icon_l);
                        icon_filter(sizemain+15,sizemain+15,0,lowerraise,0,icon_l);
                    }
                    gc=gc+1;
                }
                else
                {
                    if (check_rc(buffer_rc,"single")==0 )
                    {
                        gc=gc+1;
                    } else {
                        if (check_rc(buffer_rc,"dock")==0 )
                        {
                            get_group(rc_group,ch2,buffer_rc,"dock");
                            if ((mode==0) or (mode==1))
                            {
                                sprintf(submenue,"icon-dock %d %d %d %d %d %d %s \"%s\" 0 &",screenX,screenY-gd*(sizemain+gapmain),sizemain,sizemain,lowerraise,autohideSubbutton,ch2,skip);
//                                printf("icon-dock %d %d %d %d %d %d %s \"%s\" 0 &\n",screenX,screenY-gd*(sizemain+gapmain),sizemain,sizemain,lowerraise,autohideSubbutton,ch2,skip);
                                system(submenue);
                                gd=gd+1;
                            }
//                            gd=gd+1;
                        }
                    }    
                }     
            } 
        }
    }
    fclose(freeNum);
    imlib_context_set_drawable(icon_l[0].w_id);
    store=0;
    x=sizemain+15;
    y=sizemain+15;
    sprintf(submenue,"icon-clock %d %d \"%s %s\" %d &",screenX+sizemain-20,screenY,skip,tiling_skip,bord);
//    printf("icon-clock %d %d \"%s %s\" %d &\n",screenX+sizemain-20,screenY,skip,tiling_skip,bord);
    system(submenue);
}

int main(int argc, char **argv)
{
//    XEvent                            ev;
    const char                 *display_name = getenv("DISPLAY");
    if (display_name == NULL)
        display_name = ":0";
    disp = XOpenDisplay(display_name);
    if (disp == NULL) 
    {
        fprintf(stderr, "Can't open display %s\n", display_name);
        return 1;
    }

    
    sprintf(home,"%s",getenv("HOME"));
    if ( strcmp(home,"") == 0 )
    {
        printf("fatal error: no /home/xxx found!\n");
        return 1;
    }

    XEvent                 ev;
    Imlib_Image            buffer,buffer4;
    Imlib_Font             font;
    char                  text[1024];
    Imlib_Color_Range      range;
    int screen=DefaultScreen(disp);
    char c_cmd[1024];
    Window a_win;
    FILE *fp=NULL;
    FILE *fp2=NULL;
    char basecfg[156];

    if (( argc == 1 )  or (argc>3))
    {
        mode=1;
    }
    if ( argc == 2 ) 
    {
        run_mode=argv[1];
        if (strcmp(run_mode,"INIT")==0 )
            mode=0;
        else if (strcmp(run_mode,"RESET")==0 )
            mode=1;
        else
        {
            bord=atoi(run_mode);
            mode=1;
        }
    }    
    if ( argc == 3 ) 
    {
        sscanf(argv[2], "%d", &bord);
    }    

    char f_buffer[4096];
    int i;
    

    sprintf(rcfile,"wharf.rc");
    sprintf(usermenufile,"%s/.icon-DE/%s",home,rcfile);
    if (access(usermenufile,0)==-1)
    {
        system("mkdir ~/.icon-DE");
        system("mkdir ~/.icon-DE/fonts");
        if (access("/usr/share/fonts/truetype/wqy/wqy-zenhei.ttc",0)!=-1)
            system("cp /usr/share/fonts/truetype/wqy/wqy-zenhei.ttc ~/.icon-DE/fonts/Vera.ttf");
        if (access("/usr/share/fonts/wenquanyi/wqy-zenhei/wqy-zenhei.ttc",0)!=-1)
            system("cp /usr/share/fonts/wenquanyi/wqy-zenhei/wqy-zenhei.ttc ~/.icon-DE/fonts/Vera.ttf");
        system("cp -a /usr/share/icon-DE/* ~/.icon-DE/");
        system("cp -a /etc/icon-de/* ~/.icon-DE/");
    }

    int c_red=255,c_green=200,c_blue=10,c_alpha=255;
    int f_red=0,f_green=0,f_blue=0,f_alpha=255;
    sprintf(usermenufile,"%s/.icon-DE/icon-de.rc",home);
    if (access(usermenufile,0)!=-1)
    {
        fp2=fopen(usermenufile,"r");
    }
    else if (access("usr/share/icon-DE/icon-de.rc",0)!=-1)
        fp2=fopen("usr/share/icon-DE/icon-de.rc","r");
    if (fp2==NULL)
    {
        printf("can't open ~/.icon-DE/icon-de.rc\n");
    }
    fgets(f_buffer,4096,fp2);
    for (i=0;i<4096;i++)
        if (f_buffer[i]=='\n') f_buffer[i]='\0';
    while ( ! feof(fp2) )
    {
        if (check_rc(f_buffer,"tag_color:")==0 )
        {
            get_str(ch2,f_buffer,"tag_color:");
            get_int2(c_red,ch2,1);
            get_int2(c_green,ch2,2);
            get_int2(c_blue,ch2,3);
            get_int2(c_alpha,ch2,4);
        }
        if (check_rc(f_buffer,"font_color:")==0 )
        {
            get_str(ch2,f_buffer,"font_color:");
            get_int2(f_red,ch2,1);
            get_int2(f_green,ch2,2);
            get_int2(f_blue,ch2,3);
            get_int2(f_alpha,ch2,4);
        }
        fgets(f_buffer,4096,fp2);
        for (i=0;i<4096;i++)
            if (f_buffer[i]=='\n') f_buffer[i]='\0';
    }
    fclose(fp2);

    sprintf(rcfile,"wharf.rc");
    sprintf(usermenufile,"%s/.icon-DE/%s",home,rcfile);
    freeNum=fopen(usermenufile,"r");
    if ( freeNum==NULL)
    { 
        printf("error on open %s\n",usermenufile); 
        exit(1); 
    }
    fclose(freeNum);
//    char ch;
    if (mode==0)
    {
        system("killall icon-dock 2>/dev/null");
        system("killall icon-clock 2>/dev/null");
        system("killall iconrun 2>/dev/null");
    }        
    if (mode==1)
    {
        system("killall icon-dock 2>/dev/null");
        system("killall iconrun 2>/dev/null");
    }
    vis = DefaultVisual(disp, DefaultScreen(disp));
    depth = DefaultDepth(disp, DefaultScreen(disp));
    cm = DefaultColormap(disp, DefaultScreen(disp));
                // text
    range = imlib_create_color_range();
    imlib_context_set_color_range(range);
    imlib_context_set_color(255, 255, 255, 255);
    imlib_add_color_to_color_range(0);
    /* add an orange color, semi-transparent 10 units from the first */
//    imlib_context_set_color(255, 200, 10, 255);
    imlib_context_set_color(c_red, c_green, c_blue, c_alpha);
    imlib_add_color_to_color_range(10);
    /* add black, fully transparent at the end 20 units away */
    imlib_context_set_color(70, 0, 0, 255);
    imlib_add_color_to_color_range(20);
    
    vector<icon> icon_list(1);

    imlib_context_set_display(disp);
    imlib_context_set_visual(vis);
    imlib_context_set_colormap(cm);
    imlib_context_set_dither(1);
    imlib_context_set_blend(0);
    imlib_context_set_color_modifier(NULL);

    sprintf(font_path,"%s/.icon-DE/fonts",home);
    imlib_add_path_to_font_path(font_path);
    imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
    imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");
    imlib_add_path_to_font_path(".");
    imlib_add_path_to_font_path("/share/feh/fonts");

    sprintf(back_pic,"%s/.icon-DE/pics/background.png",home);
    if (access(back_pic,0)==-1)
        sprintf(back_pic,"/usr/share/icon-DE/pics/background.png");
    back = imlib_load_image(back_pic);
    reset_icon(icon_list,mode);
    if (bord==0)
        sprintf(win_move,"%s",windows_where);
    else
        sprintf(win_move,"%s",no_bord_where);

    imlib_context_set_drawable(icon_list[0].w_id);
    int r_flash=1;

//    Atom selection  = XA_PRIMARY;
    XA_TARGETS = XInternAtom(disp, "TARGETS", False);
    XA_multiple = XInternAtom(disp, "MULTIPLE", False);
    XA_image_bmp = XInternAtom(disp, "image/bmp", False);
    XA_image_jpg = XInternAtom(disp, "image/jpeg", False);
    XA_image_tiff = XInternAtom(disp, "image/tiff", False);
    XA_image_png = XInternAtom(disp, "image/png", False);
    XA_text_uri_list = XInternAtom(disp, "text/uri-list", False);
    XA_text_uri= XInternAtom(disp, "text/uri", False);
    XA_text_plain = XInternAtom(disp, "text/plain", False);
    XA_text = XInternAtom(disp, "TEXT", False);
    XA_XdndSelection = XInternAtom(disp, "XdndSelection", False);
    XA_XdndAware = XInternAtom(disp, "XdndAware", False);
    XA_XdndEnter = XInternAtom(disp, "XdndEnter", False);
    XA_XdndLeave = XInternAtom(disp, "XdndLeave", False);
    XA_XdndTypeList = XInternAtom(disp, "XdndTypeList", False);
    XA_XdndPosition = XInternAtom(disp, "XdndPosition", False);
    XA_XdndActionCopy = XInternAtom(disp, "XdndActionCopy", False);
    XA_XdndStatus = XInternAtom(disp, "XdndStatus", False);
    XA_XdndDrop = XInternAtom(disp, "XdndDrop", False);
    XA_XdndFinished = XInternAtom(disp, "XdndFinished", False);
    map<Atom, string> typed_data; string url;
    
    url = "file://" + url;

    typed_data[XA_text_uri_list] = url;
    typed_data[XA_text_uri] = url;
    typed_data[XA_text_plain] = url;
    typed_data[XA_text] = url;
    typed_data[XA_STRING] = url;
    set_targets_property(disp, icon_list[0].w_id, typed_data, XA_XdndTypeList);

    XFlush(disp);
    
    bool dragging=0,m_mouse=0;                   //Are we currently dragging
    Window previous_window=0;          //Window found by the last MotionNotify event.
    int previous_version = -1;         //XDnD version of previous_window
    int status=UNAWARE;               
    Window root=RootWindow(disp, screen);
    int have_press=0;
    int have_release=0;
    int m_button=0;
    int have_win2=0;

    int xfd = ConnectionNumber(disp);
    long ticks;
    fd_set rfds;
//    time_t now_time;
    struct timeval now, tm,LastTime;
//    now_time=time(0);
    Cursor grab_bad =XCreateFontCursor(disp, XC_gobbler);
    Cursor grab_maybe =XCreateFontCursor(disp, XC_circle);
    Cursor grab_good =XCreateFontCursor(disp, XC_sb_down_arrow);

    while (1)
    {
        if (XPending(disp))
        {
            XNextEvent(disp, &ev);
            switch (ev.type)
            {
            case SelectionClear:
//                cout  << "SelectionClear event received. Quitting.\n";
                break;
            case SelectionRequest:
                process_selection_request(ev, typed_data);
                break;
            case MotionNotify:
                r_flash=1;
                x = ev.xmotion.x;
                y = ev.xmotion.y;
                if (dragging == 1)
                {
                    Window window=0;
                    int version=-1;
                    window = find_app_window(disp, root);
                    if(window == previous_window)
                        version = previous_version;
                    if(status == UNAWARE && version != -1)
                        status = UNRECEPTIVE;
                    else if(version == -1)
                        status = UNAWARE;
                    //Update the pointer state.
                    if(status == UNAWARE)
                        XChangeActivePointerGrab(disp, Button1MotionMask | ButtonReleaseMask, grab_bad, CurrentTime);
                    else if(status == UNRECEPTIVE)
                        XChangeActivePointerGrab(disp, Button1MotionMask | ButtonReleaseMask, grab_maybe, CurrentTime);
                    else
                        XChangeActivePointerGrab(disp, Button1MotionMask | ButtonReleaseMask, grab_good, CurrentTime);
                    if(window != previous_window && previous_version != -1)
                    {
                        XClientMessageEvent m;
                        memset(&m, sizeof(m), 0);
                        m.type = ClientMessage;
                        m.display = ev.xclient.display;
                        m.window = previous_window;
                        m.message_type = XA_XdndLeave;
                        m.format=32;
                        m.data.l[0] = icon_list[0].w_id;
                        m.data.l[1] = 0;
                        m.data.l[2] = 0;
                        m.data.l[3] = 0;
                        m.data.l[4] = 0;
                        XSendEvent(disp, previous_window, False, NoEventMask, (XEvent*)&m);
                        XFlush(disp);
                    }

                    if(window != previous_window && version != -1)
                    {    
                        map<Atom, string>::const_iterator i = typed_data.begin();
                        XClientMessageEvent m;
                        memset(&m, sizeof(m), 0);
                        m.type = ClientMessage;
                        m.display = ev.xclient.display;
                        m.window = window;
                        m.message_type = XA_XdndEnter;
                        m.format=32;
                        m.data.l[0] = icon_list[0].w_id;
                        m.data.l[1] = min(5, version) << 24  |  (typed_data.size() > 3);
                        m.data.l[2] = typed_data.size() > 0 ? i++->first : 0;
                        m.data.l[3] = typed_data.size() > 1 ? i++->first : 0;
                        m.data.l[4] = typed_data.size() > 2 ? i->first : 0;
                        XSendEvent(disp, window, False, NoEventMask, (XEvent*)&m);
                        XFlush(disp);
                    }
                    if(version != -1)
                    {
                        int x, y, tmp;
                        unsigned int utmp;
                        Window wtmp;
                        XQueryPointer(disp, window, &wtmp, &wtmp, &tmp, &tmp, &x, &y, &utmp);
                        XClientMessageEvent m;
                        memset(&m, sizeof(m), 0);
                        m.type = ClientMessage;
                        m.display = ev.xclient.display;
                        m.window = window;
                        m.message_type = XA_XdndPosition;
                        m.format=32;
                        m.data.l[0] = icon_list[0].w_id;
                        m.data.l[1] = 0;
                        m.data.l[2] = (x <<16) | y;
                        m.data.l[3] = CurrentTime; //Our data is not time dependent, so send a generic timestamp;
                        m.data.l[4] = XA_XdndActionCopy;
                        XSendEvent(disp, window, False, NoEventMask, (XEvent*)&m);
                        XFlush(disp);
                    }
                    previous_window = window;    
                    previous_version = version;
//                    cout << endl;
                    Window        QueryRoot, QueryChild;
                    int           AbsoluteX, AbsoluteY;
                    int           RelativeX, RelativeY;
                    unsigned int    ModKeyMask;
                    
                    XQueryPointer(disp, root,
                        &QueryRoot, &QueryChild,
                        &AbsoluteX, &AbsoluteY,
                        &RelativeX, &RelativeY,
                        &ModKeyMask);
                    XMoveWindow(disp,icon_list[0].w_id,AbsoluteX-20 , AbsoluteY-20);
                    char fs[10];
                    if (AbsoluteX<=5)
                    {
                        screenX=0;
                        screenY=AbsoluteY;
                        sprintf(fs,"1 2 2 2");
                        lowerraise=1;
                        autohidemainbutton=2;
                        autohideSubbutton=2;
                        MouseMoveOpenSubIcon=1;
                    }
                    else if (AbsoluteX<sizemain)
                    {
                        screenX=AbsoluteX-(int)(sizemain/3);
                        screenY=AbsoluteY;
                        sprintf(fs,"1 1 2 1");
                        lowerraise=1;
                        autohidemainbutton=2;
                        autohideSubbutton=2;
                        MouseMoveOpenSubIcon=2;
                    }
                    else
                    {
                        screenX=AbsoluteX;
                        screenY=AbsoluteY;
                        sprintf(fs,"1 0 0 0");
                        lowerraise=1;
                        autohidemainbutton=0;
                        autohideSubbutton=0;
                        MouseMoveOpenSubIcon=0;
                    }
                    sprintf(basecfg,"baseconfig:%d %d %d 0 %d 0 %s\n",screenX,screenY,sizemain,sizemain,fs);
                    
                }
                break;
            case ButtonPress:
                r_flash=1;
                x = ev.xmotion.x;
                y = ev.xmotion.y;
                if(ev.xbutton.button==1)
                {
                    gettimeofday(&LastTime, 0);
                    have_press=1;
                    have_release=0;
                    dragging=0;
                }
                break;
            case ButtonRelease:
                r_flash=1;
                x = ev.xmotion.x;
                y = ev.xmotion.y;
                if(ev.xbutton.button==1)
                {
                    have_release=1;
                    have_press=0;
                    if (dragging==1)
                    {
//                      cout << "Mouse button was released.\n";


                        if(status == CAN_DROP)
                        {
//                          cout << "Perform drop:\n";

                            XClientMessageEvent m;
                            memset(&m, sizeof(m), 0);
                            m.type = ClientMessage;
                            m.display = ev.xclient.display;
                            m.window = previous_window;
                            m.message_type = XA_XdndDrop;
                            m.format=32;
                            m.data.l[0] = icon_list[0].w_id;
                            m.data.l[1] = 0;
                            m.data.l[2] = CurrentTime; //Our data is not time dependent, so send a generic timestamp;
                            m.data.l[3] = 0;
                            m.data.l[4] = 0;

                            XSendEvent(disp, previous_window, False, NoEventMask, (XEvent*)&m);
                            XFlush(disp);
                        }
                        XUngrabPointer(disp, CurrentTime);
                        dragging=0;
                        status=UNAWARE;
                        previous_window=None;
                        previous_version=-1;
                        cout << endl;
                        sprintf(submenue,"%s/.icon-DE/wharf.rc",home);
                        if (access(submenue,0)!=-1)
                        {
                            
                            sprintf(c_cmd,"cp -f %s %s~",submenue,submenue);
                            system(c_cmd);
                            sprintf(submenue,"%s/.icon-DE/wharf.rc~",home);
                            fp=fopen(submenue,"r");
                            if (fp==NULL)
                            {
                                printf("not open 1\n");
                            }
                            else
                            {
                                sprintf(submenue,"%s/.icon-DE/wharf.rc",home);
                                fp2=fopen(submenue,"w");
                                fgets(buffer_rc,4096,fp);
                                while ( ! feof(fp) )
                                {
								    if (check_rc(buffer_rc,"baseconfig:")==0 )
								        fputs(basecfg,fp2);
								    else
								        fputs(buffer_rc,fp2);
                                    fgets(buffer_rc,4096,fp);
								}
                            }
                            fclose(fp);
                            fclose(fp2);
                        }
                        XDestroyWindow(disp,win4);    
                        reset_icon(icon_list,1);
                    }
                    else if ( m_mouse == 0 )
                    {
                        if (MouseMoveOpenSubIcon==0)
                        {
                            if (store==1)
                            {
                                system("killall iconrun 2>/dev/null");    
                                store=0;
                                break;
                            } else {
                                sprintf(submenue,"iconrun %d&",bord);
                                system(submenue);
                                store=1;
                            }
                        }
                        else if (MouseMoveOpenSubIcon==2)
                        {
                            system("killall iconrun 2>/dev/null");    
                            sprintf(submenue,"iconrun %d&",bord);
                            system(submenue);
                            store=1;
                        }
                    }
                    else
                    {
                        if ((x>=100) and (x<=138) and (y>=96) and (y<=130))
                        {
                            imlib_context_set_drawable(win4);
                            imlib_context_set_image(buffer4);
                            imlib_render_image_on_drawable(0, 0);
                            imlib_free_image();
                            XDestroyWindow(disp,win4);
                            XSync(disp, False);
                            XFlush(disp); 
                            imlib_context_set_image(icon_list[0].im_bg);
                            imlib_context_set_drawable(icon_list[0].w_id);
                            m_button=0;
                            m_mouse=0;
                        }
                        if ((x>=54) and (x<=90) and (y>=8) and (y<=43))
                            m_button=4;
                        if ((x>=54) and (x<=90) and (y>=53) and (y<=86))
                            m_button=2;
                        if ((x>=54) and (x<=90) and (y>=96) and (y<=129))
                            m_button=5;
                        if ((x>=100) and (x<=138) and (y>=8) and (y<=86))
                            m_button=3;
                    }
                }
                if ((ev.xbutton.button==2) or (m_button==2))
                {
                    if (get_active_window(disp)!=0)
                        close_window(disp,get_active_window(disp));
                    break;
                }
                if ((ev.xbutton.button==3) or (m_button==3))
                {
                                                /* if we click anywhere in the window, exit */
                    reset_icon(icon_list,1);
                    break;
                }
                if ((ev.xbutton.button==4) or (m_button==4))
                {
                    if (list_windows(disp,skip)!=EXIT_FAILURE)
                    {
                        if (get_active_window(disp)==0)
                        {
                            if (win_pid_list[0]!=0)    
                                action_window(disp,win_pid_list[0],'a');
                            break;    
                        }    else    {
                            act_win_pid=get_active_window(disp);
                            for (i=0;i<500;i++)
                            {
                                if (win_pid_list[i]==act_win_pid)
                                {
//                                    printf("%d %d \n",win_count,i);
                                    if (i<win_count-1)
                                    {
                                        if (win_pid_list[i+1]!=0)
                                            action_window(disp,win_pid_list[i+1],'a');
                                    } else    {
                                        if (win_pid_list[0]!=0)
                                            action_window(disp,win_pid_list[0],'a');
                                    }        
                                    break;    
                                }
                            }
                        }
                    }    
                    break;
                }    
                if ((ev.xbutton.button==5) or (m_button==5))
                {
                    if (list_windows(disp,skip)!=EXIT_FAILURE)
                    {
                        if (get_active_window(disp)==0)
                        {
                            if (win_pid_list[0]!=0)    
                                action_window(disp,win_pid_list[0],'a');
                            break;    
                        }    else    {
                            act_win_pid=get_active_window(disp);
                            for (i=0;i<500;i++)
                            {
                                if (win_pid_list[i]==act_win_pid)
                                {
//                                    printf("%d %d \n",win_count,i);
                                    if (i>0) {
                                        if (win_pid_list[i-1]!=0)
                                            action_window(disp,win_pid_list[i-1],'a');
                                    } else    {
                                        if (win_pid_list[win_count-1]!=0)
                                            action_window(disp,win_pid_list[win_count-1],'a');
                                    }        
                                    break;    
                                }
                            }
                        }
                    }    
                    break;
                }    
                break;
            case ClientMessage:
                if (ev.xclient.message_type == XA_XdndStatus)
                {
                cout  << "XDnDStatus event received:" << endl
                      << "    Target window           = 0x" << hex << ev.xclient.data.l[0] << dec << endl
                      << "    Will accept             = " << (ev.xclient.data.l[1] & 1)  << endl
                      << "    No rectangle of silence = " << (ev.xclient.data.l[1] & 2)  << endl
                      << "    Rectangle of silence x  = " << (ev.xclient.data.l[2] >> 16)    << endl
                      << "    Rectangle of silence y  = " << (ev.xclient.data.l[2] & 0xffff)    << endl
                      << "    Rectangle of silence w  = " << (ev.xclient.data.l[3] >> 16)    << endl
                      << "    Rectangle of silence h  = " << (ev.xclient.data.l[3] & 0xffff)    << endl
                      << "    Action                  = " << GetAtomName(disp, ev.xclient.data.l[4]) << endl;

                
                if( (ev.xclient.data.l[1] & 1) == 0 &&  ev.xclient.data.l[4] != None)
                {
                    cout << "Action is given, even though the target won't accept a drop.\n";
                }


                if(dragging)
                {
                    if((ev.xclient.data.l[1]&1) && status != UNAWARE)
                        status = CAN_DROP;

                    if(!(ev.xclient.data.l[1]&1) && status != UNAWARE)
                        status = UNRECEPTIVE;
                }

                if(!dragging)
                    cout << "Message received, but dragging is not active!\n";

                if(status == UNAWARE)
                    cout << "Message received, but we're not in an aware window!\n";

                cout << endl;
                }
                else if( ev.xclient.message_type == XA_XdndFinished)
                {
                    //Check for these messages. Since out data is static, we don't need to do anything.
                    cout  << "XDnDFinished event received:" << endl
                          << "    Target window           = 0x" << hex << ev.xclient.data.l[0] << dec << endl
                          << "    Was successful          = " << (ev.xclient.data.l[1] & 1)  << endl
                          << "    Action                  = " << GetAtomName(disp, ev.xclient.data.l[2]) << endl;
                    
                    cout  << "No action performed.\n\n";
                }
                
                break;
            case EnterNotify:
                r_flash=1;
                x = ev.xmotion.x;
                y = ev.xmotion.y;
                if ((dragging == 0) and (m_mouse==0))
                {
                    if(lowerraise==0)
                         XLowerWindow(disp,icon_list[0].w_id);
                    if ((lowerraise==1) or (lowerraise==2))
                         XRaiseWindow(disp,icon_list[0].w_id);
                    if (show_sys_inf==1)
                    {
                        mytoggle = 1;
                        buffer = imlib_create_image(500, 220);    
                        font = imlib_load_font("Vera/10");
                        if (font == NULL)
                            font = imlib_load_font("wqy-zenhei.ttc/10");
                        imlib_context_set_font(font);
                        imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
                        win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX+sizemain+4,screenY,500,220,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
                        XRaiseWindow(disp,win2);
                        XMapWindow(disp, win2);
                        imlib_context_set_drawable(win2); 
//                        imlib_context_set_image(buffer);
                        imlib_context_set_image(buffer);
                        imlib_image_fill_color_range_rectangle(0,0, 1000, 440,-5.0);
//                        imlib_free_color_range();
                        imlib_context_set_image(buffer);
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_image(buffer);
                        imlib_context_set_font(font);
                        imlib_context_set_color(f_red, f_green, f_blue, f_alpha);

                        time_t now_time;
                        now_time=time(0);
                        strftime(text, sizeof(text), "%Y年%m月%d日 星期(%w)",localtime(&now_time) );
                        imlib_text_draw(60,2,text);
                        if (list_windows(disp,skip)!=EXIT_FAILURE)
                            sprintf(text," 有（ %ld ）个打开的窗口",win_count);
                        imlib_text_draw(240,2,text);
                        imlib_context_set_font(font);
                        imlib_free_font();
                        font = imlib_load_font("Vera/9");
                        if (font == NULL)
                            font = imlib_load_font("wqy-zenhei.ttc/9");
                        imlib_context_set_font(font);
                        sprintf(back_pic,"top -b -n1 >%s/top.txt",home);
                        system(back_pic);
                        sprintf(back_pic,"%s/top.txt",home);
                        freeNum=fopen(back_pic,"r");
                        if ( freeNum==NULL)
                            printf("error on open top.txt\n"); 
                        fgets(text,1024,freeNum);
                        i=1;
                        while (! feof(freeNum))
                        {
                            if (i<8)    
                            {
                                ReplaceStr(text,"top -","时间：");
                                ReplaceStr(text,"up ",", 已开机：");
                                ReplaceStr(text," users"," 个用户");
                                ReplaceStr(text," user"," 个用户");
                                ReplaceStr(text,"load average:","系统负载：");
                                ReplaceStr(text,"Tasks:","进程：");
                                ReplaceStr(text,"total","总数中");
                                ReplaceStr(text,"running","个正运行");
                                ReplaceStr(text,"sleeping","个在休眠");
                                ReplaceStr(text,"stopped","个已停止");
                                ReplaceStr(text,"zombie","个已僵死");
                                ReplaceStr(text,"Mem:","内存：");
                                ReplaceStr(text,"total","总数中");
                                ReplaceStr(text,"used","已使用");
                                ReplaceStr(text,"free","空闲");
                                ReplaceStr(text,"buffers","缓冲");
                                ReplaceStr(text,"Swap:","交换内存：");
                                ReplaceStr(text,"cached","缓存");
                                ReplaceStr(text,"us"," 用户");
                                ReplaceStr(text,"sy"," 系统");
                                ReplaceStr(text,"id"," 空闲");
                                ReplaceStr(text,"wa"," 等待");
                                ReplaceStr(text,"ni"," 优先");
                                ReplaceStr(text,",    0.0%hi","");
                                ReplaceStr(text,",    0.0%si","");
                                ReplaceStr(text,",    0.0%st","");
                            }
                            imlib_text_draw(5,i*15+8,text);
                            i=i+1;
                            fgets(text,1024,freeNum);
                            
                        } 
                        imlib_context_set_image(buffer);
                        imlib_context_set_drawable(win2); 
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_image(buffer);
                        imlib_free_image();
                        imlib_context_set_font(font);
                        imlib_free_font();
                        imlib_context_set_image(icon_list[0].im_bg);
                        imlib_context_set_drawable(icon_list[0].w_id);
                        
                        fclose(freeNum); 
                        have_win2=1;
                    }    

                    XMoveWindow(disp,icon_list[0].w_id,screenX , screenY);
                    if ((store==0) and (MouseMoveOpenSubIcon==2))
                    {
                        sprintf(submenue,"iconrun %d &",bord);
                        system(submenue);
                        store=1;
                    }
                    if (MouseMoveOpenSubIcon==1)
                    {
                        system("killall iconrun 2>/dev/null");
                        sprintf(submenue,"iconrun %d &",bord);
                        system(submenue);
                    }
                }
                break; 
            case LeaveNotify:        
                r_flash=1;
                x = sizemain+15;
                y = sizemain+15;
                if (list_windows(disp,skip)!=EXIT_FAILURE)
                {
                    if (win_count>0)
                    {
                        a_win= get_active_window(disp);
                        if ( a_win!=0 )
                        {
                            if (strstr(tiling_skip,get_window_class(disp,a_win))==NULL)
                            {
                                init_window(a_win);
                                window_move_resize(disp,a_win,win_move);
                            }
                        }
                    }
                }
                if (have_win2==1)
                {
                    mytoggle = 0;
                    XDestroyWindow(disp,win2);    
                    have_win2=0;
                }    
                if(autohidemainbutton==1)
                    XMoveWindow(disp,icon_list[0].w_id,2 , screenY);
                if(autohidemainbutton==2)
                    XMoveWindow(disp,icon_list[0].w_id,-sizemain/2 , screenY);
                break; 
            case Expose:
                break;
            default:
                break;
            }
        } 
         else {
        //display 是由 XopenDisplay 返回的 Display *
            FD_ZERO(&rfds);
            FD_SET(xfd, &rfds);
            gettimeofday(&now, 0);
//LastTime 是 timeval 类型的变量,保存上次时间
//ticks 的单位是毫秒 millisecond
            ticks=(now.tv_sec-LastTime.tv_sec)*1000+(now.tv_usec-LastTime.tv_usec)/1000;
            if (ticks>=3000) 
            {
                if ((have_press==1) and (have_release==0))
                {
                    if(XGrabPointer(disp, icon_list[0].w_id, True, Button1MotionMask | ButtonReleaseMask, GrabModeAsync, GrabModeAsync, root, grab_good, CurrentTime) == GrabSuccess)
                    {
                        dragging=1;
                        printf("dragging\n");
                        XSetSelectionOwner(disp, XA_XdndSelection, icon_list[0].w_id, CurrentTime);
                        m_mouse=0;
                        m_button=0;
                    }
                    else
                        dragging=0;
                    gettimeofday(&LastTime, 0);
                }
            } else if (ticks>=800)
            {
                if ((have_press==1) and (dragging!=1) and (have_release==0) and (m_mouse==0))
                {
                    win4=XCreateWindow(disp,DefaultRootWindow(disp),screenX+sizemain,screenY+sizemain,153,193,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
                    XSelectInput(disp, win4, ButtonPressMask | ButtonReleaseMask );
                    XMapWindow(disp, win4);
                    imlib_context_set_drawable(win4); 
                    sprintf(mouse_pic,"%s/.icon-DE/iconcache/mouse.png",home);
                    if (access(mouse_pic,0)==-1)
                    {
                        system("cp /usr/share/icon-DE/iconcache/mouse.png ~/.icon-DE/iconcache/mouse.png");
                        sprintf(mouse_pic,"/usr/share/icon-DE/iconcache/mouse.png");
                    }
                    buffer4 = imlib_load_image(mouse_pic);
                    imlib_context_set_image(buffer4);
                    imlib_render_image_on_drawable(0, 0);
                    m_mouse=1;
                    imlib_context_set_image(icon_list[0].im_bg);
                    imlib_context_set_drawable(icon_list[0].w_id);
                }
            }
//如果到期则调用有关函数
//select 等待 100 毫秒
            if (r_flash==1)
            {
                r_flash=0;
                if (m_mouse==1)
                {
                    imlib_context_set_drawable(win4); 
                    imlib_context_set_image(buffer4);
                    imlib_render_image_on_drawable(0, 0);
                    imlib_context_set_image(back);
                    imlib_context_set_drawable(icon_list[0].w_id); 
                }
                icon_filter(x,y,0,lowerraise,mytoggle,icon_list);
            }
            tm.tv_sec=0l;
            tm.tv_usec=200000l;
            select(xfd + 1, &rfds, 0, 0, &tm);
        } /* End else*/
    }
    return 0;

}

