// g++ -o ./icon-wmcl ./icon-wmcl.c    -lImlib2 -lX11 -lXmu `pkg-config --cflags --libs glib-2.0`
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <X11/Xlib.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/cursorfont.h>
#include <X11/Xmu/WinUtil.h>
#include <glib-2.0/glib.h>

//#include "Imlib2.h"

Display                        *disp;
Window                            win;
Visual                         *vis;
Colormap                        cm;
int                                 depth;
XSetWindowAttributes attr;
char *appToRun;
int i3;


#define MWM_HINTS_FUNCTIONS       (1L << 0) /* wheter the functions member of the struct schould be listened to */
#define MWM_HINTS_DECORATIONS     (1L << 1) /* same for decorations member */

#define MWM_FUNC_ALL              (1L << 0) /* means as much as we schould reversely interpret all other bits */
#define MWM_FUNC_RESIZE           (1L << 1) /* self explanatory */
#define MWM_FUNC_MOVE             (1L << 2)
#define MWM_FUNC_MINIMIZE         (1L << 3)
#define MWM_FUNC_MAXIMIZE         (1L << 4)
#define MWM_FUNC_CLOSE            (1L << 5)

#define MWM_DECOR_ALL             (1L << 0) /* equivalent of MWM_HINTS_FUNCTIONS */
#define MWM_DECOR_BORDER          (1L << 1) /* show border */
#define MWM_DECOR_RESIZEH         (1L << 2) /* show resize handle */
#define MWM_DECOR_TITLE           (1L << 3) /* show title bar */
#define MWM_DECOR_MENU            (1L << 4) /* wich buttons to show */
#define MWM_DECOR_MINIMIZE        (1L << 5)
#define MWM_DECOR_MAXIMIZE        (1L << 6)
#define PROP_MWM_HINTS_ELEMENTS 5
typedef struct _mwmhints {
                                uint32_t flags;
                                uint32_t functions;
                                uint32_t decorations;
                                int32_t  input_mode;
                                uint32_t status;
                } MWMHints;

#include "./other_src/wm_ctrl.c"

int main(int argc, char **argv)
{
    int                                 x, y;
    XEvent                            ev;
    const char                 *display_name = getenv("DISPLAY");
//    Imlib_Image                 buffer;
    char                                *skip;
    if (display_name == NULL)
        display_name = ":0";
    disp = XOpenDisplay(display_name);
    if (disp == NULL)
    {
        fprintf(stderr, "Can't open display %s\n", display_name);
        return 1;
    }

    int xl=0;
    int yl=0;
    char *title;
    int w_chg=0;
    char home[1024];
    sprintf(home,"%s",getenv("HOME"));
    int bord=1;
    if ( strcmp(home,"") == 0 )
    {
        printf("fatal error: no /home/xxx found!\n");
        return 1;
    }
//----arguments x y width height lower/raise(0/1) picture hidemode
    if ( argc != 3 )
    {
        printf("usage: title skip \n");
        return 1;
    }
    title=argv[1];
    skip=argv[2];
    
//    screenWidth=2;
//    screenHeight=2;
    vis = DefaultVisual(disp, DefaultScreen(disp));
    depth = DefaultDepth(disp, DefaultScreen(disp));
    cm = DefaultColormap(disp, DefaultScreen(disp));
                // text
    attr.override_redirect=True;
 //win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
    win=XCreateWindow(disp,DefaultRootWindow(disp),-10,-10,5,5,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
//     win =    XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0, 0, 100, 100, 0, 0, 0);
    XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
    XMapWindow(disp, win);

    XRaiseWindow(disp,win);

//--
//    w=screenWidth;
//    h=screenHeight;

    XResizeWindow(disp, win, 5, 5);
    XSync(disp, False);
    int i=1;
    i3=1;
//    Window cur_win=0;
//    Window                            cur_win_id;
    int xfd = ConnectionNumber(disp);
    fd_set rfds;
    long ticks;
//                        MWMHints mwmhints;
//                        Atom prop;

    sleep(20);

//    time_t now_time;
    struct timeval now, tm,LastTime;
//    now_time=time(0);
    gettimeofday(&LastTime, 0);
    
    int cg=1;

//    printf("ok\n");
    if (bord==1)
    {
    } else {
	
    }
    list_windows(disp,skip);
    while (1)
    {
        w_chg=1;
        if (XPending(disp))
        {
            XNextEvent(disp, &ev);
            switch (ev.type)
            {
            case Expose:
                break;
            case MotionNotify:
                x = ev.xmotion.x;
                y = ev.xmotion.y;
            default:
                break;
            case EnterNotify:		
                break;
            case LeaveNotify:		
                break;
            case ButtonPress:				
                if(ev.xbutton.button==1)
                {
                    break;
                }
            }    
        } else {
                //display 是由 XopenDisplay 返回的 Display *
                //w_chg=0;
            if (cg==0)
            {
                system("killall -9 Xephyr    2>/dev/null");
                system("kill -9 -1    2>/dev/null");
                sleep(10);
                return 1;
            }    
            FD_ZERO(&rfds);
            FD_SET(xfd, &rfds);
            gettimeofday(&now, 0);
//LastTime 是 timeval 类型的变量,保存上次时间
//ticks 的单位是毫秒 millisecond
            ticks=(now.tv_sec-LastTime.tv_sec)*1000+(now.tv_usec-LastTime.tv_usec)/1000;
            if (ticks>=2000)
            {
                cg=0;
                list_windows(disp,skip);
                gettimeofday(&LastTime, 0);
                for (i=0;i<win_count;i++)
                {
                    if (win_pid_list[i]!=0)
                    if (strstr(get_window_title(disp,win_pid_list[i]),title)!=NULL)
                         cg=1;
                }
            }
//如果到期则调用有关函数
//select 等待 100 毫秒
            tm.tv_sec=0l;
            tm.tv_usec=100000l;
            select(xfd + 1, &rfds, 0, 0, &tm);
        } /* End else*/
    }
    return 0;
}

