//g++ -o ./bin/icon-wmvm ./src/icon-wmvm.c -lX11    `pkg-config --cflags --libs glib-2.0` -lImlib2 -lX11 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <glib-2.0/glib.h>
#include <grp.h>
#include <pwd.h>


Visual                         *vis;
Colormap                       cm;
int                            depth;
XSetWindowAttributes           attr;
static gboolean               envir_utf8; //2012.04.18

#include "./other_src/button.c"
#define random(x) (rand()%x)  

static void window_set_title (Display *disp, Window win, /* {{{ */
                const char *title,const char mode) {
        gchar *title_utf8;
        gchar *title_local;

        if (envir_utf8) {
                title_utf8 = (gchar*)g_strdup(title);
                title_local = NULL;
        }
        else {
                if (! (title_utf8 = (gchar*)g_locale_to_utf8(title, -1, NULL, NULL, NULL))) {
                        title_utf8 = (gchar*)g_strdup(title);
                }
                title_local = g_strdup(title);
        }
        
        if (mode == 'T' || mode == 'N') {
                /* set name */
                if (title_local) {
                        XChangeProperty(disp, win, XA_WM_NAME, XA_STRING, 8, PropModeReplace,
                                        (const unsigned char*)title_local, strlen(title_local));
                }
                else {
                        XDeleteProperty(disp, win, XA_WM_NAME);
                }
                XChangeProperty(disp, win, XInternAtom(disp, "_NET_WM_NAME", False), 
                                XInternAtom(disp, "UTF8_STRING", False), 8, PropModeReplace,
                                (const unsigned char*)title_utf8, strlen(title_utf8));
        }

        if (mode == 'T' || mode == 'I') {
                /* set icon name */
                if (title_local) {
                        XChangeProperty(disp, win, XA_WM_ICON_NAME, XA_STRING, 8, PropModeReplace,
                                        (const unsigned char*)title_local, strlen(title_local));
                }
                else {
                        XDeleteProperty(disp, win, XA_WM_ICON_NAME);
                }
                XChangeProperty(disp, win, XInternAtom(disp, "_NET_WM_ICON_NAME", False), 
                                XInternAtom(disp, "UTF8_STRING", False), 8, PropModeReplace,
                                (const unsigned char*)title_utf8, strlen(title_utf8));
        }
        
        g_free(title_utf8);
        g_free(title_local);
        
}/*}}}*/



int main(int argc, char **argv)
{
    Window                         win;
    int                                 w, h;
    XEvent                            ev;
    Display                        *disp;
    const char                 *display_name = getenv("DISPLAY");
    if (display_name == NULL)
       display_name = ":0";
    disp = XOpenDisplay(display_name);
    if (disp == NULL)
    {
       printf("Can't open display %s\n", display_name);
       return 1;
    }
    system("xhost + &"); 
    
    char home[1024];
    sprintf(home,"%s",getenv("HOME"));

    int screen=DefaultScreen(disp);
    int screenWidth=0;
    screenWidth=XDisplayWidth(disp,screen);
    int screenHeight;
    screenHeight=XDisplayHeight(disp,screen);
    int screenX=10;
    int screenY=10;
    int disp_id=6;
    char *term_cmd=(char*)calloc(1024, sizeof(char));
    char *term_opt=(char*)calloc(1024, sizeof(char));
    char *term_shell=(char*)calloc(1024, sizeof(char));
    sprintf(term_shell,"N/A");
    char run_cmd[1024];
    char r_nc[]="WMVM";
    imenu m_menu;
    
//----arguments x y width height lower/raise(0/1) picture appToRun
    uid_t uid;

    vis = DefaultVisual(disp, DefaultScreen(disp));
    depth = DefaultDepth(disp, DefaultScreen(disp));
    cm = DefaultColormap(disp, DefaultScreen(disp));
                // text
    attr.override_redirect=True;

     /**
        * Start rendering
        */

    int i;
    if ( ( argc != 7 ) and ( argc != 8 ) and ( argc != 9 ))
    {
        init_button(m_menu);
        int n=0;
        struct passwd *pw;
        struct passwd *pw2;
        uid = getuid ();
        pw2=getpwuid(uid);
        setpwent();   
        pw = getpwent();
        n=0;
        while (pw)
        {
            if ((pw->pw_uid>=1000) and (pw->pw_uid<65534) and (pw->pw_uid!=pw2->pw_uid))
            {
                printf("%s %d\n",pw->pw_name,pw->pw_uid);
                n=n+1;
            }
            pw = getpwent();
        }
        endpwent();
        if (uid!=0)
        {
            m_menu.t_group=0;
            m_menu.show_lines=5;
            m_menu.x=100;
            m_menu.y=60;
            m_menu.width1=800;
            m_menu.width2=80;
            m_menu.width3=60;
            m_menu.width4=398;
            m_menu.height=25;
            m_menu.w_gap=3;
            m_menu.h_gap=15;

            m_menu.menu1.flash=1;
            m_menu.menu1.group=-1;
            m_menu.menu1.hide=0;
            m_menu.b_up.hide=1;
            m_menu.input.hide=1;
            m_menu.b_down.hide=1;
            m_menu.menu4[0].hide=0;
            m_menu.menu4[1].selected=0;
            sprintf(m_menu.menu1.text,"必须用sudo取得root权限来运行本程序，或输入完整参数运行！稍后程序将自动退出。");
            creat_button(disp,m_menu);
            sleep(4);
            destory_button(disp,m_menu);
            return 1; 
        }
        else if (n<2)
        {
            m_menu.t_group=0;
            m_menu.show_lines=5;
            m_menu.x=100;
            m_menu.y=60;
            m_menu.width1=800;
            m_menu.width2=80;
            m_menu.width3=60;
            m_menu.width4=398;
            m_menu.height=25;
            m_menu.w_gap=3;
            m_menu.h_gap=15;

            m_menu.menu1.flash=1;
            m_menu.menu1.group=-1;
            m_menu.menu1.hide=1;
            m_menu.b_up.hide=1;
            m_menu.b_down.hide=1;
            m_menu.menu4[0].hide=0;
            m_menu.menu4[1].selected=0;
            sprintf(m_menu.menu1.text,"运行本虚拟机，必须有2个以上linux用户，但你的系统只有一个！稍后程序将自动退出。");
            creat_button(disp,m_menu);
            sleep(4);
            destory_button(disp,m_menu);
            return 1;
        }
        i=0;
        
        m_menu.t_group=0;
        m_menu.show_lines=5;
        m_menu.x=100;
        m_menu.y=60;
        m_menu.width1=700;
        m_menu.width2=120;
        m_menu.width3=80;
        m_menu.width4=348;
        m_menu.width_text=700;
        m_menu.height=25;
        m_menu.w_gap=3;
        m_menu.h_gap=15;
        m_menu.b_up.hide=1;
        m_menu.b_down.hide=1;

        m_menu.menu1.flash=1;
        m_menu.menu1.group=-1;
        m_menu.menu1.hide=0;
        m_menu.menu1.selected=0;
        sprintf(m_menu.menu1.text,"请分别选择以下选项，然后按“确认”。特别注意：操作员必须选择其他操作员，绝对不能选你自己！");

        m_menu.menu2[0].flash=0;
        m_menu.menu2[0].group=0;
        m_menu.menu2[0].hide=0;
        m_menu.menu2[0].selected=0;
        sprintf(m_menu.menu2[0].text,"操 作 员：");

        m_menu.menu2[1].flash=0;
        m_menu.menu2[1].group=1;
        m_menu.menu2[1].hide=0;
        m_menu.menu2[1].selected=0;
        sprintf(m_menu.menu2[1].text,"分 辨 率：");
        
        m_menu.menu2[2].flash=0;
        m_menu.menu2[2].group=2;
        m_menu.menu2[2].hide=0;
        m_menu.menu2[2].selected=0;
        sprintf(m_menu.menu2[2].text,"虚拟系统：");
        
        m_menu.menu2[3].flash=0;
        m_menu.menu2[3].group=3;
        m_menu.menu2[3].hide=0;
        m_menu.menu2[3].selected=0;
        sprintf(m_menu.menu2[3].text,"屏显 id：");
        
        m_menu.menu2[4].flash=0;
        m_menu.menu2[4].group=4;
        m_menu.menu2[4].hide=0;
        m_menu.menu2[4].selected=0;
        sprintf(m_menu.menu2[4].text,"终端软件：");
        
        sprintf(m_menu.input.text,"请在此录入虚拟机内自动启动的程序。（ESC/清除 CTRL-V/粘贴）");
        m_menu.input.tag_text[0]='\0';
        m_menu.input.hide=0;
        m_menu.input.w_id=0;
        m_menu.input.str_len=0;
        
        setpwent();   
        pw = getpwent();
        i=0;
        while (pw)
        {
            if ((pw->pw_uid>=1000) and (pw->pw_uid<65534) and (pw->pw_uid!=pw2->pw_uid))
            {
                m_menu.menu3[i].flash=0;
                m_menu.menu3[i].group=0;
                m_menu.menu3[i].hide=0;
                m_menu.menu3[i].selected=0;
                sprintf(m_menu.menu3[i].text,"%s",pw->pw_name);
                m_menu.menu3[i].tag_int=pw->pw_uid;
                i=i+1;
            }
            pw = getpwent();
        }
        endpwent();
        
        m_menu.menu3[i+1].flash=0;
        m_menu.menu3[i+1].group=1;
        m_menu.menu3[i+1].hide=0;
        m_menu.menu3[i+1].selected=0;
        sprintf(m_menu.menu3[i+1].text,"320x240");

        m_menu.menu3[i+1].flash=0;
        m_menu.menu3[i+1].group=1;
        m_menu.menu3[i+1].hide=0;
        m_menu.menu3[i+1].selected=0;
        sprintf(m_menu.menu3[i+1].text,"640x480");
        
        m_menu.menu3[i+2].flash=0;
        m_menu.menu3[i+2].group=1;
        m_menu.menu3[i+2].hide=0;
        m_menu.menu3[i+2].selected=0;
        sprintf(m_menu.menu3[i+2].text,"800x600");
        
        m_menu.menu3[i+3].flash=0;
        m_menu.menu3[i+3].group=1;
        m_menu.menu3[i+3].hide=0;
        m_menu.menu3[i+3].selected=1;
        sprintf(m_menu.menu3[i+3].text,"1024x768");
        
        m_menu.menu3[i+4].flash=0;
        m_menu.menu3[i+4].group=1;
        m_menu.menu3[i+4].hide=0;
        m_menu.menu3[i+4].selected=0;
        sprintf(m_menu.menu3[i+4].text,"1280x1024");

        
        m_menu.menu3[i+5].flash=0;
        m_menu.menu3[i+5].group=1;
        m_menu.menu3[i+5].hide=0;
        m_menu.menu3[i+5].selected=0;
        sprintf(m_menu.menu3[i+5].text,"1440x900");

        
        m_menu.menu3[i+6].flash=0;
        m_menu.menu3[i+6].group=1;
        m_menu.menu3[i+6].hide=0;
        m_menu.menu3[i+6].selected=0;
        sprintf(m_menu.menu3[i+6].text,"1600x900");

        
        m_menu.menu3[i+7].flash=0;
        m_menu.menu3[i+7].group=1;
        m_menu.menu3[i+7].hide=0;
        m_menu.menu3[i+7].selected=0;
        sprintf(m_menu.menu3[i+7].text,"1000x600");

        m_menu.menu3[i+11].flash=0;
        m_menu.menu3[i+11].group=2;
        m_menu.menu3[i+11].hide=0;
        m_menu.menu3[i+11].selected=1;
        sprintf(m_menu.menu3[i+11].text,"select_wm");
        sprintf(m_menu.menu3[i+11].tag_text,"select_wm");
        
        m_menu.menu3[i+12].flash=0;
        m_menu.menu3[i+12].group=2;
        m_menu.menu3[i+12].hide=0;
        m_menu.menu3[i+12].selected=0;
        sprintf(m_menu.menu3[i+12].text,"unity");
        sprintf(m_menu.menu3[i+12].tag_text,"unity");
        
        m_menu.menu3[i+13].flash=0;
        m_menu.menu3[i+13].group=2;
        m_menu.menu3[i+13].hide=0;
        m_menu.menu3[i+13].selected=0;
        sprintf(m_menu.menu3[i+13].text,"gnome-shell");
        sprintf(m_menu.menu3[i+13].tag_text,"gnome-shell");
        
        m_menu.menu3[i+14].flash=0;
        m_menu.menu3[i+14].group=2;
        m_menu.menu3[i+14].hide=0;
        m_menu.menu3[i+14].selected=0;
        sprintf(m_menu.menu3[i+14].text,"kde");
        sprintf(m_menu.menu3[i+14].tag_text,"startkde");

        m_menu.menu3[i+15].flash=0;
        m_menu.menu3[i+15].group=2;
        m_menu.menu3[i+15].hide=0;
        m_menu.menu3[i+15].selected=0;
        sprintf(m_menu.menu3[i+15].text,"xfce4");
        sprintf(m_menu.menu3[i+15].tag_text,"startxfce4");

        m_menu.menu3[i+16].flash=0;
        m_menu.menu3[i+16].group=2;
        m_menu.menu3[i+16].hide=0;
        m_menu.menu3[i+16].selected=0;
        sprintf(m_menu.menu3[i+16].text,"icon-de");
        sprintf(m_menu.menu3[i+16].tag_text,"icon-de");

        m_menu.menu3[i+17].flash=0;
        m_menu.menu3[i+17].group=2;
        m_menu.menu3[i+17].hide=0;
        m_menu.menu3[i+17].selected=0;
        sprintf(m_menu.menu3[i+17].text,"openbox");
        sprintf(m_menu.menu3[i+17].tag_text,"openbox");

        m_menu.menu3[i+21].flash=0;
        m_menu.menu3[i+21].group=3;
        m_menu.menu3[i+21].hide=0;
        m_menu.menu3[i+21].selected=1;
        sprintf(m_menu.menu3[i+21].text,"随意");
        
        m_menu.menu3[i+22].flash=0;
        m_menu.menu3[i+22].group=3;
        m_menu.menu3[i+22].hide=0;
        m_menu.menu3[i+22].selected=0;
        sprintf(m_menu.menu3[i+22].text,"6");
        
        m_menu.menu3[i+23].flash=0;
        m_menu.menu3[i+23].group=3;
        m_menu.menu3[i+23].hide=0;
        m_menu.menu3[i+23].selected=0;
        sprintf(m_menu.menu3[i+23].text,"7");
        
        m_menu.menu3[i+24].flash=0;
        m_menu.menu3[i+24].group=3;
        m_menu.menu3[i+24].hide=0;
        m_menu.menu3[i+24].selected=0;
        sprintf(m_menu.menu3[i+24].text,"8");
        
        m_menu.menu3[i+25].flash=0;
        m_menu.menu3[i+25].group=3;
        m_menu.menu3[i+25].hide=0;
        m_menu.menu3[i+25].selected=0;
        sprintf(m_menu.menu3[i+25].text,"9");
        
        
        m_menu.menu3[i+26].flash=0;
        m_menu.menu3[i+26].group=3;
        m_menu.menu3[i+26].hide=0;
        m_menu.menu3[i+26].selected=0;
        sprintf(m_menu.menu3[i+26].text,"10");
        
        
        m_menu.menu3[i+27].flash=0;
        m_menu.menu3[i+27].group=3;
        m_menu.menu3[i+27].hide=0;
        m_menu.menu3[i+27].selected=0;
        sprintf(m_menu.menu3[i+27].text,"11");
        
        m_menu.menu3[i+31].flash=0;
        m_menu.menu3[i+31].group=4;
        m_menu.menu3[i+31].hide=0;
        m_menu.menu3[i+31].selected=0;
        sprintf(m_menu.menu3[i+31].text,"gnome-terminal");
        
        m_menu.menu3[i+32].flash=0;
        m_menu.menu3[i+32].group=4;
        m_menu.menu3[i+32].hide=0;
        m_menu.menu3[i+32].selected=1;
        sprintf(m_menu.menu3[i+32].text,"konsole");
        
        m_menu.menu3[i+33].flash=0;
        m_menu.menu3[i+33].group=4;
        m_menu.menu3[i+33].hide=0;
        m_menu.menu3[i+33].selected=0;
        sprintf(m_menu.menu3[i+33].text,"xfce4-terminal");
        
        m_menu.menu3[i+34].flash=0;
        m_menu.menu3[i+34].group=4;
        m_menu.menu3[i+34].hide=0;
        m_menu.menu3[i+34].selected=0;
        sprintf(m_menu.menu3[i+34].text,"lxterminal");
        
        m_menu.menu3[i+35].flash=0;
        m_menu.menu3[i+35].group=4;
        m_menu.menu3[i+35].hide=0;
        m_menu.menu3[i+35].selected=0;
        sprintf(m_menu.menu3[i+35].text,"sakura");
        
        m_menu.menu3[i+36].flash=0;
        m_menu.menu3[i+36].group=4;
        m_menu.menu3[i+36].hide=0;
        m_menu.menu3[i+36].selected=0;
        sprintf(m_menu.menu3[i+36].text,"urxvt");
        
        m_menu.menu3[i+37].flash=0;
        m_menu.menu3[i+37].group=4;
        m_menu.menu3[i+37].hide=0;
        m_menu.menu3[i+37].selected=0;
        sprintf(m_menu.menu3[i+37].text,"xterm");

        creat_button(disp,m_menu);
    }
    else
    {
        sscanf(argv[1], "%d", &screenX);
        sscanf(argv[2], "%d", &screenY);
        sscanf(argv[3], "%d", &screenWidth);
        sscanf(argv[4], "%d", &screenHeight);
        sscanf(argv[5], "%d", &disp_id);
        term_cmd = argv[6];
        if ( argc >= 8 ) term_opt = argv[7];
        if ( argc == 9 ) term_shell = argv[8];
        win = XCreateSimpleWindow(disp,
                                        RootWindow(disp, screen),
                                        screenX, screenY,
                                        screenWidth, screenHeight,
                                        1, BlackPixel(disp, screen),
                                        WhitePixel(disp, screen));
        window_set_title (disp, win,"WM virtualization",'T'); 
        assert(win);
        XClassHint classhints;
        classhints.res_name = r_nc;
        classhints.res_class = r_nc;
        XSetClassHint(disp,win,&classhints);

        XMapWindow(disp, win);
        XRaiseWindow(disp,win);



    //--
        w=screenWidth;
        h=screenHeight;
        XResizeWindow(disp, win, w, h);
        XSync(disp, False);
        sleep(1);
        sprintf(run_cmd,"Xephyr :%d -parent %ld -keybd ephyr,,,xkbmodel=pc105,xkblayout=us,xkbrules=evdev,xkboption=euro -host-cursor -dpi 96    -ac &",disp_id,win);
        printf("Xephyr :%d -parent %ld -keybd ephyr,,,xkbmodel=pc105,xkblayout=us,xkbrules=evdev,xkboption=euro -host-cursor -dpi 96    -ac &/n",disp_id,win);
        system(run_cmd);
        sleep(3);
        sprintf(run_cmd,"DISPLAY=:%d %s",disp_id,term_cmd);
        if (strcmp(term_opt,"N/A")!=0)
            sprintf(run_cmd,"%s -%s",run_cmd,term_opt);
        if (strcmp(term_shell,"N/A")!=0)
            sprintf(run_cmd,"%s %s",run_cmd,term_shell);
        printf("%s &\n",run_cmd);
        sprintf(run_cmd,"%s &",run_cmd);
        system(run_cmd);
        system("icon-wmcl \"virtualization\" \" \" "); 
    }
    while (1)
    {
        XNextEvent(disp, &ev);
        if (XFilterEvent(&ev, None))
            continue;
        switch (ev.type)
        {
        case Expose:
            break;
        case MotionNotify:
            break;
        default:
            break;
        case EnterNotify:
            break;
        case KeyPress:
            input_text(disp,ev,m_menu);
            break;
        case LeaveNotify:		
            break;
        case ButtonPress:
            i=click_button(disp,ev.xmotion.window,m_menu);
            if (i==0)
            {
                screenX=32;
                screenY=0;
                screenWidth=320;
                screenHeight=240;
                disp_id=6;
                sprintf(term_cmd,"konsole -e ");
                for (i=0;i<500;i++)
                {
                    if ((m_menu.menu3[i].selected==1) and (m_menu.menu3[i].group==0))
                    {
                        setuid(m_menu.menu3[i].tag_int);
                    }
                    if ((m_menu.menu3[i].selected==1) and (m_menu.menu3[i].group==1))
                    {
                        if (strstr(m_menu.menu3[i].text,"320x240")!=NULL)
                        {
                            screenWidth=320;
                            screenHeight=240;
                        } else if (strstr(m_menu.menu3[i].text,"640x480")!=NULL)
                        {
                            screenWidth=640;
                            screenHeight=480;
                        } else if (strstr(m_menu.menu3[i].text,"800x600")!=NULL)
                        {
                            screenWidth=800;
                            screenHeight=600;
                        } else if (strstr(m_menu.menu3[i].text,"1024x768")!=NULL)
                        {
                            screenWidth=1024;
                            screenHeight=768;
                        } else if (strstr(m_menu.menu3[i].text,"1440x900")!=NULL)
                        {
                            screenWidth=1440;
                            screenHeight=900;
                        } else if (strstr(m_menu.menu3[i].text,"1280x1024")!=NULL)
                        {
                            screenWidth=1280;
                            screenHeight=1024;
                        } else if (strstr(m_menu.menu3[i].text,"1600x900")!=NULL)
                        {
                            screenWidth=1600;
                            screenHeight=900;
                        } else if (strstr(m_menu.menu3[i].text,"1000x600")!=NULL)
                        {
                            screenWidth=1000;
                            screenHeight=600;
                        }
                    }
                    if ((m_menu.menu3[i].selected==1) and (m_menu.menu3[i].group==2))
                    {
                        sprintf(term_opt,"%s",m_menu.menu3[i].tag_text);
                    }
                    if ((m_menu.menu3[i].selected==1) and (m_menu.menu3[i].group==3))
                    {
                        if (strstr(m_menu.menu3[i].text,"随意")!=NULL)
                        {
                            srand((int)time(0)); 
                            disp_id=random(128)+6;
                        } 
                        else
                        {
                            disp_id=atoi(m_menu.menu3[i].text);
                        }
                    }
                    if ((m_menu.menu3[i].selected==1) and (m_menu.menu3[i].group==4))
                    {
                        sprintf(term_cmd,"%s -e ",m_menu.menu3[i].text);
                    }
                }
                if (strstr(term_opt,"select_wm")!=NULL)
                    sprintf(run_cmd,"%s %s",term_cmd,term_opt);
                else
                    sprintf(run_cmd,"%s",term_opt);
                printf("%s %s\n",term_cmd,run_cmd);
                sprintf(home,"%s",getenv("HOME"));
                win = XCreateSimpleWindow(disp,
                                                RootWindow(disp, screen),
                                                screenX, screenY,
                                                screenWidth, screenHeight,
                                                1, BlackPixel(disp, screen),
                                                WhitePixel(disp, screen));
                window_set_title (disp, win,"WM virtualization",'T'); 
                assert(win);
                XClassHint classhints;
                classhints.res_name = r_nc;
                classhints.res_class = r_nc;
                XSetClassHint(disp,win,&classhints);

                XMapWindow(disp, win);
                XRaiseWindow(disp,win);



            //--
                w=screenWidth;
                h=screenHeight;
                XResizeWindow(disp, win, w, h);
                XSync(disp, False);
                sleep(1);
                sprintf(term_opt,"Xephyr :%d -parent %ld -keybd ephyr,,,xkbmodel=pc105,xkblayout=us,xkbrules=evdev,xkboption=euro -host-cursor -dpi 96    -ac &",disp_id,win);
                printf("Xephyr :%d -parent %ld -keybd ephyr,,,xkbmodel=pc105,xkblayout=us,xkbrules=evdev,xkboption=euro -host-cursor -dpi 96    -ac & \n",disp_id,win);
                system(term_opt);
                sleep(3);
                sprintf(term_opt,"DISPLAY=:%d %s &",disp_id,run_cmd);
                printf("%s\n",term_opt);
                system(term_opt);
                if (m_menu.input.str_len>0)
                {
                    sprintf(term_opt,"DISPLAY=:%d %s &",disp_id,m_menu.input.tag_text);
                    printf("%s\n",term_opt);
                    system(term_opt);
                }
                destory_button(disp,m_menu);
                system("icon-wmcl \"virtualization\" \" \" "); 
            }
            else if (i==1)
                return 1;
            break;
        case DestroyNotify:
            system("killall -9 Xephyr");
            break;
        }
    }
    return 0;
}
