/* icondm - Icon DE Display Manager
*/

#ifndef _BUTTON_H_
#define _BUTTON_H_

#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <malloc.h>
#include <errno.h>
#include <string.h>
#include <pwd.h>
#include <shadow.h>
#include <setjmp.h>
#include <sys/time.h>
#include <X11/Xatom.h>
#include <X11/Xlocale.h>
#include <X11/Xmu/WinUtil.h>
#include <glib-2.0/glib.h>
#include "Imlib2.h"
#include <X11/Xft/Xft.h>
#include <string.h>
#include <assert.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <grp.h>
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/stat.h>
#include <X11/cursorfont.h>
#include <pthread.h>
#include <string>

#include "switchuser.h"
#include "const.h"
typedef struct _ibutton_ {
        Window w_id;
        char  text[256];
        int   group;
        int   tag_int;
        char  tag_text[1024];
        int   selected;
        int   flash;
        int   hide;
} ibutton;

typedef struct _iinput_ {
        Window w_id;
        Window w_ip;
        char  text[512];
        int   tag_int;
        char  tag_text[1024];
        int   str_len;
        int   hide;
        int   cur;
        int   insert;
        int   is_passwd;
        int   have_xim;
} iinput;

class imenu {
public:
    int       t_group;
    int       m_group_begin;
    int       m_group_end;
    int       show_lines;
    int       x;
    int       y;
    XIC       ic;
    GC        gc;
    int       width1;
    int       width2;
    int       width3;
    int       width4;
    int       width_text;
    int       height;
    int       w_gap;
    int       h_gap;
    int       font_size;
    int       bc_red;
    int       bc_green;
    int       bc_blue;
    int       bc_alpha;
    int       bf_red;
    int       bf_green;
    int       bf_blue;
    int       bf_alpha;
    ibutton  menu1;
    ibutton  b_up;
    ibutton  b_down;
    ibutton  menu2[15];
    ibutton  menu3[150];
    ibutton  menu4[3];
    iinput   input;

    void Message(const std::string& text);

    imenu(Display* dpy, int scr, Window root, Cfg* config);
    ~imenu();
    void init_button();
    int  creat_button();
    void destory_button();
    void hide_button();
    void filter_button(int mode);
    int  click_button(Window w_id);
    int  input_text(XEvent &event);
    char * getSession();
    const char * GetName(void) const;
    const char * GetPasswd(void) const;
private:
    imenu();
    Window Root;
    Display* Dpy;
    int Scr;
    Imlib_Color_Range range;
    Imlib_Font font;
    Imlib_Font font2;
    Visual  *button_vis;
    Colormap  button_cm;
    int  button_depth;
    Cfg* cfg;
    XftColor msgcolor;
    XftColor msgshadowcolor;
    XftFont* msgfont;
    void icondmDrawString8(XftDraw *d, XftColor *color, XftFont *font,
                            int x, int y, const std::string& str,
                            XftColor* shadowColor,
                            int xOffset, int yOffset);

};
#endif
