/* icondm - Icon DE Display Manager
*/

#include <fstream>
#include <string>
#include <iostream>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

#include "cfg.h"

using namespace std;

//***********************************处理rc文件的函数--开始
int b_check_rc(const char *fullstr,const char *l_str)
{
    char ch2[4096],f_str[4096];
    sprintf(f_str,"%s",fullstr);
    int i,n,m;
    sprintf(ch2,"%s",fullstr);
    for (i=0;i<4096;i++)
        if (ch2[i]=='\0')
            break;
    m=i;
    sprintf(ch2,"%s",l_str);
    for (i=0;i<4096;i++)
        if (ch2[i]=='\0')
            break;
    n=i;
    if (n>=m) return -1;

    for (i=0;i<n;i++)
        ch2[i]=f_str[i];
    ch2[n]='\0';
    if (strcmp(ch2,l_str)==0 )
        return 0;
    else
        return -1;
}

int b_get_str(char *sSrc,const char *fullstr,const char *l_str)
{
    char ch2[4096],f_str[4096];
    sprintf(f_str,"%s",fullstr);
    int i,n,m;
    sprintf(ch2,"%s",fullstr);
    for (i=0;i<4096;i++)
        if (ch2[i]=='\0')
            break;
    m=i;
    sprintf(ch2,"%s",l_str);
    for (i=0;i<4096;i++)
        if (ch2[i]=='\0')
            break;
    n=i;
    if (n>=m) 
        return -1;
    for (i=0;i<4096-n-1;i++)
        ch2[i]=f_str[i+n];
    sprintf(sSrc,"%s",ch2);
    return 0;
}

int b_get_str2(char * jg,char *fullstr,int n_id)
{
    char f_buffer[4096],ch2[4096];
    int i,n,o,p,yh;
    sprintf(f_buffer,"%s",fullstr);
    p=0;
    i=0;
    while (1)
    {
        o=0;
        yh=0;
        for (n=0;n<4096;n++)
            ch2[n]='\0';
        for (n=p;n<4096;n++)
        {
            if ((yh==0) and (f_buffer[n]==' '))
                continue;
    //                                printf("%c\n",f_buffer[n]);
            if ((yh==1) and (f_buffer[n]=='\"') and (f_buffer[n-1]!='\\'))
                break;
            if (((f_buffer[n]=='\"') and (n==p)) or ((f_buffer[n]=='\"') and (n>p) and (f_buffer[n-1]!='\\')))
            {
                yh=1;
                continue;
            }
            if ((yh==2) and (f_buffer[n]==' '))
                break;
            if ((yh==0) and (f_buffer[n]!=' '))
                yh=2;
            if (yh>0)
            {
                ch2[o]=f_buffer[n];
                o=o+1;
            }
        }
        if (yh==1)
            p=n+1;
        else
            p=n;
        i=i+1;
        if (i==n_id)
        {
            sprintf(jg,"%s",ch2);
            return 0;
        }
    }
    return -1;
}

//***********************************处理rc文件的函数--结束


typedef pair<string,string> option;

Cfg::Cfg() 
{
    // Configuration options
    // Theme stuff
    options.insert(option("icon_top","100"));
    options.insert(option("icon_left","60"));
    options.insert(option("icon_width1","800"));
    options.insert(option("icon_width2","120"));
    options.insert(option("icon_width3","80"));
    options.insert(option("icon_width4","231"));
    options.insert(option("text_width","800"));
    options.insert(option("icon_height","25"));
    options.insert(option("wide_gap","3"));
    options.insert(option("high_gap","15"));
    options.insert(option("bc_red","255"));
    options.insert(option("bc_green","200"));
    options.insert(option("bc_blue","10"));
    options.insert(option("bc_alpha","255"));
    options.insert(option("bf_red","0"));
    options.insert(option("bf_green","0"));
    options.insert(option("bf_blue","0"));
    options.insert(option("bf_alpha","255"));
    options.insert(option("font_size","11"));
    options.insert(option("msg_color","#FFFFFF"));
    options.insert(option("msg_font","Verdana:size=16:bold"));
    options.insert(option("msg_x","40"));
    options.insert(option("msg_y","40"));
    options.insert(option("msg_shadow_xoffset", "0"));
    options.insert(option("msg_shadow_yoffset", "0"));
    options.insert(option("msg_shadow_color","#FFFFFF"));
    options.insert(option("background","/usr/share/icon-DE/iconcache/background.jpg"));
    options.insert(option("background_style","stretch"));
    options.insert(option("background_color","#CCCCCC"));

    options.insert(option("default_path","/bin:/usr/bin:/usr/local/bin"));
    options.insert(option("default_xserver","/usr/bin/X"));
    options.insert(option("xserver_arguments",""));
    options.insert(option("numlock",""));
    options.insert(option("daemon",""));
    options.insert(option("xauth_path","/usr/bin/xauth"));
    options.insert(option("login_cmd","exec /bin/bash -login ~/.xinitrc %session"));
    options.insert(option("halt_cmd","/sbin/shutdown -h now"));
    options.insert(option("reboot_cmd","/sbin/shutdown -r now"));
    options.insert(option("sessionstart_cmd",""));
    options.insert(option("sessionstop_cmd",""));
    options.insert(option("screenshot_cmd","scrot /usr/share/icon-DE/iconcache/icondm.png"));

    options.insert(option("lockfile","/var/run/icondm.lock"));
    options.insert(option("logfile","/var/log/icondm.log"));
    options.insert(option("authfile","/var/run/icondm.auth"));
    options.insert(option("shutdown_msg","The system is halting..."));
    options.insert(option("reboot_msg","The system is rebooting..."));

    options.insert(option("our_wm1","随机启动"));
    options.insert(option("our_wm2", "select_wm"));
    options.insert(option("our_wm3", "N/A"));
    options.insert(option("default_wm","icon-de"));
    options.insert(option("default_usr","lijianjun"));
	printf("\n");
    error = "";

}

Cfg::~Cfg() {
    options.clear();
}
/*
 * Creates the Cfg object and parses
 * known options from the given configfile / themefile
 */
bool Cfg::readConf(string configfile) {
    char f_buffer[1024],ch2[1024],ch[1024];
    FILE * fp2=NULL;
    int i;
    fp2=fopen(configfile.c_str(),"r");
    if (fp2==NULL)
    {
        printf("can't open %s\n",configfile.c_str());
        return false;
    }
    else
    {
        fgets(f_buffer,1024,fp2);
        for (i=0;i<1024;i++)
            if (f_buffer[i]=='\n') f_buffer[i]='\0';
        while ( ! feof(fp2) )
        {
            if (b_check_rc(f_buffer,"tag_color:")==0 )
            {
                b_get_str(ch2,f_buffer,"tag_color:");
                b_get_str2(ch,ch2,1);
				options["bc_red"]=ch;
                b_get_str2(ch,ch2,2);
				options["bc_green"]=ch;
                b_get_str2(ch,ch2,3);
				options["bc_blue"]=ch;
                b_get_str2(ch,ch2,4);
				options["bc_alpha"]=ch;
            }
            if (b_check_rc(f_buffer,"font_color:")==0 )
            {
                b_get_str(ch2,f_buffer,"font_color:");
                b_get_str2(ch,ch2,1);
				options["bf_red"]=ch;
                b_get_str2(ch,ch2,2);
				options["bf_green"]=ch;
                b_get_str2(ch,ch2,3);
				options["bf_blue"]=ch;
                b_get_str2(ch,ch2,4);
				options["bf_alpha"]=ch;
            }
            if (b_check_rc(f_buffer,"icon_top:")==0 )
            {
                b_get_str(ch2,f_buffer,"icon_top:");
				options["icon_top"]=ch2;
			}
            if (b_check_rc(f_buffer,"icon_left:")==0 )
            {
                b_get_str(ch2,f_buffer,"icon_left:");
				options["icon_left"]=ch2;
			}
            if (b_check_rc(f_buffer,"icon_width1:")==0 )
            {
                b_get_str(ch2,f_buffer,"icon_width1:");
				options["icon_width1"]=ch2;
			}
            if (b_check_rc(f_buffer,"icon_width2:")==0 )
            {
                b_get_str(ch2,f_buffer,"icon_width2:");
				options["icon_width2"]=ch2;
			}
            if (b_check_rc(f_buffer,"icon_width3:")==0 )
            {
                b_get_str(ch2,f_buffer,"icon_width3:");
				options["icon_width3"]=ch2;
			}
            if (b_check_rc(f_buffer,"icon_width4:")==0 )
            {
                b_get_str(ch2,f_buffer,"icon_width4:");
				options["icon_width4"]=ch2;
			}
            if (b_check_rc(f_buffer,"text_width:")==0 )
            {
                b_get_str(ch2,f_buffer,"text_width:");
				options["text_width"]=ch2;
			}
            if (b_check_rc(f_buffer,"icon_height:")==0 )
            {
                b_get_str(ch2,f_buffer,"icon_height:");
				options["icon_height"]=ch2;
			}
            if (b_check_rc(f_buffer,"wide_gap:")==0 )
            {
                b_get_str(ch2,f_buffer,"wide_gap:");
				options["wide_gap"]=ch2;
			}
            if (b_check_rc(f_buffer,"high_gap:")==0 )
            {
                b_get_str(ch2,f_buffer,"high_gap:");
				options["high_gap"]=ch2;
			}
            if (b_check_rc(f_buffer,"font_size:")==0 )
            {
                b_get_str(ch2,f_buffer,"font_size:");
				options["font_size"]=ch2;
			}
            if (b_check_rc(f_buffer,"default_path:")==0 )
            {
                b_get_str(ch2,f_buffer,"default_path:");
				options["default_path"]=ch2;
			}
            if (b_check_rc(f_buffer,"default_xserver:")==0 )
            {
                b_get_str(ch2,f_buffer,"default_xserver:");
				options["default_xserver"]=ch2;
			}
            if (b_check_rc(f_buffer,"xserver_arguments:")==0 )
            {
                b_get_str(ch2,f_buffer,"xserver_arguments:");
				options["xserver_arguments"]=ch2;
			}
            if (b_check_rc(f_buffer,"numlock:")==0 )
            {
                b_get_str(ch2,f_buffer,"numlock:");
				options["numlock"]=ch2;
			}
            if (b_check_rc(f_buffer,"daemon:")==0 )
            {
                b_get_str(ch2,f_buffer,"daemon:");
				options["daemon"]=ch2;
			}
            if (b_check_rc(f_buffer,"xauth_path:")==0 )
            {
                b_get_str(ch2,f_buffer,"xauth_path:");
				options["xauth_path"]=ch2;
			}
            if (b_check_rc(f_buffer,"login_cmd:")==0 )
            {
                b_get_str(ch2,f_buffer,"login_cmd:");
				options["login_cmd"]=ch2;
			}
            if (b_check_rc(f_buffer,"halt_cmd:")==0 )
            {
                b_get_str(ch2,f_buffer,"halt_cmd:");
				options["halt_cmd"]=ch2;
			}
            if (b_check_rc(f_buffer,"reboot_cmd:")==0 )
            {
                b_get_str(ch2,f_buffer,"reboot_cmd:");
				options["reboot_cmd"]=ch2;
			}
            if (b_check_rc(f_buffer,"screenshot_cmd:")==0 )
            {
                b_get_str(ch2,f_buffer,"screenshot_cmd:");
				options["screenshot_cmd"]=ch2;
			}
            if (b_check_rc(f_buffer,"lockfile:")==0 )
            {
                b_get_str(ch2,f_buffer,"lockfile:");
				options["lockfile"]=ch2;
			}
            if (b_check_rc(f_buffer,"logfile:")==0 )
            {
                b_get_str(ch2,f_buffer,"logfile:");
				options["logfile"]=ch2;
			}
            if (b_check_rc(f_buffer,"authfile:")==0 )
            {
                b_get_str(ch2,f_buffer,"authfile:");
				options["authfile"]=ch2;
			}
            if (b_check_rc(f_buffer,"shutdown_msg:")==0 )
            {
                b_get_str(ch2,f_buffer,"shutdown_msg:");
				options["shutdown_msg"]=ch2;
			}
            if (b_check_rc(f_buffer,"reboot_msg:")==0 )
            {
                b_get_str(ch2,f_buffer,"reboot_msg:");
				options["reboot_msg"]=ch2;
			}
            if (b_check_rc(f_buffer,"msg_color:")==0 )
            {
                b_get_str(ch2,f_buffer,"msg_color:");
				options["msg_color"]=ch2;
			}
            if (b_check_rc(f_buffer,"msg_font:")==0 )
            {
                b_get_str(ch2,f_buffer,"msg_font:");
				options["msg_font"]=ch2;
			}
            if (b_check_rc(f_buffer,"msg_x:")==0 )
            {
                b_get_str(ch2,f_buffer,"msg_x:");
				options["msg_x"]=ch2;
			}
            if (b_check_rc(f_buffer,"msg_y:")==0 )
            {
                b_get_str(ch2,f_buffer,"msg_y:");
				options["msg_y"]=ch2;
			}
            if (b_check_rc(f_buffer,"msg_shadow_xoffset:")==0 )
            {
                b_get_str(ch2,f_buffer,"msg_shadow_xoffset:");
				options["msg_shadow_xoffset"]=ch2;
			}
            if (b_check_rc(f_buffer,"msg_shadow_yoffset:")==0 )
            {
                b_get_str(ch2,f_buffer,"msg_shadow_yoffset:");
				options["msg_shadow_yoffset"]=ch2;
			}
            if (b_check_rc(f_buffer,"msg_shadow_color:")==0 )
            {
                b_get_str(ch2,f_buffer,"msg_shadow_color:");
				options["msg_shadow_color"]=ch2;
			}
            if (b_check_rc(f_buffer,"background:")==0 )
            {
                b_get_str(ch2,f_buffer,"background:");
				options["background"]=ch2;
			}
            if (b_check_rc(f_buffer,"our_wm1:")==0 )
            {
                b_get_str(ch2,f_buffer,"our_wm1:");
				options["our_wm1"]=ch2;
			}
            if (b_check_rc(f_buffer,"our_wm2:")==0 )
            {
                b_get_str(ch2,f_buffer,"our_wm2:");
				options["our_wm2"]=ch2;
			}
            if (b_check_rc(f_buffer,"our_wm3:")==0 )
            {
                b_get_str(ch2,f_buffer,"our_wm3:");
				options["our_wm3"]=ch2;
			}
            if (b_check_rc(f_buffer,"default_wm:")==0 )
            {
                b_get_str(ch2,f_buffer,"default_wm:");
				options["default_wm"]=ch2;
			}
            if (b_check_rc(f_buffer,"default_usr:")==0 )
            {
                b_get_str(ch2,f_buffer,"default_usr:");
				options["default_usr"]=ch2;
			}
            if (b_check_rc(f_buffer,"background_style:")==0 )
            {
                b_get_str(ch2,f_buffer,"background_style:");
				options["background_style"]=ch2;
			}
            if (b_check_rc(f_buffer,"background_color:")==0 )
            {
                b_get_str(ch2,f_buffer,"background_color:");
				options["background_color"]=ch2;
			}
            if (b_check_rc(f_buffer,"sessionstart_cmd:")==0 )
            {
                b_get_str(ch2,f_buffer,"sessionstart_cmd:");
				options["sessionstart_cmd"]=ch2;
			}
            if (b_check_rc(f_buffer,"sessionstop_cmd:")==0 )
            {
                b_get_str(ch2,f_buffer,"sessionstop_cmd:");
				options["sessionstop_cmd"]=ch2;
			}
            fgets(f_buffer,1024,fp2);
            for (i=0;i<1024;i++)
                if (f_buffer[i]=='\n') f_buffer[i]='\0';
        }
        fclose(fp2);
    }
    return true;
}

/* Returns the option value, trimmed */
//string Cfg::parseOption(string line, string option ) {
//    return Trim( line.substr(option.size(), line.size() - option.size()));
//}


const string& Cfg::getError() const {
    return error;
}

string& Cfg::getOption(string option) {
    return options[option];
}

/* return a trimmed string */
string Cfg::Trim( const string& s ) {
    if ( s.empty() ) {
        return s;
    }
    int pos = 0;
    string line = s;
    int len = line.length();
    while ( pos < len && isspace( line[pos] ) ) {
        ++pos;
    }
    line.erase( 0, pos );
    pos = line.length()-1;
    while ( pos > -1 && isspace( line[pos] ) ) {
        --pos;
    }
    if ( pos != -1 ) {
        line.erase( pos+1 );
    }
    return line;
}

int Cfg::string2int(const char* string, bool* ok) {
    char* err = 0;
    int l = (int)strtol(string, &err, 10);
    if (ok) {
        *ok = (*err == 0);
    }
    return (*err == 0) ? l : 0;
}

// Get absolute position
int Cfg::absolutepos(const string& position, int max, int width) {
    int n = -1;
    n = position.find("%");
    if (n>0) { // X Position expressed in percentage
        int result = (max*string2int(position.substr(0, n).c_str())/100) - (width / 2);
        return result < 0 ? 0 : result ;
    } else { // Absolute X position
        return string2int(position.c_str());
    }
}

// split a comma separated string into a vector of strings
void Cfg::split(vector<string>& v, const string& str, char c, bool useEmpty) {
    v.clear();
    string::const_iterator s = str.begin();
    string tmp;
    while (true) {
        string::const_iterator begin = s;
        while (*s != c && s != str.end()) { ++s; }
    tmp = string(begin, s);
    if (useEmpty || tmp.size() > 0)
            v.push_back(tmp);
        if (s == str.end()) {
            break;
        }
        if (++s == str.end()) {
        if (useEmpty)
                v.push_back("");
            break;
        }
    }
}

