/* icondm - Icon DE Display Manager
*/

#ifndef _CFG_H_
#define _CFG_H_

#include <string>
#include <map>
#include <vector>

#define INPUT_MAXLENGTH_NAME    30
#define INPUT_MAXLENGTH_PASSWD  50

#define CFGFILE SYSCONFDIR"/icon-de/icondm.conf"

class Cfg {

public:
    Cfg();
    ~Cfg();
    bool readConf(std::string configfile);
//    std::string parseOption(std::string line, std::string option);
    const std::string& getError() const;
    std::string& getOption(std::string option);

    static int absolutepos(const std::string& position, int max, int width);
    static int string2int(const char* string, bool* ok = 0);
    static void split(std::vector<std::string>& v, const std::string& str, 
                      char c, bool useEmpty=true);
    static std::string Trim(const std::string& s);

private:
    std::map<std::string,std::string> options;
    std::vector<std::string> sessions;
    std::string error;

};

#endif
