// g++ -o ./bin/iconrun ./src/iconrun.c    -lImlib2 -lX11 -lXmu `pkg-config --cflags --libs glib-2.0`

#include <stdio.h>
#include <stdlib.h>
#include <map>
#include <iconv.h>
#include <iostream>
#include <vector>
//#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <X11/cursorfont.h>
//#include <X11/Xmu/WinUtil.h>
#include <glib-2.0/glib.h>
using namespace std;

#include "Imlib2.h"

Display                        *disp;
Window                          win4;
Window                          win2;
Visual                         *vis;
Colormap                        cm;
int                             depth;
XSetWindowAttributes attr;
char home[1024];
char c_rc[2048]="N/A";


Atom XA_TARGETS;
Atom XA_multiple;
Atom XA_image_bmp;
Atom XA_image_jpg;
Atom XA_image_tiff;
Atom XA_image_png;
Atom XA_text_uri_list;
Atom XA_text_uri;
Atom XA_text_plain;
Atom XA_text;

Atom XA_XdndSelection;
Atom XA_XdndAware;
Atom XA_XdndEnter;
Atom XA_XdndLeave;
Atom XA_XdndTypeList;
Atom XA_XdndPosition;
Atom XA_XdndActionCopy;
Atom XA_XdndStatus;
Atom XA_XdndDrop;
Atom XA_XdndFinished;

#include "./other_src/wm_ctrl.c"
#include "./other_src/icon.c"
#include "./other_src/button.c"

#define UNAWARE 0
#define UNRECEPTIVE 1
#define CAN_DROP 2

char Char2Int(char ch){
    if(ch>='0' && ch<='9')return (char)(ch-'0');
    if(ch>='a' && ch<='f')return (char)(ch-'a'+10);
    if(ch>='A' && ch<='F')return (char)(ch-'A'+10);
    return -1;
}

char Str2Bin(char *str){
    char tempWord[2];
    char chn;

    tempWord[0] = Char2Int(str[0]);                //make the B to 11 -- 00001011
    tempWord[1] = Char2Int(str[1]);                //make the 0 to 0    -- 00000000

    chn = (tempWord[0] << 4) | tempWord[1];        //to change the BO to 10110000

    return chn;
}

string UrlDecode(string str){
    string output="";
    char tmp[2];
    int i=0,len=str.length();
    
    while(i<len)
    {
        if(str[i]=='%')
        {
            tmp[0]=str[i+1];
            tmp[1]=str[i+2];
            output+=Str2Bin(tmp);
            i=i+3;
        }
        else if(str[i]=='+')
        {
            output+=' ';
            i++;
        }
        else{
            output+=str[i];
            i++;
        }
    }
    
    return output;
}


// 代码转换操作类 用于将utf-8 格式转成 gb2312
class CodeConverter {
    private:
            iconv_t cd;
    public:
            CodeConverter(const char *_charset,const char *to_charset) {// 构造
                cd = iconv_open(to_charset,_charset);
            }
        
            ~CodeConverter() {// 析构
                iconv_close(cd);
            }
        
            int convert(char *inbuf,int inlen,char *outbuf,int outlen) {// 转换输出
                char **pin = &inbuf;
                char **pout = &outbuf;

                memset(outbuf,0,outlen);
                return iconv(cd,pin,(size_t *)&inlen,pout,(size_t *)&outlen);
            }
};

//输入url_Utf-8 ,输出utf-8
string url2str_utf8(string instr){
    string input;
    input=UrlDecode(instr);

    const int    outlen=instr.length();
    char output[outlen];

    CodeConverter cc = CodeConverter("utf-8","utf-8");
    cc.convert((char *)input.c_str(),strlen(input.c_str()),output,outlen);

    return output;
}

//输入url_gb2312 ,输出 gb2312 实际上是直接调用 UrlDecode()
string url2str_gb2312(string str){
    return UrlDecode(str);
}



char * read_desktop_entry(char * desk_file_name)
{
    string ss;
    FILE *fp=NULL;
    FILE *fp2=NULL;
    char buffer[4096];
    char type[1024]="";
    char name[1024]="";
    char name_zh[1024]="";
    char icon_file[2048];
    char icon[1024]="";
    char exec[1024]="";
    char term[64]="False";
    char comment[1024]="";
    char comment_zh[1024]="";
    char url[1024]="N/A";
    char gene[1024]="";
    char gene_zh[1024]="";
    int i;
//    char full_path_icon[4096]="";
    char title[1024]="aaa";
    char c_term[1024];
    char e_term[100];
    char c_cmd[1024];

    ss=string(4096,'\0');
    ss.assign(desk_file_name);
    for (i=0;i<4089;i++)
    {
        ss[i]=ss[i+7];
        if (ss[i]=='\n')
            ss[i]='\0';
        if (ss[i]=='\r')
            ss[i]='\0';
    }
    for (i=4096;i>0;i--)
    {
        if (ss[i]=='\n')
            ss[i]='\0';
        if (ss[i]=='\r')
            ss[i]='\0';
        if (ss[i]==' ')
            ss[i]='\0';
        else
            break;    
    }
    ss=url2str_utf8(ss);
    cout<<ss<<endl;;
    cout << flush;
    if (access(ss.c_str(),0)!=-1)
    {
        fp=fopen(ss.c_str(),"r");
        if(fp==NULL) 
        {
        printf("not open 1\n");
        }
        else
        {
            fgets(buffer,4096,fp);
            for (i=0;i<4096;i++)
                if (buffer[i]=='\n') buffer[i]='\0';
            if (strcmp(buffer,"[Desktop Entry]")==0 )
            {
                sprintf(gene_zh,"N/A");
                sprintf(comment_zh,"N/A");
                sprintf(name_zh,"N/A");
                sprintf(url,"N/A");
                sprintf(exec,"N/A");
                sprintf(type,"N/A");
                sprintf(name,"N/A");
                sprintf(comment,"N/A");
                sprintf(icon,"N/A");
                sprintf(gene,"N/A");
                while ( ! feof(fp) )
                {
                    fgets(buffer,4096,fp);
                    for (i=0;i<4096;i++)
                    if (buffer[i]=='\n') buffer[i]='\0';
                    if (check_rc(buffer,"[")==0 ) break;
                    if (check_rc(buffer,"GenericName[zh_CN]")==0 )
                    {
                        ReplaceStr(buffer,"GenericName[zh_CN] = ","");
                        ReplaceStr(buffer,"GenericName[zh_CN]= ","");
                        ReplaceStr(buffer,"GenericName[zh_CN] =","");
                        ReplaceStr(buffer,"GenericName[zh_CN]=","");
                        ReplaceStr(buffer,"GenericName[zh_CN]","");
//                        printf("GenericName[zh_CN]: %s\n",buffer);
                        sprintf(gene_zh,"%s",buffer);
                    }
                    else if (check_rc(buffer,"Comment[zh_CN]")==0 )
                    {
                        ReplaceStr(buffer,"Comment[zh_CN] = ","");
                        ReplaceStr(buffer,"Comment[zh_CN]= ","");
                        ReplaceStr(buffer,"Comment[zh_CN] =","");
                        ReplaceStr(buffer,"Comment[zh_CN]=","");
                        ReplaceStr(buffer,"Comment[zh_CN]","");
//                        printf("Comment[zh_CN]: %s\n",buffer);
                        sprintf(comment_zh,"%s",buffer);
                    }
                    else if (check_rc(buffer,"GenericName[")==0 )
                    {
                        //printf("Name[zh_CN]: %s\n",buffer);
                    }
                    else if (check_rc(buffer,"Name[zh_CN]")==0 )
                    {
                        ReplaceStr(buffer,"Name[zh_CN] = ","");
                        ReplaceStr(buffer,"Name[zh_CN]= ","");
                        ReplaceStr(buffer,"Name[zh_CN] =","");
                        ReplaceStr(buffer,"Name[zh_CN]=","");
                        ReplaceStr(buffer,"Name[zh_CN]","");
//                        printf("Name[zh_CN]: %s\n",buffer);
                        sprintf(name_zh,"%s",buffer);
                    }
                    else if (check_rc(buffer,"GenericName")==0 )
                    {
                        ReplaceStr(buffer,"GenericName = ","");
                        ReplaceStr(buffer,"GenericName= ","");
                        ReplaceStr(buffer,"GenericName =","");
                        ReplaceStr(buffer,"GenericName=","");
                        ReplaceStr(buffer,"GenericName","");
//                        printf("GenericName: %s\n",buffer);
                        sprintf(gene,"%s",buffer);
                    }
                    else if (check_rc(buffer,"Terminal")==0 )
                    {
                        ReplaceStr(buffer,"Terminal = ","");
                        ReplaceStr(buffer,"Terminal= ","");
                        ReplaceStr(buffer,"Terminal =","");
                        ReplaceStr(buffer,"Terminal=","");
                        ReplaceStr(buffer,"Terminal","");
//                        printf("Terminal: %s\n",buffer);
                        sprintf(term,"%s",buffer);
                    }
                    else if (check_rc(buffer,"Comment[")==0 )
                    {
                        //printf("Comment: %s\n",buffer);
                    }
                    else if (check_rc(buffer,"Comment")==0 )
                    {
                        ReplaceStr(buffer,"Comment = ","");
                        ReplaceStr(buffer,"Comment= ","");
                        ReplaceStr(buffer,"Comment =","");
                        ReplaceStr(buffer,"Comment=","");
                        ReplaceStr(buffer,"Comment","");
//                        printf("Comment: %s\n",buffer);
                        sprintf(comment,"%s",buffer);
                    }
                    else if (check_rc(buffer,"Name[")==0 )
                    {
                        //printf("Name: %s\n",buffer);
                    }
                    else if (check_rc(buffer,"Icon")==0 )
                    {
                        ReplaceStr(buffer,"Icon = ","");
                        ReplaceStr(buffer,"Icon =","");
                        ReplaceStr(buffer,"Icon= ","");
                        ReplaceStr(buffer,"Icon=","");
                        ReplaceStr(buffer,"Icon","");
//                        printf("Icon: %s\n",buffer);
                        sprintf(icon,"%s",buffer);
                    }
                    else if (check_rc(buffer,"Type")==0 )
                    {
                        ReplaceStr(buffer,"Type = ","");
                        ReplaceStr(buffer,"Type= ","");
                        ReplaceStr(buffer,"Type =","");
                        ReplaceStr(buffer,"Type=","");
                        ReplaceStr(buffer,"Type","");
//                        printf("Type: %s\n",buffer);
                        sprintf(type,"%s",buffer);
                    }
                    else if (check_rc(buffer,"Name")==0 )
                    {
                        ReplaceStr(buffer,"Name = ","");
                        ReplaceStr(buffer,"Name= ","");
                        ReplaceStr(buffer,"Name =","");
                        ReplaceStr(buffer,"Name=","");
                        ReplaceStr(buffer,"Name","");
//                        printf("Name: %s\n",buffer);
                        sprintf(name,"%s",buffer);
                    }
                    else if (check_rc(buffer,"Exec")==0 )
                    {
                        ReplaceStr(buffer,"Exec = ","");
                        ReplaceStr(buffer,"Exec= ","");
                        ReplaceStr(buffer,"Exec =","");
                        ReplaceStr(buffer,"Exec=","");
                        ReplaceStr(buffer,"Exec","");
//                        printf("Exec: %s \n",buffer);
                        get_str2(exec,buffer,1);
                    }
                    else if (check_rc(buffer,"URl")==0 )
                    {
                        ReplaceStr(buffer,"URL = ","");
                        ReplaceStr(buffer,"URL= ","");
                        ReplaceStr(buffer,"URL =","");
                        ReplaceStr(buffer,"URL=","");
                        ReplaceStr(buffer,"URL","");
//                        printf("URl: %s\n",buffer);
                        sprintf(url,"%s",buffer);
                    }
                }
                if ((strcmp(type,"Application")==0) or (strcmp(type,"application")==0) or (strcmp(type,"APPLICATION")==0) )
                {
                    if ((strcmp(term,"True")==0) or (strcmp(term,"true")==0) or (strcmp(term,"TRUE")==0) )
                    {
                        sprintf(icon_file,"%s/.icon-DE/icon-de.rc",home);
                        if (access(icon_file,0)!=-1)
                        {
                            fp2=fopen(icon_file,"r");
                        }
                        else if (access("usr/share/icon-DE/icon-de.rc",0)!=-1)
                            fp2=fopen("usr/share/icon-DE/icon-de.rc","r");
                        if (fp2==NULL)
                        {
                            printf("can't open ~/.icon-DE/icon-de.rc\n");
                        }
                        fgets(buffer,4096,fp2);
                        for (i=0;i<4096;i++)
                            if (buffer[i]=='\n') buffer[i]='\0';
                        while ( ! feof(fp2) )
                        {
                            if (check_rc(buffer,"c_term:")==0 )
                            {
                                ReplaceStr(buffer,"c_term:","");
                                sprintf(c_term,"%s",buffer);
                                printf("%s\n",c_term);
                            }
                            if (check_rc(buffer,"e_term:")==0 )
                            {
                                ReplaceStr(buffer,"e_term:","");
                                sprintf(e_term,"%s",buffer);
                                printf("%s\n",c_term);
                            }
                            fgets(buffer,4096,fp2);
                            for (i=0;i<4096;i++)
                                if (buffer[i]=='\n') buffer[i]='\0';
                        }
                        fclose(fp2);
                        sprintf(c_cmd,"%s %s %s &",c_term,e_term,exec);
                        system(c_cmd);
                        sleep(3);
                        if (get_active_window(disp)!=0)
                        if (get_window_title(disp,get_active_window(disp))!=NULL)
                            sprintf(title,"%s",get_window_title(disp,get_active_window(disp)));
                        if (strcmp(name_zh,"N/A")==0 )
                        {
                            printf("%s \"%s\" \"%s\" \"%s\" ",icon,c_cmd,name,title);
                            sprintf(c_rc,"%s \"%s\" \"%s\" \"%s\" ",icon,c_cmd,name,title);
                        }
                        else
                        {
                            printf("%s \"%s\" \"%s\" \"%s\" ",icon,c_cmd,name_zh,title);
                            sprintf(c_rc,"%s \"%s\" \"%s\" \"%s\" ",icon,c_cmd,name_zh,title);
                        }
                    }
                    else
                    {
                        sprintf(c_cmd,"%s &",exec);
                        system(c_cmd);
                        sleep(3);
                        if (get_active_window(disp)!=0)
                        if (get_window_title(disp,get_active_window(disp))!=NULL)
                            sprintf(title,"%s",get_window_title(disp,get_active_window(disp)));
                        if (strcmp(name_zh,"N/A")==0 )
                        {
                            printf("%s \"%s\" \"%s\" \"%s\" ",icon,exec,name,title);
                            sprintf(c_rc,"%s \"%s\" \"%s\" \"%s\" ",icon,exec,name,title);
                        }
                        else
                        {
                            printf("%s \"%s\" \"%s\" \"%s\" ",icon,exec,name_zh,title);
                            sprintf(c_rc,"%s \"%s\" \"%s\" \"%s\" ",icon,exec,name_zh,title);
                        }
                    }  
                } else
                {
                    if (strcmp(url,"N/A")!=0)
                    {
                        sprintf(icon_file,"%s/.icon-DE/icon-de.rc",home);
                        if (access(icon_file,0)!=-1)
                        {
                            fp2=fopen(icon_file,"r");
                        }
                        else if (access("usr/share/icon-DE/icon-de.rc",0)!=-1)
                            fp2=fopen("usr/share/icon-DE/icon-de.rc","r");
                        if (fp2==NULL)
                        {
                            printf("can't open ~/.icon-DE/icon-de.rc\n");
                        }
                        fgets(buffer,4096,fp2);
                        for (i=0;i<4096;i++)
                            if (buffer[i]=='\n') buffer[i]='\0';
                        while ( ! feof(fp2) )
                        {
                            if (check_rc(buffer,"c_brower:")==0 )
                            {
                                ReplaceStr(buffer,"c_brower:","");
                                sprintf(c_term,"%s",buffer);
                                printf("%s\n",c_term);
                            }
                            fgets(buffer,4096,fp2);
                            for (i=0;i<4096;i++)
                                if (buffer[i]=='\n') buffer[i]='\0';
                        }
                        fclose(fp2);
                        sprintf(c_cmd,"%s %s &",c_term,exec);
                        system(c_cmd);
                        sleep(3);
                        if (get_active_window(disp)!=0)
                        if (get_window_title(disp,get_active_window(disp))!=NULL)
                            sprintf(title,"%s",get_window_title(disp,get_active_window(disp)));
                        if (strcmp(name_zh,"N/A")==0 )
                        {
                            printf("%s \"%s\" \"%s\" \"%s\" ",icon,c_cmd,name,title);
                            sprintf(c_rc,"%s \"%s\" \"%s\" \"%s\" ",icon,c_cmd,name,title);
                        }
                        else
                        {
                            printf("%s \"%s\" \"%s\" \"%s\" ",icon,c_cmd,name_zh,title);
                            sprintf(c_rc,"%s \"%s\" \"%s\" \"%s\" ",icon,c_cmd,name_zh,title);
                        }
                    }
                }
            } else
            {
                printf("打开的不是Desktop Entry文件！！\n");
            } 
            fclose(fp);
        }    
    } else {
        printf("not open 2\n");
    }
    return c_rc;

}
//Convert an atom name in to a std::string
string GetAtomName(Display* disp, Atom a)
{
    if(a == None)
        return "None";
    else
        return XGetAtomName(disp, a);
}

struct Property
{
    unsigned char *data;
    int format, nitems;
    Atom type;
};

void set_targets_property(Display* disp, Window w, map<Atom, string>& typed_data, Atom property)
{

    vector<Atom> targets; targets.push_back(XA_TARGETS);
    targets.push_back(XA_multiple);


    for(map<Atom,string>::const_iterator i=typed_data.begin(); i != typed_data.end(); i++)
        targets.push_back(i->first);

        
//    cout << "Offering: ";
    for(unsigned int i=0; i < targets.size(); i++)
//        cout << GetAtomName(disp, targets[i]) << "  ";
//    cout << endl;

    //Fill up this property with a list of targets.
    XChangeProperty(disp, w, property, XA_ATOM, 32, PropModeReplace, 
                    (unsigned char*)&targets[0], targets.size());
}


//This function essentially performs the paste operation: by converting the
//stored data in to a format acceptable to the destination and replying
//with an acknowledgement.
void process_selection_request(XEvent e, map<Atom, string>& typed_data)
{

    if(e.type != SelectionRequest)
        return;

    //Extract the relavent data
//    Window owner     = e.xselectionrequest.owner;
    Atom selection   = e.xselectionrequest.selection;
    Atom target      = e.xselectionrequest.target;
    Atom property    = e.xselectionrequest.property;
    Window requestor = e.xselectionrequest.requestor;
    Time timestamp   = e.xselectionrequest.time;
    Display* disp    = e.xselection.display;

//    cout << "A selection request has arrived!\n";
//    cout << hex << "Owner = 0x" << owner << endl;
//    cout << "Selection atom = " << GetAtomName(disp, selection) << endl;    
//    cout << "Target atom    = " << GetAtomName(disp, target)    << endl;    
//    cout << "Property atom  = " << GetAtomName(disp, property) << endl;    
//    cout << hex << "Requestor = 0x" << requestor << dec << endl;
//    cout << "Timestamp = " << timestamp << endl;
    

    //X should only send requests for the selections since we own.
    //since we own exaclty one, we don't need to check it.

    //Replies to the application requesting a pasting are XEvenst
    //sent via XSendEvent
    XEvent s;

    //Start by constructing a refusal request.
    s.xselection.type = SelectionNotify;
    //s.xselection.serial     - filled in by server
    //s.xselection.send_event - filled in by server
    //s.xselection.display    - filled in by server
    s.xselection.requestor = requestor;
    s.xselection.selection = selection;
    s.xselection.target    = target;
    s.xselection.property  = None;   //This means refusal
    s.xselection.time      = timestamp;



    if(target ==XA_TARGETS)
    {
//        cout << "Replying with a target list.\n";
        set_targets_property(disp, requestor, typed_data, property);
        s.xselection.property = property;
    }
    else if(typed_data.count(target))
    {
        //We're asked to convert to one the formate we know about
//        cout << "Replying with which ever data I have" << endl;

        //Fill up the property with the URI.
        s.xselection.property = property;
        XChangeProperty(disp, requestor, property, target, 8, PropModeReplace, 
                        reinterpret_cast<const unsigned char*>(typed_data[target].c_str()), typed_data[target].size());
    }
    else if(target == XA_multiple)
    {
        //In this case, the property has been filled up with a list
        //of atom pairs. The pairs being (target, property). The 
        //processing should continue as if whole bunch of
        //SelectionRequest events had been received with the 
        //targets and properties specified.

        //The ICCCM is rather ambiguous and confusing on this particular point,
        //and I've never encountered a program which requests this (I can't 
        //test it), so I haven't implemented it.

//        cout << "MULTIPLE is not implemented. It should be, according to the ICCCM, but\n"
//             << "I've never encountered it, so I can't test it.\n";
    }
    else
    {    
        //We've been asked to converto to something we don't know 
        //about.
//        cout << "No valid conversion. Replying with refusal.\n";
    }
    
    //Reply
    XSendEvent(disp, e.xselectionrequest.requestor, True, 0, &s);
//    cout << endl;
}

//Find the applications top level window under the mouse.
Window find_app_window(Display* disp, Window w)
{
    //Drill down the windows under the mouse, looking for
    //the window with the XdndAware property.

    int nprops, i=0;
    Atom* a;

    if(w == 0)
        return 0;

    //Search for the WM_STATE property
    a = XListProperties(disp, w, &nprops);
    for(i=0; i < nprops; i++)
        if(a[i] == XA_XdndAware)
            break;

    if(nprops)
        XFree(a);

    if(i != nprops)
        return w;
    
    //Drill down one more level.
    Window child, wtmp;
    int tmp;
    unsigned int utmp;
    XQueryPointer(disp, w, &wtmp, &child, &tmp, &tmp, &tmp, &tmp, &utmp);

    return find_app_window(disp, child);
}

//This atom isn't provided by default
//Atom XA_TARGETS;


//This fetches all the data from a property
Property read_property(Display* disp, Window w, Atom property)
{
    Atom actual_type;
    int actual_format;
    unsigned long nitems;
    unsigned long bytes_after;
    unsigned char *ret=0;
    
    int read_bytes = 1024;    

    //Keep trying to read the property until there are no
    //bytes unread.
    do
    {
        if(ret != 0)
            XFree(ret);
        XGetWindowProperty(disp, w, property, 0, read_bytes, False, AnyPropertyType,
                            &actual_type, &actual_format, &nitems, &bytes_after, 
                            &ret);

        read_bytes *= 2;
    }while(bytes_after != 0);
    
//    cerr << endl;
//    cerr << "Actual type: " << GetAtomName(disp, actual_type) << endl;
//    cerr << "Actual format: " << actual_format << endl;
//    cerr << "Number of items: " << nitems <<    endl;

    Property p = {ret, actual_format, nitems, actual_type};

    return p;
}


// This function takes a list of targets which can be converted to (atom_list, nitems)
// and a list of acceptable targets with prioritees (datatypes). It returns the highest
// entry in datatypes which is also in atom_list: ie it finds the best match.
Atom pick_target_from_list(Display* disp, Atom* atom_list, int nitems, map<string, int> datatypes)
{
    Atom to_be_requested = None;
    //This is higger than the maximum priority.
    int priority=INT_MAX;

    for(int i=0; i < nitems; i++)
    {
        string atom_name = GetAtomName(disp, atom_list[i]);
//        cerr << "Type " << i << " = " << atom_name << endl;
    
        //See if this data type is allowed and of higher priority (closer to zero)
        //than the present one.
        if(datatypes.find(atom_name)!= datatypes.end())
            if(priority > datatypes[atom_name])
            {    
//                cerr << "Will request type: " << atom_name << endl;
                priority = datatypes[atom_name];
                to_be_requested = atom_list[i];
            }
    }

    return to_be_requested;
}

// Finds the best target given up to three atoms provided (any can be None).
// Useful for part of the Xdnd protocol.
Atom pick_target_from_atoms(Display* disp, Atom t1, Atom t2, Atom t3, map<string, int> datatypes)
{
    Atom atoms[3];
    int    n=0;

    if(t1 != None)
        atoms[n++] = t1;

    if(t2 != None)
        atoms[n++] = t2;

    if(t3 != None)
        atoms[n++] = t3;

    return pick_target_from_list(disp, atoms, n, datatypes);
}


// Finds the best target given a local copy of a property.
Atom pick_target_from_targets(Display* disp, Property p, map<string, int> datatypes)
{
    //The list of targets is a list of atoms, so it should have type XA_ATOM
    //but it may have the type TARGETS instead.

    if((p.type != XA_ATOM && p.type != XA_TARGETS) || p.format != 32)
    { 
        //This would be really broken. Targets have to be an atom list
        //and applications should support this. Nevertheless, some
        //seem broken (MATLAB 7, for instance), so ask for STRING
        //next instead as the lowest common denominator

        if(datatypes.count("STRING"))
            return XA_STRING;
        else
            return None;
    }
    else
    {
        Atom *atom_list = (Atom*)p.data;
        
        return pick_target_from_list(disp, atom_list, p.nitems, datatypes);
    }
}

int main(int argc, char **argv)
{
    int                         x, y;
    XEvent                      ev;
    const char                 *display_name = getenv("DISPLAY");
    Imlib_Image                 buffer4,buffer;
    Imlib_Font                  font;
    char                       text[1024];
    Imlib_Color_Range     range;
    int    text_w, text_h;
    if (display_name == NULL)
        display_name = ":0";
    disp = XOpenDisplay(display_name);
    if (disp == NULL)
    {
        fprintf(stderr, "Can't open display %s\n", display_name);
        return 1;
    }
    int screen=DefaultScreen(disp);
//    int screenWidth=0;
//    screenWidth=XDisplayWidth(disp,screen);
//    screenWidth=64;
//    int screenHeight;
//    screenHeight=64;
    int screenX=10;
    int screenY=10;
    int lowerraise=0;
    char group[64];
    char picname[1024];
    int mytoggle = 0;
    int mytoggle2 = 0;
    int store=0;
    int autohideSubbutton=0;
    int MouseMoveOpenSubIcon=0;
    char win_move[1024];
    char windows_where[1024]="0,0,0,1280,1024";
    char no_bord_where[1024]="0,0,0,1280,1024";
    int l_id;
    char usermenufile[1024];
    char submenue[1024];
    int sizemain=24;
    int gapmain=0;
    int sizesub=24;
    int gapsub=0;
    int autohidemainbutton=0;
    FILE *freeNum;
    unsigned int cur_icon;

    int bord;
    double trans_wind=0.85;
//    char title[1024];
    char skip[1024];
    char tiling_skip[1024]="N/A";
    
//    Atom selection  = XA_PRIMARY;
    XA_TARGETS = XInternAtom(disp, "TARGETS", False);
    XA_multiple = XInternAtom(disp, "MULTIPLE", False);
    XA_image_bmp = XInternAtom(disp, "image/bmp", False);
    XA_image_jpg = XInternAtom(disp, "image/jpeg", False);
    XA_image_tiff = XInternAtom(disp, "image/tiff", False);
    XA_image_png = XInternAtom(disp, "image/png", False);
    XA_text_uri_list = XInternAtom(disp, "text/uri-list", False);
    XA_text_uri= XInternAtom(disp, "text/uri", False);
    XA_text_plain = XInternAtom(disp, "text/plain", False);
    XA_text = XInternAtom(disp, "TEXT", False);
    XA_XdndSelection = XInternAtom(disp, "XdndSelection", False);
    XA_XdndAware = XInternAtom(disp, "XdndAware", False);
    XA_XdndEnter = XInternAtom(disp, "XdndEnter", False);
    XA_XdndLeave = XInternAtom(disp, "XdndLeave", False);
    XA_XdndTypeList = XInternAtom(disp, "XdndTypeList", False);
    XA_XdndPosition = XInternAtom(disp, "XdndPosition", False);
    XA_XdndActionCopy = XInternAtom(disp, "XdndActionCopy", False);
    XA_XdndStatus = XInternAtom(disp, "XdndStatus", False);
    XA_XdndDrop = XInternAtom(disp, "XdndDrop", False);
    XA_XdndFinished = XInternAtom(disp, "XdndFinished", False);
    map<Atom, string> typed_data; string url;
    url = "file://" + url;

    Window previous_window=0;          //Window found by the last MotionNotify event.
    int previous_version = -1;         //XDnD version of previous_window
    int status=UNAWARE;               
    Window root=RootWindow(disp, screen);
    Cursor grab_bad =XCreateFontCursor(disp, XC_gobbler);
    Cursor grab_maybe =XCreateFontCursor(disp, XC_circle);
    Cursor grab_good =XCreateFontCursor(disp, XC_sb_down_arrow);

    typed_data[XA_text_uri_list] = url;
    typed_data[XA_text_uri] = url;
    typed_data[XA_text_plain] = url;
    typed_data[XA_text] = url;
    typed_data[XA_STRING] = url;

    int gc=0;
    int gm=0;
    int gd=1;
    char ch2[1024];
    char c_cmd[1024];
    char f_buffer[4096];
    FILE * fp=NULL;
    FILE * fp2=NULL;
    char rc_group[64];
    int i=0;
    char f_buffer2[4096];
    int l_end;
    long g_id;
    int n=0;
    int o=0;
    double trans_icon=0.65;

    sprintf(home,"%s",getenv("HOME"));
    if ( strcmp(home,"") == 0 )
    {
        printf("fatal error: no /home/xxx found!\n");
        return 1;
    }
    Window                            cur_win_id;
    if (( argc == 1 )  or (argc>2))
    {
        bord=-1;
    }
    if ( argc == 2 ) 
    {
        sscanf(argv[1], "%d", &bord);
    }


    int c_red=255,c_green=200,c_blue=10,c_alpha=255;
    int f_red=0,f_green=0,f_blue=0,f_alpha=255;
    sprintf(usermenufile,"%s/.icon-DE/icon-de.rc",home);
    if (access(usermenufile,0)!=-1)
    {
        fp2=fopen(usermenufile,"r");
    }
    else if (access("usr/share/icon-DE/icon-de.rc",0)!=-1)
        fp2=fopen("usr/share/icon-DE/icon-de.rc","r");
    if (fp2==NULL)
    {
        printf("can't open ~/.icon-DE/icon-de.rc\n");
    }
    fgets(f_buffer,4096,fp2);
    for (i=0;i<4096;i++)
        if (f_buffer[i]=='\n') f_buffer[i]='\0';
    while ( ! feof(fp2) )
    {
        if (check_rc(f_buffer,"tag_color:")==0 )
        {
            get_str(ch2,f_buffer,"tag_color:");
            get_int2(c_red,ch2,1);
            get_int2(c_green,ch2,2);
            get_int2(c_blue,ch2,3);
            get_int2(c_alpha,ch2,4);
        }
        if (check_rc(f_buffer,"font_color:")==0 )
        {
            get_str(ch2,f_buffer,"font_color:");
            get_int2(f_red,ch2,1);
            get_int2(f_green,ch2,2);
            get_int2(f_blue,ch2,3);
            get_int2(f_alpha,ch2,4);
        }
        fgets(f_buffer,4096,fp2);
        for (i=0;i<4096;i++)
            if (f_buffer[i]=='\n') f_buffer[i]='\0';
    }
    fclose(fp2);

    char rcfile[10]="wharf.rc";
    sprintf(usermenufile,"%s/.icon-DE/%s",home,rcfile);
    if (access(usermenufile,0)==-1)
    {
        system("mkdir ~/.icon-DE");
        system("mkdir ~/.icon-DE/fonts");
        if (access("/usr/share/fonts/truetype/wqy/wqy-zenhei.ttc",0)!=-1)
            system("cp /usr/share/fonts/truetype/wqy/wqy-zenhei.ttc ~/.icon-DE/fonts/Vera.ttf");
        if (access("/usr/share/fonts/wenquanyi/wqy-zenhei/wqy-zenhei.ttc",0)!=-1)
            system("cp /usr/share/fonts/wenquanyi/wqy-zenhei/wqy-zenhei.ttc ~/.icon-DE/fonts/Vera.ttf");
        system("cp -a /usr/share/icon-DE/* ~/.icon-DE/");
        system("cp -a /etc/icon-de/* ~/.icon-DE/");
    }
    freeNum=fopen(usermenufile,"r");
    if ( freeNum==NULL)
    { 
        printf("error on open %s\n",usermenufile); 
        exit(1); 
    }
    fgets(f_buffer,1024,freeNum);
    l_id=1;
    while ( ! feof(freeNum) )
    {
        for (n=0;n<1024;n++)
            if (f_buffer[n]=='\n') f_buffer[n]='\0';
//        printf("%s\n",f_buffer); 
        for (n=0;n<1024;n++)
          submenue[n]='\0';
        if (strcmp(f_buffer,"")!=0 )
        {
            sprintf(ch2,"%c",f_buffer[0]);
            if (strcmp(ch2,"#")!=0 ) 
            {
                if (check_rc(f_buffer,"skip:")==0 )  get_str(skip,f_buffer,"skip:");
                if (check_rc(f_buffer,"tiling_skip:")==0 )  get_str(tiling_skip,f_buffer,"tiling_skip:");
                if ((bord==-1) and (check_rc(f_buffer,"have_title:")==0 ))  get_int(bord,f_buffer,"have_title:");
                if (check_rc(f_buffer,"trans_icon:")==0 )  get_double(trans_icon,f_buffer,"trans_icon:");
                if (check_rc(f_buffer,"trans_wind:")==0 )  get_double(trans_wind,f_buffer,"trans_wind:");
                if (check_rc(f_buffer,"windows_where:")==0 )  get_str(windows_where,f_buffer,"windows_where:");
                if (check_rc(f_buffer,"no_bord_where:")==0 )  get_str(no_bord_where,f_buffer,"no_bord_where:");
                if (check_rc(f_buffer,"baseconfig:")==0 )
                {
                    get_str(ch2,f_buffer,"baseconfig:");
                    get_int2(screenX,ch2,1);
                    get_int2(screenY,ch2,2);
                    get_int2(sizemain,ch2,3);
                    get_int2(gapmain,ch2,4);
                    get_int2(sizesub,ch2,5);
                    get_int2(gapsub,ch2,6);
                    get_int2(lowerraise,ch2,7);
                    get_int2(autohidemainbutton,ch2,8);
                    get_int2(autohideSubbutton,ch2,9);
                    get_int2(MouseMoveOpenSubIcon,ch2,10);
                }
                if (check_rc(f_buffer,"group")==0 )
                {
                    get_group(rc_group,ch2,f_buffer,"group");
                    sprintf(group,"%s",rc_group);
                    o=0;
                    gc=gc+1;
                }
                else
                {
                    if (check_rc(f_buffer,"single")==0 )
                    {
                        get_group(rc_group,ch2,f_buffer,"group");
                        sprintf(group,"%s",rc_group);
                        o=0;
                        gc=gc+1;
                    } else {
                        if (check_rc(f_buffer,"dock")==0 )
                        {
                            get_group(rc_group,ch2,f_buffer,"dock");
                            sprintf(group,"%s",rc_group);
                            o=0;
                            gd=gd+1;
                        }
                        else
                        {
                            if (strcmp(rc_group,group)==0 )
                            {
                                o=o+1;
                                if (gm<o)
                                    gm=o;
                            }
                        }
                    }    
                }     
            } 
        }
        fgets(f_buffer,1024,freeNum);
        l_id=l_id+1;
    }
    fclose(freeNum);
    if (bord==0)
        sprintf(win_move,"%s",windows_where);
    else
        sprintf(win_move,"%s",no_bord_where);
    vector<icon> icon_list(gc+gm);
    vis = DefaultVisual(disp, DefaultScreen(disp));
    depth = DefaultDepth(disp, DefaultScreen(disp));
    cm = DefaultColormap(disp, DefaultScreen(disp));
                // text

    range = imlib_create_color_range();
    imlib_context_set_color_range(range);
    imlib_context_set_color(255, 255, 255, 255);
    imlib_add_color_to_color_range(0);
    /* add an orange color, semi-transparent 10 units from the first */
    imlib_context_set_color(c_red, c_green, c_blue, c_alpha);
    printf("%d,%d,%d,%d\n",c_red, c_green, c_blue, c_alpha);
//    imlib_context_set_color(255, 200, 10, 255);
    imlib_add_color_to_color_range(10);
    /* add black, fully transparent at the end 20 units away */
    imlib_context_set_color(70, 0, 0, 255);
    imlib_add_color_to_color_range(20);


     /**
        * Start rendering
        */

    imlib_context_set_display(disp);
    imlib_context_set_visual(vis);
    imlib_context_set_colormap(cm);
    imlib_context_set_drawable(icon_list[0].w_id);
    imlib_context_set_dither(1);
    imlib_context_set_blend(0);
    imlib_context_set_color_modifier(NULL);

//--
    char back_pic[1280],mouse_pic[1280];
    sprintf(back_pic,"%s/.icon-DE/pics/background.png",home);
    if (access(back_pic,0)==-1)
        sprintf(back_pic,"/usr/share/icon-DE/pics/background.png");
    back = imlib_load_image(back_pic);
    long cur_win=0;
    n=0;
    gc=0;
    gd=0;
    l_id=0;
    freeNum=fopen(usermenufile,"r");

    fgets(f_buffer,1024,freeNum);
    l_id=l_id+1;

    imenu m_menu; //自制的对话框。
    int have_m_menu=0;
    int d_icon=0;

    while ( ! feof(freeNum) )
    {
        for (n=0;n<1024;n++)
            if (f_buffer[n]=='\n') f_buffer[n]='\0';
        if (strcmp(f_buffer,"")!=0 )
        {
            sprintf(ch2,"%c",f_buffer[0]);
            if (strcmp(ch2,"#")!=0 ) 
            {
                if (check_rc(f_buffer,"group")==0 )
                {
                    get_group(rc_group,ch2,f_buffer,"group");
                    sprintf(icon_list[gc-1].group,"%s",rc_group);
                    if (gc>0)
                    {
                        get_str2(picname,ch2,1);
                        get_str2(icon_list[gc-1].tag,ch2,2);
                        icon_list[gc-1].s_g=1;
                        Creat_icon(screenX,screenY+gc*(sizemain+gapmain),sizemain,gc-1,l_id,picname,lowerraise,trans_icon,autohideSubbutton,icon_list);
                    }
                    gc=gc+1;
                }
                else
                {
                    if (check_rc(f_buffer,"single")==0 )
                    {
                        get_group(rc_group,ch2,f_buffer,"single");
                        sprintf(icon_list[gc-1].group,"%s",rc_group);
                        get_str2(picname,ch2,1);
                        get_str2(icon_list[gc-1].apps,ch2,2);
                        get_str2(icon_list[gc-1].tag,ch2,3);
                        get_str2(icon_list[gc-1].title,ch2,4);
                        icon_list[gc-1].s_g=0;
                        Creat_icon(screenX,screenY+gc*(sizemain+gapmain),sizemain,gc-1,l_id,picname,lowerraise,trans_icon,autohideSubbutton,icon_list);
                        gc=gc+1;
                    }
                }     
            } 
        }
        fgets(f_buffer,1024,freeNum);
        l_id=l_id+1;
    }
    fclose(freeNum);
    x=sizemain+15;
    y=sizemain+15;
    int r_flash=1;
    for (i=0;i<gc-1;i++)
    {
        if (icon_list[i].w_id!=0)
        {
            icon_filter(x,y,i,lowerraise,0,icon_list);
        }
    }
    cur_icon = icon_list[0].w_id;
    char font_path[1024];
    sprintf(font_path,"%s/.icon-DE/fonts",home);
    imlib_add_path_to_font_path(font_path);
    imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
    imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");

    int can_close,cur_times;
    can_close=0;
    cur_times=0;
    int tra=0;

    map<string, int> datatypes;
    datatypes["text/uri-list"] = 1;
    datatypes["STRING"] = 2;
    Atom sel = XInternAtom(disp, "PRIMARY", 0);
    Atom XdndEnter = XInternAtom(disp, "XdndEnter", False);
    Atom XdndPosition = XInternAtom(disp, "XdndPosition", False);
    Atom XdndStatus = XInternAtom(disp, "XdndStatus", False);
    Atom XdndTypeList = XInternAtom(disp, "XdndTypeList", False);
    Atom XdndActionCopy = XInternAtom(disp, "XdndActionCopy", False);
    Atom XdndDrop = XInternAtom(disp, "XdndDrop", False);
    Atom XdndLeave = XInternAtom(disp, "XdndLeave", False);
    Atom XdndFinished = XInternAtom(disp, "XdndFinished", False);
    Atom XdndSelection = XInternAtom(disp, "XdndSelection", False);
//    Atom XdndProxy = XInternAtom(disp, "XdndProxy", False);
//    Window drop_window;
//    Atom XdndAware = XInternAtom(disp, "XdndAware", False);
//    Atom version=5;
    XA_TARGETS = XInternAtom(disp, "TARGETS", False);
    XFlush(disp);
    Atom to_be_requested = None;
    bool sent_request = 0;
    int xdnd_version=0;
    Window xdnd_source_window=None;
    Atom target = ev.xselection.target;

    bool dragging=0,m_mouse=0;                   //Are we currently dragging
    int have_press=0;
    int have_release=0;
    int m_button=0;
    int have_win2=0;
    int xfd = ConnectionNumber(disp);
    long ticks;
    fd_set rfds;
//    time_t now_time;
    struct timeval now, tm,LastTime;
    int fx;

    while (1)
    {
        if (XPending(disp))
        {
            XNextEvent(disp, &ev);
            if (XFilterEvent(&ev, None))  //imenu用的
                continue;                //同上
            switch (ev.type)
            {
            case SelectionClear:
//                cout  << "SelectionClear event received. Quitting.\n";
                break;
            case SelectionRequest:
                process_selection_request(ev, typed_data);
                break;
            case ClientMessage:
//                printf("ClientMessage!\n");
                if(ev.xclient.message_type == XdndEnter)
                {
                    bool more_than_3 = ev.xclient.data.l[1] & 1;
                    Window source = ev.xclient.data.l[0];
                    xdnd_version = ( ev.xclient.data.l[1] >> 24);
                    if(more_than_3)
                    {
                        //Fetch the list of possible conversions
                        //Notice the similarity to TARGETS with pastev.
                        Property p = read_property(disp, source , XdndTypeList);
                        to_be_requested = pick_target_from_targets(disp, p, datatypes);
                        XFree(p.data);
                    }
                    else
                    {
                        //Use the available list
                        to_be_requested = pick_target_from_atoms(disp, ev.xclient.data.l[2], ev.xclient.data.l[3], ev.xclient.data.l[4], datatypes);
                    }
            }
            else if(ev.xclient.message_type == XdndPosition)
            {
//                    Atom action=XdndActionCopy;
                    if(xdnd_version >= 2)
                        action = ev.xclient.data.l[4];
                    //Xdnd: reply with an XDND status message
                    XClientMessageEvent m;
                    memset(&m, sizeof(m), 0);
                    m.type = ClientMessage;
                    m.display = ev.xclient.display;
                    m.window = ev.xclient.data.l[0];
                    m.message_type = XdndStatus;
                    m.format=32;
                    m.data.l[0] = ev.xmotion.window;
                    m.data.l[1] = (to_be_requested != None);
                    m.data.l[2] = 0; //Specify an empty rectangle
                    m.data.l[3] = 0;
                    m.data.l[4] = XdndActionCopy; //We only accept copying anyway.
                    cur_icon=ev.xmotion.window;

                    XSendEvent(disp, ev.xclient.data.l[0], False, NoEventMask, (XEvent*)&m);
                    XFlush(disp);
            }
            else if(ev.xclient.message_type == XdndLeave)
            {
                    //to_be_requested = None;

                    //We can't actually reset to_be_requested, since OOffice always
                    //sends this event, even when it doesn't mean to.
                    cerr << "Xdnd cancelled.\n";
            }
            else if(ev.xclient.message_type == XdndDrop)
            {
                    if(to_be_requested == None)
                    {
                        //It's sending anyway, despite instructions to the contrary.
                        //So reply that we're not interested.
                        XClientMessageEvent m;
                        memset(&m, sizeof(m), 0);
                        m.type = ClientMessage;
                        m.display = ev.xclient.display;
                        m.window = ev.xclient.data.l[0];
                        m.message_type = XdndFinished;
                        m.format=32;
                        m.data.l[0] = ev.xmotion.window;
                        m.data.l[1] = 0;
                        m.data.l[2] = None; //Failed.
                        XSendEvent(disp, ev.xclient.data.l[0], False, NoEventMask, (XEvent*)&m);
                        cur_icon=ev.xmotion.window;
                    }
                    else
                    {
                        xdnd_source_window = ev.xclient.data.l[0];
                        if(xdnd_version >= 1)
                            XConvertSelection(disp, XdndSelection, to_be_requested, sel, icon_list[0].w_id, ev.xclient.data.l[2]);
                        else
                            XConvertSelection(disp, XdndSelection, to_be_requested, sel, icon_list[0].w_id, CurrentTime);
                    }
                }
                break;
            case SelectionNotify:
                target = ev.xselection.target;
                if(ev.xselection.property == None)
                {
                    //If the selection can not be converted, quit with error 2.
                    //If TARGETS can not be converted (nothing owns the selection)
                    //then quit with code 3.
                    //return 2 + (target == XA_TARGETS);
                }
                else 
                {
                    Property prop = read_property(disp, icon_list[0].w_id, sel);

                    //If we're being given a list of targets (possible conversions)
                    if(target == XA_TARGETS && !sent_request)
                    {
                        sent_request = 1;
                        to_be_requested = pick_target_from_targets(disp, prop, datatypes);

                        if(to_be_requested == None)
                        {
                                cerr << "No matching datatypes.\n";
                                return 1;
                        }
                        else //Request the data type we are able to select
                        {
//                                cerr << "Now requsting type " << GetAtomName(disp, to_be_requested) << endl;
                                XConvertSelection(disp, sel, to_be_requested, sel, icon_list[0].w_id, CurrentTime);
                        }
                    }
                    else if (target == to_be_requested)
                    {
                        //Dump the binary data
//                        cout.write((char*)prop.data, prop.nitems * prop.format/8);

                        XClientMessageEvent m;
                        memset(&m, sizeof(m), 0);
                        m.type = ClientMessage;
                        m.display = disp;
                        m.window = xdnd_source_window;
                        m.message_type = XdndFinished;
                        m.format=32;
                        m.data.l[0] = cur_icon;
                        m.data.l[1] = 1;
                        m.data.l[2] = XdndActionCopy; //We only ever copy.
                         //Reply that all is well.
                        XSendEvent(disp, xdnd_source_window, False, NoEventMask, (XEvent*)&m);
                        //Un-proxy the root window
    //                        return 0;

                        for (i=0;i<gc-1;i++)
                        {
                            if (icon_list[i].w_id==cur_icon)
                                break;
                        }
                        d_icon=i;
                        if (icon_list[d_icon].s_g==1)
                        {
                            char c_cr[1024];
                            sprintf(c_cr,"%s\n",read_desktop_entry((char *)prop.data));
                            
                            //2012.08.06,调用imenu来修改自动生成的参数。
                            
                            init_button(m_menu);
                            m_menu.t_group=0;
                            m_menu.show_lines=5;
                            m_menu.x=100;
                            m_menu.y=60;
                            m_menu.width1=700;
                            m_menu.width2=80;
                            m_menu.width3=60;
                            m_menu.width4=348;
                            m_menu.width_text=700;
                            m_menu.height=25;
                            m_menu.w_gap=3;
                            m_menu.h_gap=15;

                            m_menu.menu1.flash=1;
                            m_menu.menu1.group=-1;
                            m_menu.menu1.hide=0;
                            m_menu.b_up.hide=1;
                            m_menu.b_down.hide=1;
                            m_menu.menu4[0].hide=0;
                            m_menu.menu4[1].selected=0;
                            sprintf(m_menu.menu1.text,"自动生成了配置文件的一行，请根据需要修改他。");
                            sprintf(m_menu.input.text,"如果你不理解这些内容的意义，请直接按“确定”");
                            sprintf(m_menu.input.tag_text,"%s",c_cr);
                            m_menu.input.hide=0;
                            m_menu.input.w_id=0;
                            for (n=0;n<1024;n++)  //计算字符串长度、和光标位置
                            {
                                if (m_menu.input.tag_text[n]=='\0') break;
                                if ((m_menu.input.tag_text[n]=='\n') or (m_menu.input.tag_text[n]=='\r'))
                                {
                                    m_menu.input.tag_text[n]='\0';
                                    break;
                                }
                            }
                            m_menu.input.str_len=n;
                            m_menu.input.cur=n;
                            creat_button(disp,m_menu);
                            have_m_menu=1;

                            //创建完毕，现在转入“ButtonPress”和“KeyPress”去处理。
                        }
                        else
                        {
                            init_button(m_menu);
                            m_menu.t_group=0;
                            m_menu.show_lines=5;
                            m_menu.x=100;
                            m_menu.y=60;
                            m_menu.width1=700;
                            m_menu.width2=80;
                            m_menu.width3=60;
                            m_menu.width4=700;
                            m_menu.width_text=700;
                            m_menu.height=25;
                            m_menu.w_gap=3;
                            m_menu.h_gap=15;

                            m_menu.menu1.flash=1;
                            m_menu.menu1.group=-1;
                            m_menu.menu1.hide=0;
                            m_menu.b_up.hide=1;
                            m_menu.b_down.hide=1;
                            m_menu.menu4[0].hide=1;
                            m_menu.menu4[1].selected=0;
                            sprintf(m_menu.menu1.text,"你把.desktop文件拖入到了独立icon内，无效！！请拖入2级icon内！");
                            m_menu.input.hide=1;
                            m_menu.input.w_id=0;
                            for (n=0;n<1024;n++)  //计算字符串长度、和光标位置
                            {
                                if (m_menu.input.tag_text[n]=='\0') break;
                                if ((m_menu.input.tag_text[n]=='\n') or (m_menu.input.tag_text[n]=='\r'))
                                {
                                    m_menu.input.tag_text[n]='\0';
                                    break;
                                }
                            }
                            m_menu.input.str_len=n;
                            m_menu.input.cur=n;
                            creat_button(disp,m_menu);
                            have_m_menu=1;

                            //创建完毕，现在转入“ButtonPress”和“KeyPress”去处理。
                        }
                        XFree(prop.data);
                    }
                    cerr << endl;
                }
//                printf("SelectionNotify;\n");
                break;
            case KeyPress:
                if (have_m_menu==1)
                    input_text(disp,ev,m_menu);  //处理m_menu的键盘录入
                break;
            case Expose:
                break;
            case MotionNotify:
                r_flash=1;
                if (( m_mouse == 0 ) and (dragging!=1))
                    cur_icon = ev.xmotion.window;
                x = ev.xmotion.x;
                y = ev.xmotion.y;
                if (dragging == 1)
                {
                    Window window=0;
                    int version=-1;
//                    unsigned char *data = 0;
                    window = find_app_window(disp, root);
                    if(window == previous_window)
                        version = previous_version;
//                    else
//                    {
//                        version = data[0];
//                    }
                    if(status == UNAWARE && version != -1)
                        status = UNRECEPTIVE;
                    else if(version == -1)
                        status = UNAWARE;
                    //Update the pointer state.
                    if(status == UNAWARE)
                        XChangeActivePointerGrab(disp, Button1MotionMask | ButtonReleaseMask, grab_bad, CurrentTime);
                    else if(status == UNRECEPTIVE)
                        XChangeActivePointerGrab(disp, Button1MotionMask | ButtonReleaseMask, grab_maybe, CurrentTime);
                    else
                        XChangeActivePointerGrab(disp, Button1MotionMask | ButtonReleaseMask, grab_good, CurrentTime);
                    if(window != previous_window && previous_version != -1)
                    {
                        XClientMessageEvent m;
                        memset(&m, sizeof(m), 0);
                        m.type = ClientMessage;
                        m.display = ev.xclient.display;
                        m.window = previous_window;
                        m.message_type = XA_XdndLeave;
                        m.format=32;
                        m.data.l[0] = cur_icon;
                        m.data.l[1] = 0;
                        m.data.l[2] = 0;
                        m.data.l[3] = 0;
                        m.data.l[4] = 0;

                        XSendEvent(disp, previous_window, False, NoEventMask, (XEvent*)&m);
                        XFlush(disp);
                    }
                    if(window != previous_window && version != -1)
                    {    
                        map<Atom, string>::const_iterator i = typed_data.begin();
                        XClientMessageEvent m;
                        memset(&m, sizeof(m), 0);
                        m.type = ClientMessage;
                        m.display = ev.xclient.display;
                        m.window = window;
                        m.message_type = XA_XdndEnter;
                        m.format=32;
                        m.data.l[0] = cur_icon;
                        m.data.l[1] = min(5, version) << 24  |  (typed_data.size() > 3);
                        m.data.l[2] = typed_data.size() > 0 ? i++->first : 0;
                        m.data.l[3] = typed_data.size() > 1 ? i++->first : 0;
                        m.data.l[4] = typed_data.size() > 2 ? i->first : 0;
                        XSendEvent(disp, window, False, NoEventMask, (XEvent*)&m);
                        XFlush(disp);
                    }
                    if(version != -1)
                    {
                        int x, y, tmp;
                        unsigned int utmp;
                        Window wtmp;
                        XQueryPointer(disp, window, &wtmp, &wtmp, &tmp, &tmp, &x, &y, &utmp);
                        XClientMessageEvent m;
                        memset(&m, sizeof(m), 0);
                        m.type = ClientMessage;
                        m.display = ev.xclient.display;
                        m.window = window;
                        m.message_type = XA_XdndPosition;
                        m.format=32;
                        m.data.l[0] = cur_icon;
                        m.data.l[1] = 0;
                        m.data.l[2] = (x <<16) | y;
                        m.data.l[3] = CurrentTime; //Our data is not time dependent, so send a generic timestamp;
                        m.data.l[4] = XA_XdndActionCopy;
                        XSendEvent(disp, window, False, NoEventMask, (XEvent*)&m);
                        XFlush(disp);

                    }
                    previous_window = window;    
                    previous_version = version;
                    Window        QueryRoot, QueryChild;
                    int           AbsoluteX, AbsoluteY;
                    int           RelativeX, RelativeY;
                    unsigned int    ModKeyMask;
                    
                    XQueryPointer(disp, root,
                        &QueryRoot, &QueryChild,
                        &AbsoluteX, &AbsoluteY,
                        &RelativeX, &RelativeY,
                        &ModKeyMask);
                    XMoveWindow(disp,cur_icon,AbsoluteX-10 , AbsoluteY-10);
                    if (AbsoluteX<=5)
                    {
                        screenX=0;
                        screenY=AbsoluteY;
                    }

                    else if (AbsoluteX<sizesub)
                    {
                        screenX=AbsoluteX-(int)(sizesub/3);
                        screenY=AbsoluteY;
                    }
                    else
                    {
                        screenX=AbsoluteX;
                        screenY=AbsoluteY;
                    }
                }
                break;
            default:
                break;
            case EnterNotify:
                r_flash=1;
                if (( m_mouse == 0 ) and (dragging!=1))
                    cur_icon = ev.xmotion.window;
                mytoggle = 1;
                x = ev.xmotion.x;
                y = ev.xmotion.y;
                if ((dragging == 0) and (m_mouse==0) and (have_m_menu==0))
                {
                    for (i=0;i<gc+gm-1;i++)
                    {
                        if (icon_list[i].w_id==cur_icon)
                            break;
                    }
                    buffer = imlib_create_image(1000, 30);    
                    font = imlib_load_font("Vera/8");
                    if (font == NULL)
                        font = imlib_load_font("wqy-zenhei.ttc/8");
                    imlib_context_set_font(font);
                    imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
                    sprintf(text,"%s",icon_list[i].tag);
                    imlib_get_text_size(text, &text_w, &text_h);
                    if (i<gc)
                        win2=XCreateWindow(disp,DefaultRootWindow(disp),icon_list[i].x+sizemain+4,icon_list[i].y-18,text_w+40,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
                    else
                        win2=XCreateWindow(disp,DefaultRootWindow(disp),icon_list[i].x+sizesub+4,icon_list[i].y-18,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
                    have_win2=1;
                    XRaiseWindow(disp,win2);
                    XMapWindow(disp, win2);
                    imlib_context_set_drawable(win2); 
    //                imlib_context_set_image(buffer);
                    imlib_context_set_image(buffer);
                    imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
                //         imlib_free_color_range();
                    imlib_context_set_image(buffer);
                    imlib_render_image_on_drawable(0, 0); 
                    imlib_context_set_image(buffer);
                    imlib_context_set_font(font);
                    imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
                    imlib_text_draw(5,2,text);
                    imlib_context_set_image(buffer);
                    imlib_context_set_drawable(win2); 
                    imlib_render_image_on_drawable(0, 0); 
                    imlib_context_set_image(buffer);
                    imlib_free_image();
                    imlib_context_set_font(font);
                    imlib_free_font();
                    imlib_context_set_image(icon_list[i].im_bg);
                    imlib_context_set_drawable(icon_list[i].w_id);
                    if ((i<gc) and ((MouseMoveOpenSubIcon==1) or (MouseMoveOpenSubIcon==2)))
                    {
                        if(lowerraise==0)
                             XLowerWindow(disp,icon_list[i].w_id);
                        if ((lowerraise==1) or (lowerraise==2))
                             XRaiseWindow(disp,icon_list[i].w_id);
                        mytoggle = 1;

                        Destroy_icon(gc,gc+gm,icon_list);

                        XMoveWindow(disp,icon_list[i].w_id,icon_list[i].x , icon_list[i].y); 
                        int q=gc;
                        freeNum=fopen(usermenufile,"r");
                        l_id=0;
                        while ( ! feof(freeNum) )
                        {
                            fgets(f_buffer,1024,freeNum);
                            l_id=l_id+1;
                            for (n=0;n<1024;n++)
                                if (f_buffer[n]=='\n') f_buffer[n]='\0';
    //                        printf("%s\n",f_buffer); 
                            if (strcmp(f_buffer,"")!=0 )
                            {
                                sprintf(ch2,"%c",f_buffer[0]);
                                if (strcmp(ch2,"#")!=0 ) 
                                {

                                    if (check_rc(f_buffer,"group")==0 )
                                        get_group(rc_group,ch2,f_buffer,"group");
                                    else
                                    {
                                        if (check_rc(f_buffer,"single")==0 )
                                            get_group(rc_group,ch2,f_buffer,"single");
                                        else
                                        {
                                            if ((strcmp(rc_group,icon_list[i].group)==0) and (icon_list[i].s_g==1))
                                            {
                                                get_str2(picname,f_buffer,1);
                                                get_str2(icon_list[q].apps,f_buffer,2);
                                                get_str2(icon_list[q].tag,f_buffer,3);
                                                get_str2(icon_list[q].title,f_buffer,4);
                                                icon_list[q].s_g=2;
                                                Creat_icon(icon_list[i].x+gapsub+(sizesub+gapsub)*(q-gc+1),icon_list[i].y-((sizesub-sizemain)/2),sizesub,q,l_id,picname,lowerraise,trans_icon,0,icon_list);
                                                q=q+1;
                                            }
                                        }
                                    }     
                                } 
                            }
                        } 
                        fclose(freeNum); 
                        for (i=gc;i<gc+gm-1;i++)
                        {
                            icon_filter(sizesub+15,sizesub+15,i,lowerraise,0,icon_list);
                        }
                    }
                } 
                break;
            case LeaveNotify:
                r_flash=1;
                cur_times=0;
                if (( m_mouse == 0 ) and (dragging!=1))
                    cur_icon = ev.xmotion.window;
                for (i=0;i<gc+gm-1;i++)
                {
                    if (icon_list[i].w_id==cur_icon)
                        break;
                }
                mytoggle = 0;
                if (i<gc)
                {
                    x = sizemain+15;
                    y = sizemain+15;
                    if (m_mouse!=1)
                    {
                        if ( mytoggle2 == 1)
                        {
                            if ((win_pid_list[cur_win]!=0) and (icon_list[i].s_g==1))
                            {
                                action_window(disp,win_pid_list[cur_win],'a');
                                if (strstr(tiling_skip,get_window_class(disp, win_pid_list[cur_win]))==NULL)
                                {
                                    init_window(win_pid_list[cur_win]);
                                    window_move_resize(disp,win_pid_list[cur_win],win_move);
                                }
                            }    
                            mytoggle2 = 0;
                        }        
                        store=0;
                        if (autohideSubbutton==1)
                            XMoveWindow(disp,icon_list[i].w_id,-sizemain+2 , icon_list[i].y);
                        if (autohideSubbutton==2)
                            XMoveWindow(disp,icon_list[i].w_id,-sizemain/2 , icon_list[i].y);
                    }
                }
                else
                {
                    x = sizesub+15;
                    y = sizesub+15;
                }
                if (have_win2==1)
                {
                    XDestroyWindow(disp,win2);
                    have_win2=0;
                }
                if (m_mouse==1)
                {
                    imlib_context_set_drawable(win4); 
                    imlib_context_set_image(buffer4);
                    imlib_render_image_on_drawable(0, 0);
                }
                icon_filter(x,y,i,lowerraise,mytoggle,icon_list);
                break;
            case ButtonPress:
                r_flash=1;
                if (have_m_menu==1)
                {
                    i=click_button(disp,ev.xmotion.window,m_menu);
                    if (i==0)
                    {
                        have_m_menu=0;
                        sprintf(submenue,"%s/.icon-DE/wharf.rc",home);
                        if (access(submenue,0)!=-1)
                        {
                            
                            sprintf(c_cmd,"cp -f %s %s~",submenue,submenue);
    //                            printf("%s\n",c_cmd);
                            system(c_cmd);
                            sprintf(submenue,"%s/.icon-DE/wharf.rc~",home);
                            fp=fopen(submenue,"r");
                            if (fp==NULL)
                            {
                                printf("not open 1\n");
                            }
                            else
                            {
                                sprintf(submenue,"%s/.icon-DE/wharf.rc",home);
                                fp2=fopen(submenue,"w");
                                fgets(f_buffer,4096,fp);
                                n=1;
                                while ( ! feof(fp) )
                                {
                                    fputs(f_buffer,fp2);
                                    if ( n==icon_list[d_icon].l_id )
                                    {
                                        fputs(m_menu.input.tag_text,fp2);
                                        fputs("\n",fp2);
                                    }
                                    fgets(f_buffer,4096,fp);
                                    n=n+1;
                                }
                            }
                            fclose(fp);
                            fclose(fp2);
                            sleep(2);
                            sprintf(submenue,"icon-wharf RESET");
                            system(submenue);
                        }
                    } else if (i==1)
                    {
                        destory_button(disp,m_menu);
                        if (autohideSubbutton==1)
                            XMoveWindow(disp,icon_list[d_icon].w_id,-sizemain+2 , icon_list[d_icon].y);
                        if (autohideSubbutton==2)
                            XMoveWindow(disp,icon_list[d_icon].w_id,-sizemain/2 , icon_list[d_icon].y);
                    }
                    break;
                }
                
                if (( m_mouse == 0 ) and (dragging!=1))
                    cur_icon = ev.xmotion.window;
                x = ev.xmotion.x;
                y = ev.xmotion.y;
                if(ev.xbutton.button==1)
                {
                    gettimeofday(&LastTime, 0);
                    have_press=1;
                    have_release=0;
                    dragging=0;
                }
                break;
            case ButtonRelease:
                r_flash=1;
                if (( m_mouse == 0 ) and (dragging!=1))
                    cur_icon = ev.xmotion.window;
                x = ev.xmotion.x;
                y = ev.xmotion.y;
                for (i=0;i<gc+gm-1;i++)
                {
                    if (icon_list[i].w_id==cur_icon)
                        break;
                }
                if(ev.xbutton.button==1)
                {
                    have_release=1;
                    have_press=0;
                    m_button=0;
                    if ((dragging) and (icon_list[i].w_id!=0))
                    {
//                      cout << "Mouse button was released.\n";


                        if(status == CAN_DROP)
                        {
//                          cout << "Perform drop:\n";

                            XClientMessageEvent m;
                            memset(&m, sizeof(m), 0);
                            m.type = ClientMessage;
                            m.display = ev.xclient.display;
                            m.window = previous_window;
                            m.message_type = XA_XdndDrop;
                            m.format=32;
                            m.data.l[0] = icon_list[i].w_id;
                            m.data.l[1] = 0;
                            m.data.l[2] = CurrentTime; //Our data is not time dependent, so send a generic timestamp;
                            m.data.l[3] = 0;
                            m.data.l[4] = 0;

                            XSendEvent(disp, previous_window, False, NoEventMask, (XEvent*)&m);
                            XFlush(disp);
                        }
                        XUngrabPointer(disp, CurrentTime);
                        dragging=0;
                        /*     3
                         *    /\
                         *     |
                         * 1<-- -->2
                         *     |
                         *    \/
                         *    4     
                         * 1 左移 
                         * 2 右移 
                         * 3 到上一个group（如果有） 
                         * 4 到下一个group（如果有）
                         * 5(拽到屏幕左边缘) 删除
                         */
//                        printf("%d %d %d %d\n",icon_list[i].x,icon_list[i].y,screenX,screenY);
                        if ( screenX<=5)
                            fx=5;
                        else
                        {
                            int ll=screenX-icon_list[i].x;
                            int hh=screenY-icon_list[i].y;
                            icon_list[i].x=screenY;
                            icon_list[i].y=screenY;
                            if ((abs(ll)<=10) and (abs(hh)<=10))
                                fx=0;
                            else if (abs(ll)-abs(hh)>=0)
                            {
                                if (ll>0)
                                    fx=2;
                                else
                                    fx=1;
                            }
                            else
                            {
                                if (hh>0)
                                    fx=4;
                                else
                                    fx=3;
                            }
                        }
//                        printf("fx: %d %d\n",fx,icon_list[i].l_id);
                        if (fx!=0)
                        {
                            status=UNAWARE;
                            previous_window=None;
                            previous_version=-1;
    //                        cout << endl;
                            sprintf(submenue,"%s/.icon-DE/wharf.rc",home);
                            if (access(submenue,0)!=-1)
                            {
                                
                                sprintf(c_cmd,"cp -f %s %s~",submenue,submenue);
    //                            printf("%s\n",c_cmd);
                                system(c_cmd);
                                sprintf(submenue,"%s/.icon-DE/wharf.rc~",home);
                                fp=fopen(submenue,"r");
                                if (fp==NULL)
                                {
                                    printf("not open 1\n");
                                }
                                else
                                {
                                    if (fx==3)
                                    {
                                        sprintf(submenue,"%s/.icon-DE/wharf.rc",home);
                                        sprintf(c_cmd,"cp -f %s %s~~",submenue,submenue);
//                                        printf("%s\n",c_cmd);
                                        system(c_cmd);
                                        sleep(2);
                                        FILE *fp3;
                                        int ii;
                                        sprintf(submenue,"%s/.icon-DE/wharf.rc~~",home);
                                        fp3=fopen(submenue,"r");
                                        if (fp3==NULL)
                                        {
                                            printf("not open 3\n");
                                            break;
                                        }
                                        else
                                        {
                                            fgets(f_buffer2,4096,fp3);
                                            ii=1;
                                            g_id=1;
                                            while ( ! feof(fp3) )
                                            {
                                                if (check_rc(f_buffer2,"group")==0 )
                                                    g_id=ii;
                                                if (ii==icon_list[i].l_id)
                                                    break;
                                                fgets(f_buffer2,4096,fp3);
                                                ii=ii+1;
//                                                printf("g_id: %ld %ld %s\n",g_id,ii,f_buffer2);
                                            }
                                        }
                                        fclose(fp3);
                                        sprintf(c_cmd,"rm -rf %s",submenue);
                                        system(c_cmd);
                                    }
                                    sprintf(submenue,"%s/.icon-DE/wharf.rc",home);
                                    fp2=fopen(submenue,"w");
                                    fgets(f_buffer,4096,fp);
                                    n=1;
                                    l_end=0;
                                    l_id=0;
                                    while ( ! feof(fp) )
                                    {
                                        if (fx==1)
                                        {
                                            if (n==icon_list[i].l_id-1)
                                            {
                                                if ( ! feof(fp) )
                                                {
                                                    fgets(f_buffer2,4096,fp);
                                                    n=n+1;
                                                    if (check_rc(f_buffer2,"group")==0 )
                                                    {
                                                        fputs(f_buffer,fp2);
                                                        fputs(f_buffer2,fp2);
                                                    }
                                                    else
                                                    {
                                                        fputs(f_buffer2,fp2);
                                                        fputs(f_buffer,fp2);
                                                    }
                                                }
                                                else
                                                    fputs(f_buffer,fp2);
                                            }    
                                            else
                                                fputs(f_buffer,fp2);
                                        }
                                        else if  (fx==2)
                                        {
                                            if (n==icon_list[i].l_id)
                                            {
                                                if ( ! feof(fp) )
                                                {
                                                    fgets(f_buffer2,4096,fp);
                                                    n=n+1;
                                                    if (check_rc(f_buffer2,"group")==0 )
                                                    {
                                                        fputs(f_buffer,fp2);
                                                        fputs(f_buffer2,fp2);
                                                    }
                                                    else
                                                    {
                                                        fputs(f_buffer2,fp2);
                                                        fputs(f_buffer,fp2);
                                                    }
                                                }
                                                else
                                                    fputs(f_buffer,fp2);
                                            }    
                                            else
                                                fputs(f_buffer,fp2);
                                        }
                                        else if  (fx==3)
                                        {
                                            if (n!=icon_list[i].l_id)
                                                fputs(f_buffer,fp2);
                                            if (n==g_id-1)
                                                fputs(f_buffer2,fp2);
                                        }
                                        else if  (fx==4)
                                        {
                                            if (n==icon_list[i].l_id-1)
                                            {
                                                fputs(f_buffer,fp2);
                                                if ( ! feof(fp) )
                                                {
                                                    fgets(f_buffer2,4096,fp);
                                                    n=n+1;
                                                    l_end=1;
                                                }
                                            }    
                                            else
                                            {
                                                if ((l_end==1) and (check_rc(f_buffer,"group")==0 ))
                                                {
                                                    fputs(f_buffer,fp2);
                                                    fputs(f_buffer2,fp2);
                                                    l_end=0;
                                                }
                                                else
                                                    fputs(f_buffer,fp2);
                                            } 
                                        }
                                        else //删除
                                        {
                                            if (n!=icon_list[i].l_id )
                                                fputs(f_buffer,fp2);
                                        }
                                        fgets(f_buffer,4096,fp);
                                        n=n+1;
                                    }
                                }
                                fclose(fp);
                                fclose(fp2);
                                sprintf(submenue,"icon-wharf RESET");
                                system(submenue);
                            }
                        }
                        break;
                    }
                    else if ( m_mouse == 0 )
                    {
                        if ((icon_list[i].s_g==0) or (icon_list[i].s_g==2))
                        {
                            char app[2000];
                            if ((bord==1) or (trans_wind<1))
                            {
                                sprintf(app , "icon-bord \"%s\" \"%s\" %d %f &" ,icon_list[i].title,skip,bord,trans_wind);
                                system(app);    
                            }
                            sprintf(app,"%s &",icon_list[i].apps);
//                            printf("%s \n",app);
                            system(app);
                            Destroy_icon(gc,gc+gm,icon_list);
                            if (MouseMoveOpenSubIcon==1) 
                                return 1;
                        }
                        if (icon_list[i].s_g==1)
                        {
                            if(store==1)
                            {
                                Destroy_icon(gc,gc+gm,icon_list);
                                store=0;
                                break;
                            }
                            mytoggle = 1;
                            Destroy_icon(gc,gc+gm,icon_list);
                            XMoveWindow(disp,icon_list[i].w_id,icon_list[i].x , icon_list[i].y); 
                            int q=gc;
                            freeNum=fopen(usermenufile,"r");
                            l_id=0;
                            while ( ! feof(freeNum) )
                            {
                                fgets(f_buffer,1024,freeNum);
                                l_id=l_id+1;
                                for (n=0;n<1024;n++)
                                    if (f_buffer[n]=='\n') f_buffer[n]='\0';
        //                        printf("%s\n",f_buffer); 
                                if (strcmp(f_buffer,"")!=0 )
                                {
                                    sprintf(ch2,"%c",f_buffer[0]);
                                    if (strcmp(ch2,"#")!=0 ) 
                                    {
                                        if (check_rc(f_buffer,"group")==0 )
                                            get_group(rc_group,ch2,f_buffer,"group");
                                        else
                                        {
                                            if (check_rc(f_buffer,"single")==0 )
                                                get_group(rc_group,ch2,f_buffer,"single");
                                            else
                                            {
                                                if ((strcmp(rc_group,icon_list[i].group)==0) and (icon_list[i].s_g==1))
                                                {
                                                    get_str2(picname,f_buffer,1);
                                                    get_str2(icon_list[q].apps,f_buffer,2);
                                                    get_str2(icon_list[q].tag,f_buffer,3);
                                                    get_str2(icon_list[q].title,f_buffer,4);
                                                    icon_list[q].s_g=2;
                                                    Creat_icon(icon_list[i].x+gapsub+(sizesub+gapsub)*(q-gc+1),icon_list[i].y-((sizesub-sizemain)/2),sizesub,q,l_id,picname,lowerraise,trans_icon,0,icon_list);
                                                    q=q+1;
                                                }
                                            }
                                        }     
                                    } 
                                }
                            } 
                            fclose(freeNum); 
                            for (i=gc;i<gc+gm-1;i++)
                            {
                                icon_filter(x,y,i,lowerraise,mytoggle,icon_list);
                            }
                            store+=1;
                        }
                        if (icon_list[i].s_g==2)
                        {
                            Destroy_icon(gc,gc+gm,icon_list);
                            char app[2000];
                            if ((bord==1) or (trans_wind<1))
                            {
                                sprintf(app , "icon-bord \"%s\" \"%s\" %d %f &" ,icon_list[i].title,skip,bord,trans_wind);
                                system(app);    
                            }
                            sprintf(app,"%s &",icon_list[i].apps);
//                            printf("%s \n",app);
                            system(app);
                            if (MouseMoveOpenSubIcon==1) 
                                return 1;
                        }
                    }
                    else
                    {
                        m_button=0;
                        if ((x>=100) and (x<=138) and (y>=96) and (y<=130))
                        {
                            imlib_context_set_drawable(win4);
                            imlib_context_set_image(buffer4);
                            imlib_render_image_on_drawable(0, 0);
                            imlib_free_image();
                            XDestroyWindow(disp,win4);
                            imlib_context_set_image(icon_list[i].im_bg);
                            imlib_context_set_drawable(icon_list[i].w_id);
                            m_button=0;
                            m_mouse=0;
                            if ( mytoggle2 == 1)
                            {
                                if (win_pid_list[cur_win]!=0)
                                {
                                    action_window(disp,win_pid_list[cur_win],'a');
                                    if (strstr(tiling_skip,get_window_class(disp, win_pid_list[cur_win]))==NULL)
                                    {
                                        init_window(win_pid_list[cur_win]);
                                        window_move_resize(disp,win_pid_list[cur_win],win_move);
                                    }
                                }    
                                mytoggle2 = 0;
                            }        
                            mytoggle = 0;
                            if (have_win2==1)
                            {
                                have_win2=0;
                                XDestroyWindow(disp,win2);    
                            }
                            store=0;
                            if (i<gc)
                            {
                                if (autohideSubbutton==1) 
                                    XMoveWindow(disp,icon_list[i].w_id,-sizemain+2 , icon_list[i].y);
                                if (autohideSubbutton==2) 
                                    XMoveWindow(disp,icon_list[i].w_id,-sizemain/2 , icon_list[i].y);
                            }
                            if (i<gc)
                            {
                                x=sizemain+15;
                                y=sizemain+15;
                            }
                            else
                            {
                                x=sizesub+15;
                                y=sizesub+15;
                            }
                            XSync(disp, False);
                            XFlush(disp); 
                        }
                        else if ((x>=54) and (x<=90) and (y>=8) and (y<=43))
                            m_button=4;
                        else if ((x>=54) and (x<=90) and (y>=53) and (y<=86))
                            m_button=2;
                        else if ((x>=54) and (x<=90) and (y>=96) and (y<=129))
                            m_button=5;
                        else if ((x>=100) and (x<=138) and (y>=8) and (y<=86))
                            m_button=3;
                    }
                } 
                if ((ev.xbutton.button==2) or (m_button==2))
                {
                    if (i<gc)
                    {
                        double t=atof(icon_list[i].group);
                        if (t>=10) t=10;
                        t=t/10;
                        if (get_active_window(disp)!=0)
                        {
                            if (tra==0)
                            {
                                sprintf(submenue , "icon-trans %f 2" , t);
                                system(submenue);    
                                tra=1;
                            } else {
                                sprintf(submenue , "icon-trans 1 2");
                                system(submenue);    
                                tra=0;
                            } 
                        }
                    }
                    else
                    {
                        if (tra==0)
                        {
                            sprintf(submenue , "icon-trans %f 1" , trans_wind);
                            system(submenue);    
                            tra=1;
                        } else {
                            sprintf(submenue , "icon-trans 1 1");
                            system(submenue);    
                            tra=0;
                        } 
                    }
                    break;
                }
                if ((ev.xbutton.button==3) or (m_button==3))
                {
                    Destroy_icon(gc,gc+gm,icon_list);
                    if (MouseMoveOpenSubIcon==1)
                        return 1;    
                    break;
                }
                if ((ev.xbutton.button==4) or (m_button==4))
                {
                    if ((icon_list[i].s_g==0) or (icon_list[i].s_g==2))
                    {
                        cur_times=cur_times+1;
                        if ((can_close==1) or (cur_times>=3))
                        {
                            cur_times=0;
                            Destroy_icon(gc,gc+gm,icon_list);
                            if (MouseMoveOpenSubIcon==1)
                                return 1;
                        }
                        list_windows(disp,skip);
                        if (get_active_window(disp)==0)
                        {
                            for (n=0;n<win_count;n++)
                            {
                                if (win_pid_list[n]!=0) 
                                if (get_window_title(disp,win_pid_list[n])!=NULL)
                                if (strstr(get_window_title(disp,win_pid_list[n]),icon_list[i].title)!=NULL)
                                {
                                    action_window(disp,win_pid_list[n],'a');
                                    can_close=0;
                                }    
                            }     
                        } else {
                            if ( get_window_title(disp,get_active_window(disp))!=NULL)
                            {
                                cur_win_id=get_active_window(disp);
                                init_window(cur_win_id);
                                if (strstr(get_window_title(disp,cur_win_id),icon_list[i].title)==NULL)
                                {
                                    for (n=0;n<win_count;n++)
                                    {
                                        if (win_pid_list[n]!=0) 
                                        if (get_window_title(disp,win_pid_list[n])!=NULL)
                                        if (strstr(get_window_title(disp,win_pid_list[n]),icon_list[i].title)!=NULL)
                                        {
                                            action_window(disp,win_pid_list[n],'a');
                                            can_close=0;
                                        }    
                                    }     
                                }  else {
                                    if (get_active_window(disp)!=0)
                                    {
                                        cur_win_id=get_active_window(disp);
//                                        action_window(disp,win_pid_list[cur_win],'a');
                                        if (strstr(tiling_skip,get_window_class(disp, cur_win_id))==NULL)
                                        {
                                            init_window(cur_win_id);
                                            window_move_resize(disp,cur_win_id,win_move);
                                        }
                                    }
                                }    
                            }
                        } 
                    }  else {
                        list_windows(disp,skip);
                        if (win_pid_list[cur_win]==0)
                        {
                            cur_win=0;
                            sprintf(text,"没有活动窗口");
                        }    else    {
                            if (get_window_title(disp,win_pid_list[cur_win])!=NULL)
                            {
                                if (cur_win<win_count-1) {
                                    cur_win=cur_win+1;    
                                } else    {
                                    cur_win=0;    
                                } 
                                sprintf(text,"%s",get_window_title(disp,win_pid_list[cur_win]));
                                mytoggle = 1;
                                mytoggle2 = 1;
                            } else {
                                sprintf(text,"没有活动窗口");
                                cur_win=0;    
                            }        
                        } 
                        mytoggle = 1;
                        buffer = imlib_create_image(1000, 30);    
                        font = imlib_load_font("Vera/8");
                        if (font == NULL)
                            font = imlib_load_font("wqy-zenhei.ttc/8");
                        imlib_context_set_font(font);
                        imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
                        imlib_get_text_size(text, &text_w, &text_h);
//                        win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX+screenWidth+4,screenY-18,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
                        XRaiseWindow(disp,win2);
                        XMapWindow(disp, win2);
                        imlib_context_set_drawable(win2); 
//                        imlib_context_set_image(buffer);
                        imlib_context_set_image(buffer);
                        imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
            //         imlib_free_color_range();
                        imlib_context_set_image(buffer);
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_image(buffer);
                        imlib_context_set_font(font);
                        imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
                        imlib_text_draw(5,2,text);
                        imlib_context_set_image(buffer);
                        imlib_context_set_drawable(win2); 
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_image(buffer);
                        imlib_free_image();
                        imlib_context_set_font(font);
                        imlib_free_font();
                        imlib_context_set_image(icon_list[i].im_bg);
                        imlib_context_set_drawable(icon_list[i].w_id); 
                        Destroy_icon(gc,gc+gm,icon_list);
                    }
                    break;
                }
                if ((ev.xbutton.button==5) or (m_button==5))
                {
                    if ((icon_list[i].s_g==0) or (icon_list[i].s_g==2))
                    {
                        cur_times=cur_times+1;
                        if ((can_close==1) or (cur_times>=3))
                        {
                            cur_times=0;
                            Destroy_icon(gc,gc+gm,icon_list);
                            if (MouseMoveOpenSubIcon==1)
                                return 1;
                        }
                        list_windows(disp,skip);
                        if (get_active_window(disp)==0)
                        {
                            for (n=0;n<win_count;n++)
                            {
                                if (win_pid_list[n]!=0) 
                                if (get_window_title(disp,win_pid_list[n])!=NULL)
                                if (strstr(get_window_title(disp,win_pid_list[n]),icon_list[i].title)!=NULL)
                                {
                                    action_window(disp,win_pid_list[n],'a');
                                    can_close=0;
                                }    
                            }     
                        } else {
                            if (get_window_title(disp,get_active_window(disp))!=NULL)
                            {
                                cur_win_id=get_active_window(disp);
                                init_window(cur_win_id);
                                if (strstr(get_window_title(disp,cur_win_id),icon_list[i].title)==NULL)
                                {
                                    for (n=0;n<win_count;n++)
                                    {
                                        if (win_pid_list[n]!=0) 
                                        if (get_window_title(disp,win_pid_list[n])!=NULL)
                                        if (strstr(get_window_title(disp,win_pid_list[n]),icon_list[i].title)!=NULL)
                                        {
                                            action_window(disp,win_pid_list[n],'a');
                                            can_close=0;
                                        }    
                                    }     
                                }    else {
                                    if (get_active_window(disp)!=0)
                                    {
                                        cur_win_id=get_active_window(disp);
//                                        action_window(disp,win_pid_list[cur_win],'a');
                                        if (strstr(tiling_skip,get_window_class(disp, cur_win_id))==NULL)
                                        {
                                            init_window(win_pid_list[cur_win]);
                                            window_move_resize(disp,cur_win_id,win_move);
                                        }
                                    }
                                }    
                            }
                        }    
                    }    else {
                        list_windows(disp,skip);
                        if (win_pid_list[cur_win]==0)
                        {
                            cur_win=0;
                            sprintf(text,"没有活动窗口");
                        }    else    {
                            if (get_window_title(disp,win_pid_list[cur_win])!=NULL)
                            {
                                if (cur_win>0) {
                                    cur_win=cur_win-1;    
                                } else    {
                                    cur_win=win_count-1;
                                } 
                                sprintf(text,"%s",get_window_title(disp,win_pid_list[cur_win]));
                                mytoggle = 1;
                                mytoggle2 = 1;
                            } else {
                                sprintf(text,"没有活动窗口");
                                cur_win=0;    
                            }        
                        } 
                        mytoggle = 1;
                        buffer = imlib_create_image(1000, 30);    
                        font = imlib_load_font("Vera/8");
                        if (font == NULL)
                            font = imlib_load_font("wqy-zenhei.ttc/8");
                        imlib_context_set_font(font);
                        imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
                        imlib_get_text_size(text, &text_w, &text_h);
//                        win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX+screenWidth+4,screenY-18,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
                        XRaiseWindow(disp,win2);
                        XMapWindow(disp, win2);
                        imlib_context_set_drawable(win2); 
//                        imlib_context_set_image(buffer);
                        imlib_context_set_image(buffer);
                        imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
            //         imlib_free_color_range();
                        imlib_context_set_image(buffer);
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_image(buffer);
                        imlib_context_set_font(font);
                        imlib_context_set_color(f_red, f_green, f_blue, f_alpha);
                        imlib_text_draw(5,2,text);
                        imlib_context_set_image(buffer);
                        imlib_context_set_drawable(win2); 
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_image(buffer);
                        imlib_free_image();
                        imlib_context_set_font(font);
                        imlib_free_font();
                        imlib_context_set_image(icon_list[i].im_bg);
                        imlib_context_set_drawable(icon_list[i].w_id); 
                        Destroy_icon(gc,gc+gm,icon_list);
                    }
                    break;
                }
            }
        }
         else {
        //display 是由 XopenDisplay 返回的 Display *
            FD_ZERO(&rfds);
            FD_SET(xfd, &rfds);
            gettimeofday(&now, 0);
//LastTime 是 timeval 类型的变量,保存上次时间
//ticks 的单位是毫秒 millisecond
            ticks=(now.tv_sec-LastTime.tv_sec)*1000+(now.tv_usec-LastTime.tv_usec)/1000;
            for (i=0;i<gc+gm-1;i++)
            {
                if (icon_list[i].w_id==cur_icon)
                    break;
            }
            if (ticks>=3000)
            {
                if ((have_press==1) and (have_release==0) and (i>=gc) and (icon_list[i].w_id!=0))
                {
                    if(XGrabPointer(disp,icon_list[i].w_id, True, Button1MotionMask | ButtonReleaseMask, GrabModeAsync, GrabModeAsync, root, grab_good, CurrentTime) == GrabSuccess)
                    {
                        dragging=1;
                        printf("dragging\n");
                        XSetSelectionOwner(disp, XA_XdndSelection, icon_list[i].w_id, CurrentTime);
                        m_mouse=0;
                        m_button=0;
                    }
                }
                else
                    dragging=0;
                gettimeofday(&LastTime, 0);
            } else if (ticks>=800)
            {
                if ((have_press==1) and (have_release==0) and (m_mouse==0))
                {
                    if (i<gc)
                        win4=XCreateWindow(disp,DefaultRootWindow(disp),icon_list[i].x+sizemain,icon_list[i].y+sizemain,153,193,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
                    else
                        win4=XCreateWindow(disp,DefaultRootWindow(disp),icon_list[i].x+sizesub,icon_list[i].y+sizesub,153,193,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
                    XSelectInput(disp, win4, ButtonPressMask | ButtonReleaseMask );
                    XMapWindow(disp, win4);
                    imlib_context_set_drawable(win4); 
                    sprintf(mouse_pic,"%s/.icon-DE/iconcache/mouse.png",home);
                    if (access(mouse_pic,0)==-1)
                    {
                        system("cp /usr/share/icon-DE/iconcache/mouse.png ~/.icon-DE/iconcache/mouse.png");
                        sprintf(mouse_pic,"/usr/share/icon-DE/iconcache/mouse.png");
                    }
                    buffer4 = imlib_load_image(mouse_pic);
                    imlib_context_set_image(buffer4);
                    imlib_render_image_on_drawable(0, 0);
                    m_mouse=1;
                    imlib_context_set_image(icon_list[i].im_bg);
                    imlib_context_set_drawable(icon_list[i].w_id);
                }
            }
//如果到期则调用有关函数
//select 等待 100 毫秒
            tm.tv_sec=0l;
            tm.tv_usec=300000l;
            select(xfd + 1, &rfds, 0, 0, &tm);
            if ((r_flash==1)  and (icon_list[i].w_id!=0))
            {
                r_flash=0;
                if (m_mouse==1)
                {
                    imlib_context_set_drawable(win4); 
                    imlib_context_set_image(buffer4);
                    imlib_render_image_on_drawable(0, 0);
                }
                icon_filter(x,y,i,lowerraise,mytoggle,icon_list);
            } 
        } /* End else*/
    }
//    delete[] icon_list;
    return 0;
}


