/*
 * 自己开发的基于xlib和imlib2的人机交互界面。
 * 使用时，请用以下的方式调用：
 * #include "./other_src/button.c"
 * main（）
 * {
 *     Display                        *disp;
 *     const char                 *display_name = getenv("DISPLAY");
 *     if (display_name == NULL)
 *         display_name = ":0";
 *     disp = XOpenDisplay(display_name);
 *     if (disp == NULL)
 *     {
 *        printf("Can't open display %s\n", display_name);
 *        return 1;
 *     }                //以上是基于xlib的标准写法......
 *     imenu m_menu;  //定义变量
 *     init_button(m_menu); //初始化
 *     m_menu.t_group=0;   //定义参数
 *     m_menu.show_lines=5;
 *     m_menu.x=100;
 *     m_menu.y=60;
 *     m_menu.width1=800;
 *     m_menu.width2=80;
 *     m_menu.width3=60;
 *     m_menu.width4=398;
 *     m_menu.height=25;
 *     m_menu.w_gap=3;
 *     m_menu.h_gap=15;
 *     m_menu.menu1.flash=1;
 *     m_menu.menu1.group=-1;
 *     m_menu.menu1.hide=0;
 *     m_menu.b_up.hide=1;
 *     m_menu.input.hide=1;
 *     m_menu.b_down.hide=1;
 *     m_menu.menu4[0].hide=0;
 *     m_menu.menu4[1].selected=0;
 *     sprintf(m_menu.menu1.text,"必须用sudo取得root权限来运行本程序，或输入完整参数运行！稍后程序将自动退出。");
 *     m_menu.menu2[0].flash=0;
 *     
 *     //开始定义2级、3级菜单。和2级菜单group相同的3级菜单，是2级菜单的子菜单。
 *     m_menu.menu2[0].group=0;
 *     m_menu.menu2[0].hide=0;
 *     m_menu.menu2[0].selected=0;
 *     sprintf(m_menu.menu2[0].text,"操 作 员：");

 *     m_menu.menu2[1].flash=0;
 *     m_menu.menu2[1].group=1;
 *     m_menu.menu2[1].hide=0;
 *     m_menu.menu2[1].selected=0;
 *     sprintf(m_menu.menu2[1].text,"分 辨 率：");
         
 *     m_menu.menu3[0].flash=0;
 *     m_menu.menu3[0].group=1;
 *     m_menu.menu3[0].hide=0;
 *     m_menu.menu3[0].selected=0;
 *     sprintf(m_menu.menu3[0].text,"320x240");

 *     m_menu.menu3[1].flash=0;
 *     m_menu.menu3[1].group=1;
 *     m_menu.menu3[1].hide=0;
 *     m_menu.menu3[1].selected=0;
 *     sprintf(m_menu.menu3[1].text,"640x480");
 *     
 *     m_menu.menu3[2].flash=0;
 *     m_menu.menu3[2].group=1;
 *     m_menu.menu3[2].hide=0;
 *     m_menu.menu3[2].selected=0;
 *     sprintf(m_menu.menu3[2].text,"800x600");
 *     
 *     //......
 *     creat_button(disp,m_menu); //显示菜单窗口
 *     while (1)   //开始“xlib事件循环”，（有多种写法，这只是其中一种）
 *     {
 *         XNextEvent(disp, &ev);
 *         if (XFilterEvent(&ev, None)) //这两句不能省略，否则不能输入汉字
 *             continue;                //同上
 *         switch (ev.type)
 *         {
 *         case KeyPress:
 *             input_text(disp,ev,m_menu); //键盘输入
 *             break;
 *         case ButtonPress:
 *             int m_i=click_button(disp,ev.xmotion.window,m_menu);  //确定、取消等按钮按下事件。“确定”0,“取消”1,“up/down_button”4,其他3。
 *             //......    在这里写下按下按钮时执行的语句
 *             break;
 *         }
 *     }
 * }
 */
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <malloc.h>
#include <errno.h>
#include <string.h>
#include <setjmp.h>
#include <sys/time.h>
#include <X11/Xatom.h>
#include <X11/Xlocale.h>
#include <X11/Xmu/WinUtil.h>
#include <glib-2.0/glib.h>
#include "Imlib2.h"

Visual                         *button_vis;
Colormap                       button_cm;
int                            button_depth;
XSetWindowAttributes           button_attr;
int bc_red=255,bc_green=200,bc_blue=10,bc_alpha=255;
int bf_red=0,bf_green=0,bf_blue=0,bf_alpha=255;


typedef struct _ibutton_ {
        Window w_id;
        char  text[256];
        int   group;
        int   tag_int;
        char  tag_text[1024];
        int   selected;
        int   flash;
        int   hide;
} ibutton;

typedef struct _iinput_ {
        Window w_id;
        Window w_ip;
        char  text[512];
        int   tag_int;
        char  tag_text[1024];
        int   str_len;
        int   hide;
        int   cur;
        int   insert;
        int   is_passwd;
        int   have_xim;
} iinput;

typedef struct _imenu_ {
        int       t_group;
        int       m_group_begin;
        int       m_group_end;
        int       show_lines;
        int       x;
        int       y;
        XIC       ic;
        GC        gc;
        int       width1;
        int       width2;
        int       width3;
        int       width4;
        int       width_text;
        int       height;
        int       w_gap;
        int       h_gap;
        int       font_size;
        Imlib_Font font;
        Imlib_Font font2;
        ibutton  menu1;
        ibutton  b_up;
        ibutton  b_down;
        ibutton  menu2[50];
        ibutton  menu3[500];
        ibutton  menu4[3];
        iinput   input;
} imenu;

#define _NET_WM_STATE_REMOVE        0    /* remove/unset property */
#define _NET_WM_STATE_ADD           1    /* add/set property */
#define _NET_WM_STATE_TOGGLE        2    /* toggle property  */

#define MWM_HINTS_FUNCTIONS       (1L << 0) /* wheter the functions member of the struct schould be listened to */
#define MWM_HINTS_DECORATIONS     (1L << 1) /* same for decorations member */

#define MWM_FUNC_ALL              (1L << 0) /* means as much as we schould reversely interpret all other bits */
#define MWM_FUNC_RESIZE           (1L << 1) /* self explanatory */
#define MWM_FUNC_MOVE             (1L << 2)
#define MWM_FUNC_MINIMIZE         (1L << 3)
#define MWM_FUNC_MAXIMIZE         (1L << 4)
#define MWM_FUNC_CLOSE            (1L << 5)

#define MWM_DECOR_ALL             (1L << 0) /* equivalent of MWM_HINTS_FUNCTIONS */
#define MWM_DECOR_BORDER          (1L << 1) /* show border */
#define MWM_DECOR_RESIZEH         (1L << 2) /* show resize handle */
#define MWM_DECOR_TITLE           (1L << 3) /* show title bar */
#define MWM_DECOR_MENU            (1L << 4) /* wich buttons to show */
#define MWM_DECOR_MINIMIZE        (1L << 5)
#define MWM_DECOR_MAXIMIZE        (1L << 6)
#define PROP_MWM_HINTS_ELEMENTS 5
typedef struct _mwmhints {
                                uint32_t flags;
                                uint32_t functions;
                                uint32_t decorations;
                                int32_t  input_mode;
                                uint32_t status;
                } MWMHints;

//static gboolean envir_utf8;

static int button_client_msg(Display *disp, Window win,const char *msg, /* {{{ */
        unsigned long data0, unsigned long data1, 
        unsigned long data2, unsigned long data3,
        unsigned long data4) {
    XEvent event;
    long mask = SubstructureRedirectMask | SubstructureNotifyMask;

    event.xclient.type = ClientMessage;
    event.xclient.serial = 0;
    event.xclient.send_event = True;
    event.xclient.message_type = XInternAtom(disp, msg, False);
    event.xclient.window = win;
    event.xclient.format = 32;
    event.xclient.data.l[0] = data0;
    event.xclient.data.l[1] = data1;
    event.xclient.data.l[2] = data2;
    event.xclient.data.l[3] = data3;
    event.xclient.data.l[4] = data4;
    
    if (XSendEvent(disp, DefaultRootWindow(disp), False, mask, &event)) {
        return EXIT_SUCCESS;
    }
    else {
        fprintf(stderr, "Cannot send %s event.\n", msg);
        return EXIT_FAILURE;
    }
}/*}}}*/

//***********************************处理rc文件的函数--开始

int b_check_rc(const char *fullstr,const char *l_str)
{
    char ch2[4096],f_str[4096];
    sprintf(f_str,"%s",fullstr);
    int i,n,m;
    sprintf(ch2,"%s",fullstr);
    for (i=0;i<4096;i++)
        if (ch2[i]=='\0')
            break;
    m=i;
    sprintf(ch2,"%s",l_str);
    for (i=0;i<4096;i++)
        if (ch2[i]=='\0')
            break;
    n=i;
    if (n>=m) return -1;

    for (i=0;i<n;i++)
        ch2[i]=f_str[i];
    ch2[n]='\0';
    if (strcmp(ch2,l_str)==0 )
        return 0;
    else
        return -1;
}

int b_get_str(char *sSrc,const char *fullstr,const char *l_str)
{
    char ch2[4096],f_str[4096];
    sprintf(f_str,"%s",fullstr);
    int i,n,m;
    sprintf(ch2,"%s",fullstr);
    for (i=0;i<4096;i++)
        if (ch2[i]=='\0')
            break;
    m=i;
    sprintf(ch2,"%s",l_str);
    for (i=0;i<4096;i++)
        if (ch2[i]=='\0')
            break;
    n=i;
    if (n>=m) 
        return -1;
    for (i=0;i<4096-n-1;i++)
        ch2[i]=f_str[i+n];
    sprintf(sSrc,"%s",ch2);
    return 0;
}

int b_get_int2(int &jg,char *fullstr,int n_id)
{
    char f_buffer[4096],ch2[4096];
    int i,n,o,p,yh;
    sprintf(f_buffer,"%s",fullstr);
    p=0;
    i=0;
    while (1)
    {
        o=0;
        yh=0;
        for (n=0;n<4096;n++)
            ch2[n]='\0';
        for (n=p;n<4096;n++)
        {
            if ((yh==0) and (f_buffer[n]==' '))
                continue;
            if ((yh==1) and (f_buffer[n]=='\"') and (f_buffer[n-1]!='\\'))
                break;
            if (((f_buffer[n]=='\"') and (n==p)) or ((f_buffer[n]=='\"') and (n>p) and (f_buffer[n-1]!='\\')))
            {
                yh=1;
                continue;
            }
            if ((yh==2) and (f_buffer[n]==' '))
                break;
            if ((yh==0) and (f_buffer[n]!=' '))
                yh=2;
            if (yh>0)
            {
                ch2[o]=f_buffer[n];
                o=o+1;
            }
        }
        if (yh==1)
            p=n+1;
        else
            p=n;
        i=i+1;
        if (i==n_id)
        {
            jg=atoi(ch2);
            return 0;
        }
    }
    return -1;
}
//***********************************处理rc文件的函数--结束
//*******************************************************************************************/
/*
 * xsel -- manipulate the X selection
 * Copyright (C) 2001 Conrad Parker <conrad@vergenet.net>
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 */

#define AUTHOR "Conrad Parker <conrad@vergenet.net>"

/* Default debug level (ship at 0) */
#define DEBUG_LEVEL 0

#define empty_string(s) (s==NULL||s[0]=='\0')
#define free_string(s) { free(s); s=NULL; }

/* Maximum line length for error messages */
#define MAXLINE 1024

/* Maximum filename length */
#define MAXFNAME 1024

/* Maximum incremental selection size. (Ripped from Xt) */
#define MAX_SELECTION_INCR(dpy) (((65536 < XMaxRequestSize(dpy)) ? \
        (65536 << 2)  : (XMaxRequestSize(dpy) << 2))-100)

/*
 * Debug levels (for print_debug()):
 *
 *   0  -  Fatal errors (default/unmaskable)
 *   1  -  Non-fatal warning (essential debugging info)
 *   2  -  Informative (generally useful debugging info)
 *   3  -  Obscure (more detailed debugging info)
 *   4  -  Trace (sequential trace of progress)
 */

#define D_FATAL 0
#define D_WARN  1
#define D_INFO  2
#define D_OBSC  3
#define D_TRACE 4

/* An instance of a MULTIPLE SelectionRequest being served */
typedef struct _MultTrack MultTrack;

struct _MultTrack {
  MultTrack * mparent;
  Display * display;
  Window requestor;
  Atom property;
  Atom selection;
  Time time;
  Atom * atoms;
  unsigned long length;
  unsigned long index;
  unsigned char * sel;
};

/* Selection serving states */
typedef enum {
  S_NULL=0,
  S_INCR_1,
  S_INCR_2
} IncrState;

/* An instance of a selection being served */
typedef struct _IncrTrack IncrTrack;

struct _IncrTrack {
  MultTrack * mparent;
  IncrTrack * prev, * next;
  IncrState state;
  Display * display;
  Window requestor;
  Atom property;
  Atom selection;
  Time time;
  Atom target;
  int format;
  unsigned char * data;
  int nelements; /* total */
  int offset, chunk, max_elements; /* all in terms of nelements */
};

/* Status of request handling */
typedef int HandleResult;
#define HANDLE_OK         0
#define HANDLE_ERR        (1<<0)
#define HANDLE_INCOMPLETE (1<<1)
#define DID_DELETE        (1<<2)

/*
 * xsel -- manipulate the X selection
 * Copyright (C) 2001 Conrad Parker <conrad@vergenet.net>
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or
 * implied warranty.
 */

/* The name we were invoked as (argv[0]) */
static char * progname;

/* Verbosity level for debugging */
static int debug_level = DEBUG_LEVEL;

/* Our X Display and Window */
//Display * display;
static Window window;

/* Maxmimum request size supported by this X server */
static long max_req;

/* Our timestamp for all operations */
static Time timestamp;

static Atom timestamp_atom; /* The TIMESTAMP atom */
static Atom multiple_atom; /* The MULTIPLE atom */
static Atom targets_atom; /* The TARGETS atom */
static Atom delete_atom; /* The DELETE atom */
static Atom incr_atom; /* The INCR atom */
static Atom null_atom; /* The NULL atom */
static Atom text_atom; /* The TEXT atom */
static Atom utf8_atom; /* The UTF8 atom */
static Atom compound_text_atom; /* The COMPOUND_TEXT atom */

/* Number of selection targets served by this.
 * (MULTIPLE, INCR, TARGETS, TIMESTAMP, DELETE, TEXT, UTF8_STRING and STRING)
 * NB. We do not currently serve COMPOUND_TEXT; we can retrieve it but do not
 * perform charset conversion.
 */
#define MAX_NUM_TARGETS 9
static int NUM_TARGETS;
static Atom supported_targets[MAX_NUM_TARGETS];

static long timeout = 0;
static struct itimerval timer;

/*
 * exit_err (fmt)
 *
 * Print a formatted error message and errno information to stderr,
 * then exit with return code 1.
 */
static void
exit_err (const char * fmt, ...)
{
  va_list ap;
  int errno_save;
  char buf[MAXLINE];
  int n;

  errno_save = errno;

  va_start (ap, fmt);

  snprintf (buf, MAXLINE, "%s: ", progname);
  n = strlen (buf);

  vsnprintf (buf+n, MAXLINE-n, fmt, ap);
  n = strlen (buf);

  snprintf (buf+n, MAXLINE-n, ": %s\n", strerror (errno_save));

  fflush (stdout); /* in case stdout and stderr are the same */
  fputs (buf, stderr);
  fflush (NULL);

  va_end (ap);
  exit (1);
}

/*
 * print_err (fmt)
 *
 * Print a formatted error message to stderr.
 */
static void
print_err (const char * fmt, ...)
{
  va_list ap;
//  int errno_save;
  char buf[MAXLINE];
  int n;

//  errno_save = errno;

  va_start (ap, fmt);

  snprintf (buf, MAXLINE, "%s: ", progname);
  n = strlen (buf);

  vsnprintf (buf+n, MAXLINE-n, fmt, ap);
  n = strlen (buf);

  fflush (stdout); /* in case stdout and stderr are the same */
  fputs (buf, stderr);
  fputc ('\n', stderr);
  fflush (NULL);

  va_end (ap);
}

/*
 * print_debug (level, fmt)
 *
 * Print a formatted debugging message of level 'level' to stderr
 */
#define print_debug(x,y...) {if (x <= debug_level) print_err (y);}

/*
 * get_atom_name (atom)
 *
 * Returns a string with a printable name for the Atom 'atom'.
 */
static char *
get_atom_name (Display * display,Atom atom)
{
  char * ret;
  static char atom_name[MAXLINE+1];
  sprintf(atom_name,"N/A");
  if (atom == None) sprintf(atom_name,"None");
  if (atom == XA_STRING) sprintf(atom_name,"STRING");
  if (atom == XA_PRIMARY) sprintf(atom_name,"PRIMARY");
  if (atom == XA_SECONDARY) sprintf(atom_name,"SECONDARY");
  if (atom == timestamp_atom) sprintf(atom_name,"TIMESTAMP");
  if (atom == multiple_atom) sprintf(atom_name,"MULTIPLE");
  if (atom == targets_atom) sprintf(atom_name,"TARGETS");
  if (atom == delete_atom) sprintf(atom_name,"DELETE");
  if (atom == incr_atom) sprintf(atom_name,"INCR");
  if (atom == null_atom) sprintf(atom_name,"NULL");
  if (atom == text_atom) sprintf(atom_name,"TEXT");
  if (atom == utf8_atom) sprintf(atom_name,"UTF8_STRING");
  if (strcmp(atom_name,"N/A")==0) return atom_name;
  ret = XGetAtomName (display, atom);
  strncpy (atom_name, ret, sizeof (atom_name));
  if (atom_name[MAXLINE] != '\0')
    {
      atom_name[MAXLINE-3] = '.';
      atom_name[MAXLINE-2] = '.';
      atom_name[MAXLINE-1] = '.';
      atom_name[MAXLINE] = '\0';
    }
  XFree (ret);

  return atom_name;
}

/*
 * debug_property (level, requestor, property, target, length)
 *
 * Print debugging information (at level 'level') about a property received.
 */
static void
debug_property (Display * display,int level, Window requestor, Atom property, Atom target,
                unsigned long length)
{
  print_debug (level, "Got window property: requestor 0x%x, property 0x%x, target 0x%x %s, length %ld bytes", requestor, property, target, get_atom_name (display,target), length);
}

/*
 * xs_malloc (size)
 *
 * Malloc wrapper. Always returns a successful allocation. Exits if the
 * allocation didn't succeed.
 */
static void *
xs_malloc (size_t size)
{
  void * ret;

  if (size == 0) size = 1;
  if ((ret = malloc (size)) == NULL) {
    exit_err ("malloc error");
  }

  return ret;
}

/*
 * xs_strdup (s)
 *
 * strdup wrapper for unsigned char *
 */
#define xs_strdup(s) ((unsigned char *) _xs_strdup ((const char *)s))
static char * _xs_strdup (const char * s)
{
  char * ret;

  if (s == NULL) return NULL;
  if ((ret = strdup(s)) == NULL) {
    exit_err ("strdup error");
  }

  return ret; 
}

/*
 * xs_strlen (s)
 *
 * strlen wrapper for unsigned char *
 */
#define xs_strlen(s) (strlen ((const char *) s))

/*
 * xs_strncpy (s)
 *
 * strncpy wrapper for unsigned char *
 */
#define xs_strncpy(dest,s,n) (_xs_strncpy ((char *)dest, (const char *)s, n))
static char *
_xs_strncpy (char * dest, const char * src, size_t n)
{
  if (n > 0) {
    strncpy (dest, src, n);
    dest[n-1] = '\0';
  }
  return dest;
}

/*
 * get_timestamp ()
 *
 * Get the current X server time.
 *
 * This is done by doing a zero-length append to a random property of the
 * window, and checking the time on the subsequent PropertyNotify event.
 *
 * PRECONDITION: the window must have PropertyChangeMask set.
 */
static Time
get_timestamp (Display * display)
{
  XEvent event;

  XChangeProperty (display, window, XA_WM_NAME, XA_STRING, 8,
                   PropModeAppend, NULL, 0);

  while (1) {
    XNextEvent (display, &event);

    if (event.type == PropertyNotify)
      return event.xproperty.time;
  }
}

/*
 * SELECTION RETRIEVAL
 * ===================
 *
 * The following functions implement retrieval of an X selection,
 * optionally within a user-specified timeout.
 *
 *
 * Selection timeout handling.
 * ---------------------------
 *
 * The selection retrieval can time out if no response is received within
 * a user-specified time limit. In order to ensure we time the entire
 * selection retrieval, we use an interval timer and catch SIGVTALRM.
 * [Calling select() on the XConnectionNumber would only provide a timeout
 * to the first XEvent.]
 */

/* The jmp_buf to longjmp out of the signal handler */
static sigjmp_buf env_alrm;

/*
 * alarm_handler (sig)
 *
 * Signal handler for catching SIGVTALRM.
 */
static void
alarm_handler (int sig)
{
  siglongjmp (env_alrm, 1);
}

/*
 * get_append_property ()
 *
 * Get a window property and append its data to a buffer at a given offset
 * pointed to by *offset. 'offset' is modified by this routine to point to
 * the end of the data.
 *
 * Returns True if more data is available for receipt.
 *
 * If an error is encountered, the buffer is free'd.
 */
static Bool
get_append_property (Display * display,XSelectionEvent * xsl, unsigned char ** buffer,
                     unsigned long * offset, unsigned long * alloc)
{
  unsigned char * ptr;
  Atom target;
  int format;
  unsigned long bytesafter, length;
  unsigned char * value;

  XGetWindowProperty (xsl->display, xsl->requestor, xsl->property,
                      0L, 1000000, True, (Atom)AnyPropertyType,
                      &target, &format, &length, &bytesafter, &value);

  debug_property (display,D_TRACE, xsl->requestor, xsl->property, target, length);

  if (target != XA_STRING && target != utf8_atom) {
    print_debug (D_OBSC, "target %s not XA_STRING nor UTF8_STRING in get_append_property()",
                 get_atom_name (display,target));
    free (*buffer);
    *buffer = NULL;
    return False;
  } else if (length == 0) {
    /* A length of 0 indicates the end of the transfer */
    print_debug (D_TRACE, "Got zero length property; end of INCR transfer");
    return False;
  } else if (format == 8) {
    if (*offset + length > *alloc) {
      *alloc = *offset + length;
      if ((*buffer = (unsigned char*)realloc (*buffer, *alloc)) == NULL) {
        exit_err ("realloc error");
      }
    }
    ptr = *buffer + *offset;
    xs_strncpy (ptr, value, length);
    *offset += length;
    print_debug (D_TRACE, "Appended %d bytes to buffer\n", length);
  } else {
    print_debug (D_WARN, "Retrieved non-8-bit data\n");
  }

  return True;
}


/*
 * wait_incr_selection (selection)
 *
 * Retrieve a property of target type INCR. Perform incremental retrieval
 * and return the resulting data.
 */
static unsigned char *
wait_incr_selection (Display * display,Atom selection, XSelectionEvent * xsl, int init_alloc)
{
  XEvent event;
  unsigned char * incr_base = NULL;
//  unsigned char  * incr_ptr = NULL;
  unsigned long incr_alloc = 0, incr_xfer = 0;
  Bool wait_prop = True;

  print_debug (D_TRACE, "Initialising incremental retrieval of at least %d bytes\n", init_alloc);

  /* Take an interest in the requestor */
  XSelectInput (xsl->display, xsl->requestor, PropertyChangeMask);

  incr_alloc = init_alloc;
  incr_base = (unsigned char*)xs_malloc (incr_alloc);
//  incr_ptr = incr_base;

  print_debug (D_TRACE, "Deleting property that informed of INCR transfer");
  XDeleteProperty (xsl->display, xsl->requestor, xsl->property);

  print_debug (D_TRACE, "Waiting on PropertyNotify events");
  while (wait_prop) {
    XNextEvent (xsl->display, &event);

    switch (event.type) {
    case PropertyNotify:
      if (event.xproperty.state != PropertyNewValue) break;

      wait_prop = get_append_property (display,xsl, &incr_base, &incr_xfer,
                                       &incr_alloc);
      break;
    default:
      break;
    }
  }

  /* when zero length found, finish up & delete last */
  XDeleteProperty (xsl->display, xsl->requestor, xsl->property);

  print_debug (D_TRACE, "Finished INCR retrieval");

  return incr_base;
}

/*
 * wait_selection (selection, request_target)
 *
 * Block until we receive a SelectionNotify event, and return its
 * contents; or NULL in the case of a deletion or error. This assumes we
 * have already called XConvertSelection, requesting a string (explicitly
 * XA_STRING) or deletion (delete_atom).
 */
static unsigned char *
wait_selection (Display * display,Atom selection, Atom request_target)
{
  XEvent event;
  Atom target;
  int format;
  unsigned long bytesafter, length;
  unsigned char * value, * retval = NULL;
  Bool keep_waiting = True;

  while (keep_waiting) {
    XNextEvent (display, &event);

    switch (event.type) {
    case SelectionNotify:
      if (event.xselection.selection != selection) break;

      if (event.xselection.property == None) {
        print_debug (D_WARN, "Conversion refused");
        value = NULL;
        keep_waiting = False;
      } else if (event.xselection.property == null_atom &&
                 request_target == delete_atom) {
      } else {
	XGetWindowProperty (event.xselection.display,
			    event.xselection.requestor,
			    event.xselection.property, 0L, 1000000,
			    False, (Atom)AnyPropertyType, &target,
			    &format, &length, &bytesafter, &value);

        debug_property (display,D_TRACE, event.xselection.requestor,
                        event.xselection.property, target, length);

        if (request_target == delete_atom && value == NULL) {
          keep_waiting = False;
        } else if (target == incr_atom) {
          /* Handle INCR transfers */
          retval = wait_incr_selection (display,selection, &event.xselection,
                                        *(int *)value);
          keep_waiting = False;
        } else if (target != utf8_atom && target != XA_STRING &&
                   target != compound_text_atom &&
                   request_target != delete_atom) {
          /* Report non-TEXT atoms */
          print_debug (D_WARN, "Selection (type %s) is not a string.",
                       get_atom_name (display,target));
          free (retval);
          retval = NULL;
          keep_waiting = False;
        } else {
          retval = xs_strdup (value);
          XFree (value);
          keep_waiting = False;
        }

        XDeleteProperty (event.xselection.display,
                         event.xselection.requestor,
                         event.xselection.property);

      }
      break;
    default:
      break;
    }
  }

  /* Now that we've received the SelectionNotify event, clear any
   * remaining timeout. */
  if (timeout > 0) {
    setitimer (ITIMER_VIRTUAL, (struct itimerval *)0, (struct itimerval *)0);
  }

  return retval;
}

/*
 * get_selection (selection, request_target)
 *
 * Retrieves the specified selection and returns its value.
 *
 * If a non-zero timeout is specified then set a virtual interval
 * timer. Return NULL and print an error message if the timeout
 * expires before the selection has been retrieved.
 */
static unsigned char *
get_selection (Display * display,Atom selection, Atom request_target)
{
  Atom prop;
  unsigned char * retval;

  prop = XInternAtom (display, "XSEL_DATA", False);
  XConvertSelection (display, selection, request_target, prop, window,
                     timestamp);
  XSync (display, False);

  if (timeout > 0) {
    if (signal (SIGVTALRM, alarm_handler) == SIG_ERR) {
      exit_err ("error setting timeout handler");
    }

    timer.it_interval.tv_sec = 0;
    timer.it_interval.tv_usec = timeout;
    timer.it_value.tv_sec = 0;
    timer.it_value.tv_usec = timeout;

    if (sigsetjmp (env_alrm, 0) == 0) {
      setitimer (ITIMER_VIRTUAL, &timer, (struct itimerval *)0);
      retval = wait_selection (display,selection, request_target);
    } else {
      print_debug (D_WARN, "selection timed out");
      retval = NULL;
    }
  } else {
    retval = wait_selection (display,selection, request_target);
  }

  return retval;
}

/*
 * get_selection_text (Atom selection)
 *
 * Retrieve a text selection. First attempt to retrieve it as UTF_STRING,
 * and if that fails attempt to retrieve it as a plain XA_STRING.
 *
 * NB. Before implementing this, an attempt was made to query TARGETS and
 * request UTF8_STRING only if listed there, as described in:
 * http://www.pps.jussieu.fr/~jch/software/UTF8_STRING/UTF8_STRING.text
 * However, that did not seem to work reliably when tested against various
 * applications (eg. Mozilla Firefox). This method is of course more
 * reliable.
 */
static unsigned char *
get_selection_text (Display * display,Atom selection)
{
  unsigned char * retval;

  if ((retval = get_selection (display,selection, utf8_atom)) == NULL)
    retval = get_selection (display,selection, XA_STRING);

  return retval;
}


/*
 * SELECTION SETTING
 * =================
 *
 * The following functions allow a given selection to be set, appended to
 * or cleared, or to exchange the primary and secondary selections.
 */

static IncrTrack * incrtrack_list = NULL;

/*
 * add_incrtrack (it)
 *
 * Add 'it' to the head of incrtrack_list.
 */
static void
add_incrtrack (IncrTrack * it)
{
  if (incrtrack_list) {
    incrtrack_list->prev = it;
  }
  it->prev = NULL;
  it->next = incrtrack_list;
  incrtrack_list = it;
}

/*
 * fresh_incrtrack ()
 *
 * Create a new incrtrack, and add it to incrtrack_list.
 */
static IncrTrack *
fresh_incrtrack (void)
{
  IncrTrack * it;

  it = (IncrTrack*)xs_malloc (sizeof (IncrTrack));
  add_incrtrack (it);

  return it;
}

/* Forward declaration of handle_multiple() */
static HandleResult
handle_multiple (Display * display,Window requestor, Atom property,
                 unsigned char * sel, Atom selection, Time time,
                 MultTrack * mparent);

/* Forward declaration of process_multiple() */
static HandleResult
process_multiple (Display * display,MultTrack * mt, Bool do_parent);


/*
 * notify_multiple (mt, hr)
 *
 * Confirm the selection request initiated with MULTIPLE tracked by 'mt'.
 */
static void
notify_multiple (Display * display,MultTrack * mt, HandleResult hr)
{
  XSelectionEvent ev;

  /* Call XSync here to make sure any BadAlloc errors are caught before
   * confirming the conversion. */
  XSync (mt->display, False);

  /* Prepare a SelectionNotify event to send, placing the selection in the
   * requested property. */
  ev.type = SelectionNotify;
  ev.display = mt->display;
  ev.requestor = mt->requestor;
  ev.selection = mt->selection;
  ev.time = mt->time;
  ev.target = multiple_atom;

  if (hr & HANDLE_ERR) ev.property = None;
  else ev.property = mt->property;

  XSendEvent (display, ev.requestor, False,
              (unsigned long)NULL, (XEvent *)&ev);
}

/*
 * complete_multiple (mt, do_parent, hr)
 *
 * Complete a MULTIPLE transfer. Iterate to its parent MULTIPLE if
 * 'do_parent' is true. If there is not parent MULTIPLE, send notification
 * of its completion with status 'hr'.
 */
static void
complete_multiple (Display * display,MultTrack * mt, Bool do_parent, HandleResult hr)
{
  MultTrack * mparent = mt->mparent;

  if (mparent) {
    free (mt);
    if (do_parent) process_multiple (display,mparent, True);
  } else {
    notify_multiple (display,mt, hr);
    free (mt);
  }
}

/*
 * change_property (display, requestor, property, target, format, mode,
 *                  data, nelements)
 *
 * Wrapper to XChangeProperty that performs INCR transfer if required and
 * returns status of entire transfer.
 */
static HandleResult
change_property (Display * display, Window requestor, Atom property,
                 Atom target, int format, int mode,
                 unsigned char * data, int nelements,
                 Atom selection, Time time, MultTrack * mparent)
{
  XSelectionEvent ev;
  int nr_bytes;
  IncrTrack * it;

  print_debug (D_TRACE, "change_property ()");

  nr_bytes = nelements * format / 8;

  if (nr_bytes <= max_req) {
    print_debug (D_TRACE, "data within maximum request size");
    XChangeProperty (display, requestor, property, target, format, mode,
                     data, nelements);

    return HANDLE_OK;
  }

  /* else */
  print_debug (D_TRACE, "large data transfer");


  /* Send a SelectionNotify event of type INCR */
  ev.type = SelectionNotify;
  ev.display = display;
  ev.requestor = requestor;
  ev.selection = selection;
  ev.time = time;
  ev.target = incr_atom; /* INCR */
  ev.property = property;

  XSelectInput (ev.display, ev.requestor, PropertyChangeMask);

  XChangeProperty (ev.display, ev.requestor, ev.property, incr_atom, 32,
                   PropModeReplace, (unsigned char *)&nr_bytes, 1);

  XSendEvent (display, requestor, False,
              (unsigned long)NULL, (XEvent *)&ev);

  /* Set up the IncrTrack to track this */
  it = fresh_incrtrack ();

  it->mparent = mparent;
  it->state = S_INCR_1;
  it->display = display;
  it->requestor = requestor;
  it->property = property;
  it->selection = selection;
  it->time = time;
  it->target = target;
  it->format = format;
  it->data = data;
  it->nelements = nelements;
  it->offset = 0;

  /* Maximum nr. of elements that can be transferred in one go */
  it->max_elements = max_req * 8 / format;

  /* Nr. of elements to transfer in this instance */
  it->chunk = MIN (it->max_elements, it->nelements - it->offset);

  /* Wait for that property to get deleted */
  print_debug (D_TRACE, "Waiting on intial property deletion (%s)",
               get_atom_name (display,it->property));

  return HANDLE_INCOMPLETE;
}

/*
 * handle_timestamp (display, requestor, property)
 *
 * Handle a TIMESTAMP request.
 */
static HandleResult
handle_timestamp (Display * display, Window requestor, Atom property,
                  Atom selection, Time time, MultTrack * mparent)
{
  return
    change_property (display, requestor, property, XA_INTEGER, 32,
                     PropModeReplace, (unsigned char *)&timestamp, 1,
                     selection, time, mparent);
}

/*
 * handle_targets (display, requestor, property)
 *
 * Handle a TARGETS request.
 */
static HandleResult
handle_targets (Display * display, Window requestor, Atom property,
                Atom selection, Time time, MultTrack * mparent)
{
  Atom * targets_cpy;

  targets_cpy =(Atom*)malloc (sizeof (supported_targets));
  memcpy (targets_cpy, supported_targets, sizeof (supported_targets));

  return
    change_property (display, requestor, property, XA_ATOM, 32,
                     PropModeReplace, (unsigned char *)targets_cpy,
                     NUM_TARGETS, selection, time, mparent);
}

/*
 * handle_string (display, requestor, property, sel)
 *
 * Handle a STRING request; setting 'sel' as the data
 */
static HandleResult
handle_string (Display * display, Window requestor, Atom property,
               unsigned char * sel, Atom selection, Time time,
               MultTrack * mparent)
{
  return
    change_property (display, requestor, property, XA_STRING, 8,
                     PropModeReplace, sel, xs_strlen(sel),
                     selection, time, mparent);
}

/*
 * handle_utf8_string (display, requestor, property, sel)
 *
 * Handle a UTF8_STRING request; setting 'sel' as the data
 */
static HandleResult
handle_utf8_string (Display * display, Window requestor, Atom property,
                    unsigned char * sel, Atom selection, Time time,
                    MultTrack * mparent)
{
  return
    change_property (display, requestor, property, utf8_atom, 8,
                     PropModeReplace, sel, xs_strlen(sel),
                     selection, time, mparent);
}

/*
 * handle_delete (display, requestor, property)
 *
 * Handle a DELETE request.
 */
static HandleResult
handle_delete (Display * display, Window requestor, Atom property)
{
  XChangeProperty (display, requestor, property, null_atom, 0,
                   PropModeReplace, NULL, 0);

  return DID_DELETE;
}

/*
 * process_multiple (mt, do_parent)
 *
 * Iterate through a MultTrack until it completes, or until one of its
 * entries initiates an interated selection.
 *
 * If 'do_parent' is true, and the actions proscribed in 'mt' are
 * completed during the course of this call, then process_multiple
 * is iteratively called on mt->mparent.
 */
static HandleResult
process_multiple (Display * display,MultTrack * mt, Bool do_parent)
{
  HandleResult retval = HANDLE_OK;
  unsigned long i;

  if (!mt) return retval;

  for (; mt->index < mt->length; mt->index += 2) {
    i = mt->index;
    if (mt->atoms[i] == timestamp_atom) {
      retval |= handle_timestamp (mt->display, mt->requestor, mt->atoms[i+1],
                                  mt->selection, mt->time, mt);
    } else if (mt->atoms[i] == targets_atom) {
      retval |= handle_targets (mt->display, mt->requestor, mt->atoms[i+1],
                                mt->selection, mt->time, mt);
    } else if (mt->atoms[i] == multiple_atom) {
      retval |= handle_multiple (mt->display, mt->requestor, mt->atoms[i+1],
                                 mt->sel, mt->selection, mt->time, mt);
    } else if (mt->atoms[i] == XA_STRING || mt->atoms[i] == text_atom) {
      retval |= handle_string (mt->display, mt->requestor, mt->atoms[i+1],
                               mt->sel, mt->selection, mt->time, mt);
    } else if (mt->atoms[i] == utf8_atom) {
      retval |= handle_utf8_string (mt->display, mt->requestor, mt->atoms[i+1],
                                    mt->sel, mt->selection, mt->time, mt);
    } else if (mt->atoms[i] == delete_atom) {
      retval |= handle_delete (mt->display, mt->requestor, mt->atoms[i+1]);
    } else if (mt->atoms[i] == None) {
      /* the only other thing we know to handle is None, for which we
       * do nothing. This block is, like, __so__ redundant. Welcome to
       * Over-engineering 101 :) This comment is just here to keep the
       * logic documented and separate from the 'else' block. */
    } else {
      /* for anything we don't know how to handle, we fail the conversion
       * by setting this: */
      mt->atoms[i] = None;
    }

    /* If any of the conversions failed, signify this by setting that
     * atom to None ...*/
    if (retval & HANDLE_ERR) {
      mt->atoms[i] = None;
    }
    /* ... but don't propogate HANDLE_ERR */
    retval &= (~HANDLE_ERR);

    if (retval & HANDLE_INCOMPLETE) break;
  }

  if ((retval & HANDLE_INCOMPLETE) == 0) {
    complete_multiple (display,mt, do_parent, retval);
  }

  return retval;
}

/*
 * handle_multiple (display, requestor, property, sel, selection, time)
 *
 * Handle a MULTIPLE request; possibly setting 'sel' if any STRING
 * requests are processed within it. Return value has DID_DELETE bit set
 * if any delete requests are processed.
 *
 * NB. This calls process_multiple with do_parent=False because it is
 * assumed we are "handling" the multiple request on behalf of a
 * multiple already in progress, or (more likely) directly off a
 * SelectionRequest event.
 */
static HandleResult
handle_multiple (Display * display, Window requestor, Atom property,
                 unsigned char * sel, Atom selection, Time time,
                 MultTrack * mparent)
{
  MultTrack * mt;
  int format;
  unsigned long bytesafter;
  HandleResult retval = HANDLE_OK;

  mt = (MultTrack*)xs_malloc (sizeof (MultTrack));

  XGetWindowProperty (display, requestor, property, 0L, 1000000,
                      False, (Atom)AnyPropertyType, &mt->property,
                      &format, &mt->length, &bytesafter,
                      (unsigned char **)&mt->atoms);

  /* Make sure we got the Atom list we want */
  if (format != 32) return HANDLE_OK;


  mt->mparent = mparent;
  mt->display = display;
  mt->requestor = requestor;
  mt->sel = sel;
  mt->selection = selection;
  mt->time = time;
  mt->index = 0;

  retval = process_multiple (display,mt, False);

  return retval;
}
//********************************************************************************
/*
 * This program demonstrates some of the R5 internationalized text
 * input functions.  It creates a very simple window, connects to an
 * input method, and displays composed text obtained by calling
 * XwcLookupString.  It backspaces when it receives the Backspace or
 * Delete keysyms.
 *
 * Note that this program contains a work-around for a bug
 * in the Xsi implementation of XwcLookupString.  If you are using
 * the Ximp implementation, or if the bug has been fixed in your Xlib,
 * you will need to undo the workaround.  See the comment below, near
 * the call to XwcLookupString.
 *
 * This program has not been tested with the Ximp implementation.
*/

//******************************************************************
/*
 * This function chooses the "more desirable" of two input styles.  The
 * style with the more complicated Preedit style is returned, and if the
 * styles have the same Preedit styles, then the style with the more
 * complicated Status style is returned.  There is no "official" way to
 * order interaction styles.  This one makes the most sense to me.
 * This is a long procedure for a simple heuristic.
 */
XIMStyle ChooseBetterStyle(XIMStyle style1,XIMStyle style2)
{
    XIMStyle s,t;
    XIMStyle preedit = XIMPreeditArea | XIMPreeditCallbacks |
        XIMPreeditPosition | XIMPreeditNothing | XIMPreeditNone;
    XIMStyle status = XIMStatusArea | XIMStatusCallbacks |
        XIMStatusNothing | XIMStatusNone;
    if (style1 == 0) return style2;
    if (style2 == 0) return style1;
    if ((style1 & (preedit | status)) == (style2 & (preedit | status)))
        return style1;
    s = style1 & preedit;
    t = style2 & preedit;
    if (s != t) {
        if (s | t | XIMPreeditCallbacks)
            return (s == XIMPreeditCallbacks)?style1:style2;
        else if (s | t | XIMPreeditPosition)
            return (s == XIMPreeditPosition)?style1:style2;
        else if (s | t | XIMPreeditArea)
            return (s == XIMPreeditArea)?style1:style2;
        else if (s | t | XIMPreeditNothing)
            return (s == XIMPreeditNothing)?style1:style2;
    }
    else { /* if preedit flags are the same, compare status flags */
        s = style1 & status;
        t = style2 & status;
        if (s | t | XIMStatusCallbacks)
            return (s == XIMStatusCallbacks)?style1:style2;
        else if (s | t | XIMStatusArea)
            return (s == XIMStatusArea)?style1:style2;
        else if (s | t | XIMStatusNothing)
            return (s == XIMStatusNothing)?style1:style2;
    }
}
void GetPreferredGeometry(XIC ic,char * name,XRectangle* area)
//ic;
//*name;           /* XNPreEditAttributes or XNStatusAttributes */
 //*area;     /* the constraints on the area */
{
    XVaNestedList list;
    list = XVaCreateNestedList(0, XNAreaNeeded, area, NULL);
    /* set the constraints */
    XSetICValues(ic, name, list, NULL);
    /* Now query the preferred size */
    /* The Xsi input method, Xwnmo, seems to ignore the constraints, */
    /* but we're not going to try to enforce them here. */
    XGetICValues(ic, name, list, NULL);
    XFree(list);
}

void SetGeometry(XIC ic,char * name,XRectangle * area)
//ic;
//name;           /* XNPreEditAttributes or XNStatusAttributes */
//area;     /* the actual area to set */
{
    XVaNestedList list;
    list = XVaCreateNestedList(0, XNArea, area, NULL);
    XSetICValues(ic, name, list, NULL);
    XFree(list);
}



/* nothing fancy */
int trans_button(Display *disp,double d, Window target_win)
{
    #define OPAQUE	0xffffffff
    #define OPACITY	"_NET_WM_WINDOW_OPACITY"
    unsigned int opacity;

    opacity = (unsigned int) (d * OPAQUE);
    XChangeProperty(disp, target_win, XInternAtom(disp, OPACITY, False), 
		        XA_CARDINAL, 32, PropModeReplace, 
		        (unsigned char *) &opacity, 1L);
    XSync(disp, False);
    return 0;
}

void init_button(imenu &im)
{
    int i;
    im.t_group=0;
    im.m_group_begin=-1;
    im.m_group_end=-1;
    im.show_lines=15;
    im.x=100;
    im.y=60;
    im.width1=500;
    im.width2=80;
    im.width3=60;
    im.width4=150;
    im.height=25;
    im.width_text=500;
    im.w_gap=3;
    im.h_gap=15;
    im.font_size=11;
    char home[1024];
    sprintf(home,"%s",getenv("HOME"));
    if ( strcmp(home,"") == 0 )
        printf("fatal error: no /home/xxx found!\n");
    char font_path[1024];
    sprintf(font_path,"%s/.icon-DE/fonts",home);
    imlib_add_path_to_font_path(font_path);
    imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
    imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");
    char font_name[128];
    sprintf(font_name,"Vera/%d",im.font_size);
    im.font = imlib_load_font(font_name);
    if (im.font == NULL)
    {
        sprintf(font_name,"wqy-zenhei.ttc/%d",im.font_size);
        im.font = imlib_load_font(font_name);
    }

    im.font2 = imlib_load_font("Vera/8");
    if (im.font2 == NULL)
        im.font2 = imlib_load_font("wqy-zenhei.ttc/8");
//    imlib_context_set_font(font3);
//    imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
    im.menu1.text[0]='\0';
    im.menu1.group=-1;
    im.menu1.tag_int=0;
    im.menu1.tag_text[0]='\0';
    im.menu1.selected=0;
    im.menu1.flash=1;
    im.menu1.hide=0;
    im.menu1.w_id=0;

    sprintf(im.b_up.text,"/\\");
    im.b_up.group=-1;
    im.b_up.tag_int=0;
    im.b_up.tag_text[0]='\0';
    im.b_up.selected=0;
    im.b_up.flash=0;
    im.b_up.hide=0;
    im.b_up.w_id=0;

    sprintf(im.b_down.text,"\\/");
    im.b_down.group=-1;
    im.b_down.tag_int=0;
    im.b_down.tag_text[0]='\0';
    im.b_down.selected=0;
    im.b_down.flash=0;
    im.b_down.hide=0;
    im.b_down.w_id=0;

    for (i=0;i<50;i++)
    {
        im.menu2[i].text[0]='\0';
        im.menu2[i].group=i;
        im.menu2[i].tag_int=0;
        im.menu2[i].tag_text[0]='\0';
        im.menu2[i].selected=0;
        im.menu2[i].flash=0;
        im.menu2[i].hide=1;
        im.menu2[i].w_id=0;
    }
    for (i=0;i<500;i++)
    {
        im.menu3[i].text[0]='\0';
        im.menu3[i].group=0;
        im.menu3[i].tag_int=0;
        im.menu3[i].tag_text[0]='\0';
        im.menu3[i].selected=0;
        im.menu3[i].flash=0;
        im.menu3[i].hide=1;
        im.menu3[i].w_id=0;
    }
    sprintf(im.menu4[0].text,"  确定  ");
    im.menu4[0].group=-1;
    im.menu4[0].tag_int=0;
    im.menu4[0].tag_text[0]='\0';
    im.menu4[0].selected=0;
    im.menu4[0].flash=0;
    im.menu4[0].hide=0;
    im.menu4[0].w_id=0;

    sprintf(im.menu4[1].text,"  取消  ");
    im.menu4[1].group=-1;
    im.menu4[1].tag_int=0;
    im.menu4[1].tag_text[0]='\0';
    im.menu4[1].selected=0;
    im.menu4[1].flash=0;
    im.menu4[1].hide=0;
    im.menu4[1].w_id=0;

    sprintf(im.menu4[2].text,"  其他  ");
    im.menu4[2].group=-1;
    im.menu4[2].tag_int=0;
    im.menu4[2].tag_text[0]='\0';
    im.menu4[2].selected=0;
    im.menu4[2].flash=0;
    im.menu4[2].hide=1;
    im.menu4[2].w_id=0;

    sprintf(im.input.text,"请在此录入。ESC清除；CTRL-V粘贴；BackSpace删除。");
    im.input.tag_text[0]='\0';
    im.input.hide=1;
    im.input.is_passwd=0;
    im.input.w_id=0;
    im.input.w_ip=0;
    im.input.cur=0;
    im.input.str_len=0;
    im.input.insert=1;
}

int creat_button(Display *disp,imenu &im)
{
    Imlib_Image                 buffer3;
    int    text_w, text_h;
    Atom test_atom;
    XGCValues gcv;
    XFontSet fontset;
    XIM xim;
    XIMStyles *im_supported_styles;
    XIMStyle app_supported_styles;
    XIMStyle style;
    XIMStyle best_style;
    XVaNestedList list;
    long im_event_mask;
    char **missing_charsets;
    int num_missing_charsets = 0;
    char *default_string;
    int i;
    int black;
    int s=0;

    char home[1024];
    sprintf(home,"%s",getenv("HOME"));
    if ( strcmp(home,"") == 0 )

    {
        printf("fatal error: no /home/xxx found!\n");
//        return 1;
    }
    Imlib_Color_Range            range;

    button_vis = DefaultVisual(disp, DefaultScreen(disp));
    button_depth = DefaultDepth(disp, DefaultScreen(disp));
    button_cm = DefaultColormap(disp, DefaultScreen(disp));
                // text

    char usermenufile[256],f_buffer[1024],ch2[1024];
    FILE * fp2=NULL;
    sprintf(usermenufile,"%s/.icon-DE/icon-de.rc",home);
    if (access(usermenufile,0)!=-1)
    {
        fp2=fopen(usermenufile,"r");
    }
    else if (access("/etc/icon-de/icon-de.rc",0)!=-1)
        fp2=fopen("/etc/icon-de/icon-de.rc","r");
    if (fp2==NULL)
    {
        printf("can't open icon-de.rc\n");
    }
    else
    {
        fgets(f_buffer,1024,fp2);
        for (i=0;i<1024;i++)
            if (f_buffer[i]=='\n') f_buffer[i]='\0';
        while ( ! feof(fp2) )
        {
            if (b_check_rc(f_buffer,"tag_color:")==0 )
            {
                b_get_str(ch2,f_buffer,"tag_color:");
                b_get_int2(bc_red,ch2,1);
                b_get_int2(bc_green,ch2,2);
                b_get_int2(bc_blue,ch2,3);
                b_get_int2(bc_alpha,ch2,4);
            }
            if (b_check_rc(f_buffer,"font_color:")==0 )
            {
                b_get_str(ch2,f_buffer,"font_color:");
                b_get_int2(bf_red,ch2,1);
                b_get_int2(bf_green,ch2,2);
                b_get_int2(bf_blue,ch2,3);
                b_get_int2(bf_alpha,ch2,4);
            }
            fgets(f_buffer,1024,fp2);
            for (i=0;i<1024;i++)
                if (f_buffer[i]=='\n') f_buffer[i]='\0';
        }
        fclose(fp2);
    }
    range = imlib_create_color_range();
    imlib_context_set_color_range(range);
    imlib_context_set_color(255, 255, 255, 255);
    imlib_add_color_to_color_range(0);
    /* add an orange color, semi-transparent 10 units from the first */
//    imlib_context_set_color(255, 200, 10, 255);
    imlib_context_set_color(bc_red, bc_green, bc_blue, bc_alpha);
    imlib_add_color_to_color_range(10);
    /* add black, fully transparent at the end 20 units away */
    imlib_context_set_color(70, 0, 0, 255);
    imlib_add_color_to_color_range(20);
    button_attr.override_redirect=True;

     /**
        * Start rendering
        */

    imlib_context_set_display(disp);
    imlib_context_set_visual(button_vis);
    imlib_context_set_colormap(button_cm);
    imlib_context_set_dither(1);
    imlib_context_set_blend(0);
    imlib_context_set_color_modifier(NULL);
    imlib_context_set_font(im.font);
    imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);

    buffer3 = imlib_create_image(im.width1+200, im.height+10);    
    
    if (im.b_up.hide!=1)
    {
        imlib_get_text_size(im.b_up.text, &text_w, &text_h);
        im.b_up.w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x,im.y,text_w+10,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        XSelectInput(disp, im.b_up.w_id,  ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        XRaiseWindow(disp,im.b_up.w_id);
        XMapWindow(disp, im.b_up.w_id);

        imlib_get_text_size(im.b_up.text, &text_w, &text_h);
        imlib_context_set_drawable(im.b_up.w_id); 
        imlib_context_set_image(buffer3);
        imlib_free_image();
        buffer3 = imlib_create_image(im.width1+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_context_set_image(buffer3);
        imlib_context_set_drawable(im.b_up.w_id); 
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        imlib_text_draw(5,(im.height-text_h)/2,im.b_up.text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
    }

    if (im.menu1.hide!=1)
    {
        if (im.b_up.hide!=1)
            im.menu1.w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x+text_w+10+im.w_gap,im.y,im.width1,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        else
            im.menu1.w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x,im.y,im.width1,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        XSelectInput(disp, im.menu1.w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        imlib_get_text_size(im.menu1.text, &text_w, &text_h);
        XRaiseWindow(disp,im.menu1.w_id);
        XMapWindow(disp, im.menu1.w_id);
        imlib_get_text_size(im.menu1.text, &text_w, &text_h);
        imlib_context_set_drawable(im.menu1.w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_free_image();
        buffer3 = imlib_create_image(im.width1+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, im.width1*4, im.height*2,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=im.width1) 
            imlib_text_draw(5,(im.height-text_h)/2,im.menu1.text);
        else
            imlib_text_draw((im.width1-text_w)/2,(im.height-text_h)/2,im.menu1.text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
    }
    
    int n,m,o,x,text_cw,text_ch;
    char s_l[1024];
    
    if (im.t_group<0)
      im.t_group=0;
    if (im.t_group+im.show_lines>50)
      im.t_group=50-im.show_lines;
    o=0;
    for (i=im.t_group;i<im.t_group+im.show_lines;i++)
    {
        if (im.menu2[i].hide!=1)
        {
            im.menu2[i].w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x,im.y+(im.h_gap+im.height)*(o+1),im.width2,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
            XSelectInput(disp, im.menu2[i].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
            imlib_get_text_size(im.menu2[i].text, &text_w, &text_h);
            XRaiseWindow(disp,im.menu2[i].w_id);
            XMapWindow(disp, im.menu2[i].w_id);
            imlib_context_set_drawable(im.menu2[i].w_id); 
                 /* draw the range */
            imlib_context_set_image(buffer3);
            imlib_free_image();
            buffer3 = imlib_create_image(im.width2+200, im.height+10);    
            imlib_context_set_image(buffer3);
            imlib_free_image();
            buffer3 = imlib_create_image(im.width2+200, im.height+10);    
            imlib_context_set_image(buffer3);
            imlib_image_fill_color_range_rectangle(0,0, im.width2*4, im.height*2,-45.0);
                 /* free it */
                    //         imlib_free_color_range();
            imlib_context_set_image(buffer3);
            imlib_context_set_drawable(im.menu2[i].w_id); 
            imlib_render_image_on_drawable(0, 0); 
            imlib_context_set_font(im.font);
            imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
            if (text_w>=im.width2) 
                imlib_text_draw(5,(im.height-text_h)/2,im.menu2[i].text);
            else
                imlib_text_draw((im.width2-text_w)/2,(im.height-text_h)/2,im.menu2[i].text);
            /* set the buffer image as our current image */
            imlib_context_set_image(buffer3);
            imlib_render_image_on_drawable(0, 0); 
            imlib_context_set_image(buffer3);
            m=0;
            for (n=0;n<500;n++)
            {
                if ((im.menu3[n].hide!=1) and (im.menu3[n].group==im.menu2[i].group))
                {
                    im.menu3[n].w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x+im.width2+im.w_gap+(im.width3+im.w_gap)*(m),im.y+(im.h_gap+im.height)*(o+1),im.width3,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
                    XSelectInput(disp, im.menu3[n].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
                    imlib_get_text_size(im.menu3[n].text, &text_w, &text_h);
                    XRaiseWindow(disp,im.menu3[n].w_id);
                    XMapWindow(disp, im.menu3[n].w_id);
                    imlib_context_set_drawable(im.menu3[n].w_id); 
                         /* draw the range */
                    imlib_context_set_image(buffer3);
                    imlib_free_image();
                    buffer3 = imlib_create_image(im.width3+200, im.height+10);    
                    imlib_context_set_image(buffer3);
                    imlib_image_fill_color_range_rectangle(0,0, im.width3*4, im.height*2,-45.0);
                         /* free it */
                            //         imlib_free_color_range();
                    imlib_render_image_on_drawable(0, 0); 
                    imlib_context_set_font(im.font2);
                    imlib_get_text_size("√", &text_w, &text_h);
                    imlib_context_set_color(0, 0, 255, 255);
                    if (im.menu3[n].selected==1)
                        imlib_text_draw(1,(im.height-text_h)/2,"√");
                    /* set the buffer image as our current image */

                    imlib_render_image_on_drawable(0, 0); 
                    imlib_context_set_font(im.font);
                    imlib_get_text_size(im.menu3[n].text, &text_w, &text_h);
                    imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
                    if (text_w>=im.width3) 
                        imlib_text_draw(5,(im.height-text_h)/2,im.menu3[n].text);
                    else
                        imlib_text_draw((im.width3-text_w)/2,(im.height-text_h)/2,im.menu3[n].text);
                    /* set the buffer image as our current image */
                    imlib_context_set_image(buffer3);
                    imlib_render_image_on_drawable(0, 0); 
                    imlib_context_set_image(buffer3);
                    if (im.menu3[n].selected==1)
                        trans_button(disp,1,im.menu3[n].w_id);
                    else
                        trans_button(disp,0.65,im.menu3[n].w_id);
                    m=m+1;
                }
            }
            o=o+1;
        }
    }
    if (im.input.hide!=1)
    {
        black = BlackPixel (disp, DefaultScreen (disp));
        window = XCreateSimpleWindow (disp, DefaultRootWindow(disp), 0, 0, 1, 1, 0, black, black);

        /* Get a timestamp */
        XSelectInput (disp, window, PropertyChangeMask);
        im.input.have_xim=1;
        timestamp = get_timestamp (disp);

        max_req = 4000;

        /* Consistency check */
        test_atom = XInternAtom (disp, "PRIMARY", False);
        if (test_atom != XA_PRIMARY)
        {
            printf ("XA_PRIMARY not named \"PRIMARY\"\n");
            im.input.have_xim=0;
        }
        test_atom = XInternAtom (disp, "SECONDARY", False);
        if (test_atom != XA_SECONDARY)
        {
            printf ("XA_SECONDARY not named \"SECONDARY\"\n");
            im.input.have_xim=0;
        }

        NUM_TARGETS=0;

        /* Get the TIMESTAMP atom */
        timestamp_atom = XInternAtom (disp, "TIMESTAMP", False);
        supported_targets[s++] = timestamp_atom;
        NUM_TARGETS++;

        /* Get the MULTIPLE atom */
        multiple_atom = XInternAtom (disp, "MULTIPLE", False);
        supported_targets[s++] = multiple_atom;
        NUM_TARGETS++;

        /* Get the TARGETS atom */
        targets_atom = XInternAtom (disp, "TARGETS", False);
        supported_targets[s++] = targets_atom;
        NUM_TARGETS++;

        /* Get the DELETE atom */
        delete_atom = XInternAtom (disp, "DELETE", False);
        supported_targets[s++] = delete_atom;
        NUM_TARGETS++;

        /* Get the INCR atom */
        incr_atom = XInternAtom (disp, "INCR", False);
        supported_targets[s++] = incr_atom;
        NUM_TARGETS++;

        /* Get the NULL atom */
        null_atom = XInternAtom (disp, "NULL", False);
        NUM_TARGETS++;

        /* Get the TEXT atom */
        text_atom = XInternAtom (disp, "TEXT", False);
        supported_targets[s++] = text_atom;
        NUM_TARGETS++;

        /* Get the UTF8_STRING atom */
        utf8_atom = XInternAtom (disp, "UTF8_STRING", True);
        if(utf8_atom != None) {
            supported_targets[s++] = utf8_atom;
            NUM_TARGETS++;
        } else {
            utf8_atom = XA_STRING;
        }

        supported_targets[s++] = XA_STRING;
        NUM_TARGETS++;

        if (NUM_TARGETS > MAX_NUM_TARGETS) {
            printf ("internal error num-targets (%d) > max-num-targets (%d)\n",
                  NUM_TARGETS, MAX_NUM_TARGETS);
            im.input.have_xim=0;
        }
        if (setlocale(LC_ALL, "") == NULL) {
            printf( "cannot set locale.");
            im.input.have_xim=0;
        }
        if (!XSupportsLocale()) {
            printf( "X does not support locale %s."
                           , setlocale(LC_ALL, NULL));
            im.input.have_xim=0;
        }
        if (XSetLocaleModifiers("") == NULL) {
            printf( "Warning: cannot set locale modifiers.");
            im.input.have_xim=0;
        }
        fontset = XCreateFontSet(disp,
                                 "-*-wenquanyi bitmap song-medium-r-normal-*-12-*-*-*-*-*-iso10646-*,\
                                  -misc-fixed-*-r-*-*-*-130-*-*-*-*-*-*",
                                 &missing_charsets, &num_missing_charsets,
                                 &default_string);
        if (num_missing_charsets > 0) {
            printf("The following charsets are missing:");
            for(i=0; i < num_missing_charsets; i++)
                printf( "%s", missing_charsets[i]);
            XFreeStringList(missing_charsets);
            printf("The string %s will be used in place", default_string);
            printf("of any characters from those sets.");
        } 

        im.input.w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x,im.y+(im.h_gap+im.height)*(o+1),im.width_text,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        button_attr.override_redirect=False;
        im.input.w_ip=XCreateWindow(disp,DefaultRootWindow(disp),im.x,im.y+(im.h_gap+im.height)*(o+2),im.width_text,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        button_attr.override_redirect=True;

        im.gc = XCreateGC(disp,im.input.w_ip,0,&gcv);
        XSetForeground(disp,im.gc,WhitePixel(disp,DefaultScreen(disp)));
        XSetBackground(disp,im.gc,BlackPixel(disp,DefaultScreen(disp)));

        
        if ((xim = XOpenIM(disp, NULL, NULL, NULL)) == NULL) {
            printf( "Couldn't open input method");
            im.input.have_xim=0;
        }
        if (im.input.have_xim==1)
        {
            /* set flags for the styles our application can support */
            app_supported_styles = XIMPreeditNone | XIMPreeditNothing | XIMPreeditArea;
            app_supported_styles |= XIMStatusNone | XIMStatusNothing | XIMStatusArea;
            /* figure out which styles the IM can support */
            XGetIMValues(xim, XNQueryInputStyle, &im_supported_styles, NULL);
            /*
             * now look at each of the IM supported styles, and
             * chose the "best" one that we can support.
             */
            best_style = 0;
            for(i=0; i < im_supported_styles->count_styles; i++) {
                style = im_supported_styles->supported_styles[i];
                if ((style & app_supported_styles) == style) /* if we can handle it */
                    best_style = ChooseBetterStyle(style, best_style);
            }
            /* if we couldn't support any of them, print an error and exit */
            if (best_style == 0) {
                printf("application and program do not share a");
                printf("commonly supported interaction style.");
                im.input.have_xim=0;
            }
            XFree(im_supported_styles);
            if (im.input.have_xim==1)
            {
                list = XVaCreateNestedList(0,XNFontSet,fontset,NULL);
                im.ic = XCreateIC(xim,
                               XNInputStyle, best_style,
                               XNClientWindow, im.input.w_ip,
                               XNPreeditAttributes, list,
                               XNStatusAttributes, list,
                               NULL);
                XFree(list);
                if (im.ic == NULL) {
                    printf("Couldn't create input context");
                    im.input.have_xim=0;
                }
            }
            if (im.input.have_xim==1)
                XGetICValues(im.ic, XNFilterEvents, &im_event_mask, NULL);
        }
        XSelectInput(disp, im.input.w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        XRaiseWindow(disp,im.input.w_id);
        XMapWindow(disp, im.input.w_id);

        XSelectInput(disp, im.input.w_ip, ExposureMask | KeyPressMask | StructureNotifyMask | im_event_mask);
        XRaiseWindow(disp,im.input.w_ip);
        XMapWindow(disp, im.input.w_ip);

        MWMHints mwmhints;
        Atom prop;

        memset(&mwmhints, 0, sizeof(mwmhints));
        prop = XInternAtom(disp, "_MOTIF_WM_HINTS", False);
        mwmhints.flags = MWM_HINTS_DECORATIONS;
        mwmhints.decorations = 0;
        XChangeProperty(disp, im.input.w_ip, prop, prop, 32, PropModeReplace,
                        (unsigned char *) &mwmhints,
                        PROP_MWM_HINTS_ELEMENTS);

        unsigned long action;
        gchar *tmp_prop1, *tmp1;
        const char *p1="above";
        Atom prop1 = 0;
        action = _NET_WM_STATE_ADD;
        tmp_prop1 = g_strdup_printf("_NET_WM_STATE_%s", tmp1 = g_ascii_strup(p1, -1));
        prop1 = XInternAtom(disp, tmp_prop1, False);
        button_client_msg(disp, im.input.w_ip, "_NET_WM_STATE", 
            action, (unsigned long)prop1, 0, 0, 0);
        XSync(disp, False);
        XMoveResizeWindow(disp, im.input.w_ip, im.x,im.y+(im.h_gap+im.height)*(o+2),im.width_text,im.height);
        XFlush(disp);
        XSync(disp, False);
        imlib_get_text_size(im.input.text, &text_w, &text_h);
        imlib_context_set_drawable(im.input.w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_free_image();
        buffer3 = imlib_create_image(im.width_text+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0,im.width_text+200,im.height+100,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=im.width_text) 
            imlib_text_draw(5,(im.height-text_h)/2,im.input.text);
        else
            imlib_text_draw((im.width_text-text_w)/2,(im.height-text_h)/2,im.input.text);
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_free_image();
        imlib_context_set_font(im.font);
        imlib_get_text_size(im.input.tag_text, &text_w, &text_h);
        imlib_context_set_drawable(im.input.w_ip); 
             /* draw the range */
        buffer3 = imlib_create_image(im.width_text+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0,im.width_text+200, im.height+45,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font2);
        imlib_context_set_color(255, 0, 0, 255);
        if (text_w<im.width_text-20)
            x=0;
        else
            x=im.width_text-text_w-20;
        if (im.input.insert==0)
        {
            imlib_get_text_size("△", &text_cw, &text_ch);
            imlib_text_draw(x+text_w+5-text_cw/2,im.height-(im.height-text_h)/2-5,"△");
        }
        else
        {
            imlib_get_text_size("▲", &text_cw, &text_ch);
            imlib_text_draw(x+text_w+5-text_cw/2,im.height-(im.height-text_h)/2-5,"▲");
        }
        sprintf(s_l,"%s",im.input.tag_text);
//        printf("%s▲%s\n",s_l,s_r);
        imlib_context_set_font(im.font);
        if (im.input.is_passwd==0)
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
            imlib_text_draw(x+5,(im.height-text_h)/2,im.input.tag_text);
        }
        else
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, 10);
            imlib_text_draw(x+5,(im.height-text_h)/2,im.input.tag_text);
        }
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
//        printf("%d,%s\n",im.input.str_len,im.input.tag_text);
        o=o+2;
        
    }

    if (im.b_down.hide!=1)
    {
        imlib_get_text_size(im.b_down.text, &text_w, &text_h);
        im.b_down.w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x,im.y+(im.h_gap+im.height)*(o+1),text_w+10,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        XSelectInput(disp, im.b_down.w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        XRaiseWindow(disp,im.b_down.w_id);
        XMapWindow(disp, im.b_down.w_id);
        imlib_context_set_drawable(im.b_down.w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_free_image();
        buffer3 = imlib_create_image(text_w+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, text_w*4, im.height*2,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        imlib_text_draw(5,(im.height-text_h)/2,im.b_down.text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
    }
    int xl;
    if (im.b_down.hide!=1)
        xl=text_w+10+im.w_gap;
    else
        xl=0;
    if (im.menu4[0].hide!=1)
    {
        im.menu4[0].w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x+xl,im.y+(im.h_gap+im.height)*(o+1),im.width4,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        xl=xl+im.width4+im.w_gap;
        XSelectInput(disp, im.menu4[0].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        imlib_get_text_size(im.menu4[0].text, &text_w, &text_h);
        XRaiseWindow(disp,im.menu4[0].w_id);
        XMapWindow(disp, im.menu4[0].w_id);
        imlib_context_set_drawable(im.menu4[0].w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_free_image();
        buffer3 = imlib_create_image(im.width4+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, im.width4*4, im.height*2,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=im.width4) 
            imlib_text_draw(5,(im.height-text_h)/2,im.menu4[0].text);
        else
            imlib_text_draw((im.width4-text_w)/2,(im.height-text_h)/2,im.menu4[0].text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
    }
    if (im.menu4[1].hide!=1)
    {
        im.menu4[1].w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x+xl,im.y+(im.h_gap+im.height)*(o+1),im.width4,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        XSelectInput(disp, im.menu4[1].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        xl=xl+im.width4+im.w_gap;
        XRaiseWindow(disp,im.menu4[1].w_id);
        XMapWindow(disp, im.menu4[1].w_id);
        imlib_context_set_drawable(im.menu4[1].w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_free_image();
        buffer3 = imlib_create_image(im.width4+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, im.width4*4, im.height*2,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font);
        imlib_get_text_size(im.menu4[1].text, &text_w, &text_h);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=im.width4) 
            imlib_text_draw(5,(im.height-text_h)/2,im.menu4[1].text);
        else
            imlib_text_draw((im.width4-text_w)/2,(im.height-text_h)/2,im.menu4[1].text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
    }
    if (im.menu4[2].hide!=1)
    {
        if (im.b_down.hide!=1)
            im.menu4[2].w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x+xl+(im.width4+im.w_gap)*2,im.y+(im.h_gap+im.height)*(o+1),im.width4,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        else
            im.menu4[2].w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x+(im.width4+im.w_gap)*2,im.y+(im.h_gap+im.height)*(o+1),im.width4,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
        XSelectInput(disp, im.menu4[2].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
        XRaiseWindow(disp,im.menu4[2].w_id);
        XMapWindow(disp, im.menu4[2].w_id);
        imlib_context_set_drawable(im.menu4[2].w_id); 
             /* draw the range */
        imlib_context_set_image(buffer3);
        imlib_free_image();
        buffer3 = imlib_create_image(im.width4+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0, im.width4*4, im.height*2,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font);
        imlib_get_text_size(im.menu4[2].text, &text_w, &text_h);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (text_w>=im.width4) 
            imlib_text_draw(5,(im.height-text_h)/2,im.menu4[2].text);
        else
            imlib_text_draw((im.width4-text_w)/2,(im.height-text_h)/2,im.menu4[2].text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
    }
    if (im.input.hide!=1)
    {
        sleep (1);
        imlib_context_set_font(im.font);
        imlib_get_text_size(im.input.tag_text, &text_w, &text_h);
        imlib_context_set_drawable(im.input.w_ip); 
             /* draw the range */
        buffer3 = imlib_create_image(im.width_text+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0,im.width_text+200, im.height+45,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font2);
        imlib_context_set_color(255, 0, 0, 255);
        if (text_w<im.width_text-20)
            x=0;
        else
            x=im.width_text-text_w-20;
        if (im.input.insert==0)
        {
            imlib_get_text_size("△", &text_cw, &text_ch);
            imlib_text_draw(x+text_w+5-text_cw/2,im.height-(im.height-text_h)/2-5,"△");
        }
        else
        {
            imlib_get_text_size("▲", &text_cw, &text_ch);
            imlib_text_draw(x+text_w+5-text_cw/2,im.height-(im.height-text_h)/2-5,"▲");
        }
        sprintf(s_l,"%s",im.input.tag_text);
//        printf("%s▲%s\n",s_l,s_r);
        imlib_context_set_font(im.font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (im.input.is_passwd==0)
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
            imlib_text_draw(x+5,(im.height-text_h)/2,im.input.tag_text);
        }
        else
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, 10);
            imlib_text_draw(x+5,(im.height-text_h)/2,im.input.tag_text);
        }
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
//        printf("%d,%s\n",im.input.str_len,im.input.tag_text);
    }
    imlib_context_set_image(buffer3);
    imlib_free_image();
    return 0;
}

void destory_button(Display *disp,imenu &im)
{
    int i;
    im.t_group=0;
    im.m_group_begin=-1;
    im.m_group_end=-1;
    im.show_lines=15;
    im.x=100;
    im.y=60;
    im.width1=300;
    im.width2=80;
    im.width3=60;
    im.width4=100;
    im.height=25;
    im.w_gap=3;
    im.h_gap=15;
    im.font_size=11;
    char home[1024];
    sprintf(home,"%s",getenv("HOME"));
    if ( strcmp(home,"") == 0 )
        printf("fatal error: no /home/xxx found!\n");
    char font_path[1024];
    sprintf(font_path,"%s/.icon-DE/fonts",home);
    imlib_add_path_to_font_path(font_path);
    imlib_add_path_to_font_path("/usr/share/fonts/truetype/wqy/");
    imlib_add_path_to_font_path("/usr/share/fonts/wenquanyi/wqy-zenhei/");
    char font_name[128];
    sprintf(font_name,"Vera/%d",im.font_size);
    im.font = imlib_load_font(font_name);
    if (im.font == NULL)
    {
        sprintf(font_name,"wqy-zenhei.ttc/%d",im.font_size);
        im.font = imlib_load_font(font_name);
    }

    im.font2 = imlib_load_font("Vera/8");
    if (im.font2 == NULL)
        im.font2 = imlib_load_font("wqy-zenhei.ttc/8");
//    imlib_context_set_font(font3);
//    imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
    im.menu1.text[0]='\0';
    im.menu1.group=-1;
    im.menu1.tag_int=0;
    im.menu1.tag_text[0]='\0';
    im.menu1.selected=0;
    im.menu1.flash=1;
    im.menu1.hide=1;
    if (im.menu1.w_id!=0)
    {
        XDestroyWindow(disp,im.menu1.w_id);
        im.menu1.w_id=0;
    }

    sprintf(im.b_up.text,"/\\");
    im.b_up.group=-1;
    im.b_up.tag_int=0;
    im.b_up.tag_text[0]='\0';
    im.b_up.selected=0;
    im.b_up.flash=0;
    im.b_up.hide=1;
    if (im.b_up.w_id!=0)
    {
        XDestroyWindow(disp,im.b_up.w_id);
        im.b_up.w_id=0;
    }

    sprintf(im.b_down.text,"\\/");
    im.b_down.group=-1;
    im.b_down.tag_int=0;
    im.b_down.tag_text[0]='\0';
    im.b_down.selected=0;
    im.b_down.flash=0;
    im.b_down.hide=1;
    if (im.b_down.w_id!=0)
    {
        XDestroyWindow(disp,im.b_down.w_id);
        im.b_down.w_id=0;
    }

    for (i=0;i<50;i++)
    {
        im.menu2[i].text[0]='\0';
        im.menu2[i].group=i;
        im.menu2[i].tag_int=0;
        im.menu2[i].tag_text[0]='\0';
        im.menu2[i].selected=0;
        im.menu2[i].flash=0;
        im.menu2[i].hide=1;
        if (im.menu2[i].w_id!=0)
        {
            XDestroyWindow(disp,im.menu2[i].w_id);
            im.menu2[i].w_id=0;
        }
    }
    for (i=0;i<500;i++)
    {
        im.menu3[i].text[0]='\0';
        im.menu3[i].group=0;
        im.menu3[i].tag_int=0;
        im.menu3[i].tag_text[0]='\0';
        im.menu3[i].selected=0;
        im.menu3[i].flash=0;
        im.menu3[i].hide=1;
        if (im.menu3[i].w_id!=0)
        {
            XDestroyWindow(disp,im.menu3[i].w_id);
            im.menu3[i].w_id=0;
        }
    }
    sprintf(im.menu4[0].text,"  确定  ");
    im.menu4[0].group=-1;
    im.menu4[0].tag_int=0;
    im.menu4[0].tag_text[0]='\0';
    im.menu4[0].selected=0;
    im.menu4[0].flash=0;
    im.menu4[0].hide=1;
    if (im.menu4[0].w_id!=0)
    {
        XDestroyWindow(disp,im.menu4[0].w_id);
        im.menu4[0].w_id=0;
    }

    sprintf(im.menu4[1].text,"  取消  ");
    im.menu4[1].group=-1;
    im.menu4[1].tag_int=0;
    im.menu4[1].tag_text[0]='\0';
    im.menu4[1].selected=0;
    im.menu4[1].flash=0;
    im.menu4[1].hide=1;
    if (im.menu4[1].w_id!=0)
    {
        XDestroyWindow(disp,im.menu4[1].w_id);
        im.menu4[1].w_id=0;
    }

    sprintf(im.menu4[2].text,"  其他  ");
    im.menu4[2].group=-1;
    im.menu4[2].tag_int=0;
    im.menu4[2].tag_text[0]='\0';
    im.menu4[2].selected=0;
    im.menu4[2].flash=0;
    im.menu4[2].hide=1;
    if (im.menu4[2].w_id!=0)
    {
        XDestroyWindow(disp,im.menu4[2].w_id);
        im.menu4[2].w_id=0;
    }
    if (im.input.w_id!=0)
    {
        XDestroyWindow(disp,im.input.w_id);
        im.input.w_id=0;
    }
    if (im.input.w_ip!=0)
    {
        XDestroyWindow(disp,im.input.w_ip);
        im.input.w_ip=0;
    }
    sprintf(im.input.text,"请在此录入。（支持：ESC清除；CTRL-V粘贴）");
    im.input.tag_text[0]='\0';
    im.input.hide=1;
    im.input.is_passwd=0;
    im.input.w_id=0;
    im.input.w_ip=0;
    im.input.str_len=0;
    im.input.insert=1;
    im.input.cur=0;
    imlib_context_set_font(im.font);
    imlib_free_font();
    imlib_context_set_font(im.font2);
    imlib_free_font();
}

void hide_button(Display *disp,imenu &im)
{
    int i;
    if (im.menu1.w_id!=0)
    {
        XDestroyWindow(disp,im.menu1.w_id);
        im.menu1.w_id=0;
    }
    if (im.b_up.w_id!=0)
    {
        XDestroyWindow(disp,im.b_up.w_id);
        im.b_up.w_id=0;
    }

    if (im.b_down.w_id!=0)
    {
        XDestroyWindow(disp,im.b_down.w_id);
        im.b_down.w_id=0;
    }

    for (i=0;i<50;i++)
    {
        if (im.menu2[i].w_id!=0)
        {
            XDestroyWindow(disp,im.menu2[i].w_id);
            im.menu2[i].w_id=0;
        }
    }
    for (i=0;i<500;i++)
    {
        if (im.menu3[i].w_id!=0)
        {
            XDestroyWindow(disp,im.menu3[i].w_id);
            im.menu3[i].w_id=0;
        }
    }

    if (im.input.w_id!=0)
    {
        XDestroyWindow(disp,im.input.w_id);
        im.input.w_id=0;
    }

    if (im.input.w_ip!=0)
    {
        XDestroyWindow(disp,im.input.w_ip);
        im.input.w_ip=0;
    }

    if (im.menu4[0].w_id!=0)
    {
        XDestroyWindow(disp,im.menu4[0].w_id);
        im.menu4[0].w_id=0;
    }

    if (im.menu4[1].w_id!=0)
    {
        XDestroyWindow(disp,im.menu4[1].w_id);
        im.menu4[1].w_id=0;
    }

    if (im.menu4[2].w_id!=0)
    {
        XDestroyWindow(disp,im.menu4[2].w_id);
        im.menu4[2].w_id=0;
    }
}


void filter_button(Display *disp,imenu &im,int mode)
{
    char home[1024];
    sprintf(home,"%s",getenv("HOME"));
    if ( strcmp(home,"") == 0 )

    {
        printf("fatal error: no /home/xxx found!\n");
//        return 1;
    }
    int i,m,n,o,text_w,text_h;
    Imlib_Image                 buffer3;
    Imlib_Color_Range     range;

    button_vis = DefaultVisual(disp, DefaultScreen(disp));
    button_depth = DefaultDepth(disp, DefaultScreen(disp));
    button_cm = DefaultColormap(disp, DefaultScreen(disp));
                // text
    char usermenufile[256],f_buffer[1024],ch2[1024];
    FILE * fp2=NULL;
    sprintf(usermenufile,"%s/.icon-DE/icon-de.rc",home);
    if (access(usermenufile,0)!=-1)
    {
        fp2=fopen(usermenufile,"r");
    }
    else if (access("/etc/icon-de/icon-de.rc",0)!=-1)
        fp2=fopen("/etc/icon-de/icon-de.rc","r");
    if (fp2==NULL)
    {
        printf("can't open icon-de.rc\n");
    }
    else
    {
        fgets(f_buffer,1024,fp2);
        for (i=0;i<1024;i++)
            if (f_buffer[i]=='\n') f_buffer[i]='\0';
        while ( ! feof(fp2) )
        {
            if (b_check_rc(f_buffer,"tag_color:")==0 )
            {
                b_get_str(ch2,f_buffer,"tag_color:");
                b_get_int2(bc_red,ch2,1);
                b_get_int2(bc_green,ch2,2);
                b_get_int2(bc_blue,ch2,3);
                b_get_int2(bc_alpha,ch2,4);
            }
            if (b_check_rc(f_buffer,"font_color:")==0 )
            {
                b_get_str(ch2,f_buffer,"font_color:");
                b_get_int2(bf_red,ch2,1);
                b_get_int2(bf_green,ch2,2);
                b_get_int2(bf_blue,ch2,3);
                b_get_int2(bf_alpha,ch2,4);
            }
            fgets(f_buffer,1024,fp2);
            for (i=0;i<1024;i++)
                if (f_buffer[i]=='\n') f_buffer[i]='\0';
        }
        fclose(fp2);
    }
    range = imlib_create_color_range();
    imlib_context_set_color_range(range);
    imlib_context_set_color(255, 255, 255, 255);
    imlib_add_color_to_color_range(0);
    /* add an orange color, semi-transparent 10 units from the first */
//    imlib_context_set_color(255, 200, 10, 255);
    imlib_context_set_color(bc_red, bc_green, bc_blue, bc_alpha);
    imlib_add_color_to_color_range(10);
    /* add black, fully transparent at the end 20 units away */
    imlib_context_set_color(70, 0, 0, 255);
    imlib_add_color_to_color_range(20);

    imlib_context_set_display(disp);
    imlib_context_set_visual(button_vis);
    imlib_context_set_colormap(button_cm);
    imlib_context_set_dither(1);
    imlib_context_set_blend(0);
    imlib_context_set_color_modifier(NULL);
    
    buffer3 = imlib_create_image(im.width1+200, im.height+10);    
    imlib_context_set_font(im.font);
    imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
    
    if (mode==0)
    {
        for (n=0;n<500;n++)
        {
            if (im.menu3[n].w_id!=0)
            {
                imlib_context_set_drawable(im.menu3[n].w_id); 
                     /* draw the range */
                buffer3 = imlib_create_image(im.width3+200, im.height+10);    
                imlib_context_set_image(buffer3);
                imlib_image_fill_color_range_rectangle(0,0, im.width3*4, im.height*2,-45.0);
                     /* free it */
                        //         imlib_free_color_range();
                imlib_render_image_on_drawable(0, 0); 
                imlib_context_set_font(im.font2);
                imlib_get_text_size("√", &text_w, &text_h);
                imlib_context_set_color(0, 0, 255, 255);
                if (im.menu3[n].selected==1)
                    imlib_text_draw(1,(im.height-text_h)/2,"√");
                imlib_render_image_on_drawable(0, 0); 
                imlib_context_set_font(im.font);
                imlib_get_text_size(im.menu3[n].text, &text_w, &text_h);
                imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
                if (text_w>=im.width3) 
                    imlib_text_draw(5,(im.height-text_h)/2,im.menu3[n].text);
                else
                    imlib_text_draw((im.width3-text_w)/2,(im.height-text_h)/2,im.menu3[n].text);
                /* set the buffer image as our current image */
                imlib_context_set_image(buffer3);
                imlib_render_image_on_drawable(0, 0); 
                imlib_context_set_image(buffer3);
                if (im.menu3[n].selected==1)
                    trans_button(disp,1,im.menu3[n].w_id);
                else
                    trans_button(disp,0.65,im.menu3[n].w_id);
            }
        }
    }
    else if (mode==1)
    {
        for (i=0;i<50;i++)
        {
            if (im.menu2[i].w_id!=0)
            {
                XDestroyWindow(disp,im.menu2[i].w_id);
                im.menu2[i].w_id=0;
            }
        }
        for (i=0;i<500;i++)
        {
            if (im.menu3[i].w_id!=0)
            {
                XDestroyWindow(disp,im.menu3[i].w_id);
                im.menu3[i].w_id=0;
            }
        }
        o=0;
        for (i=im.t_group;i<im.t_group+im.show_lines;i++)
        {
            if (im.menu2[i].hide!=1)
            {
                im.menu2[i].w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x,im.y+(im.h_gap+im.height)*(o+1),im.width2,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
                XSelectInput(disp, im.menu2[i].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
                imlib_get_text_size(im.menu2[i].text, &text_w, &text_h);
                XRaiseWindow(disp,im.menu2[i].w_id);
                XMapWindow(disp, im.menu2[i].w_id);
                imlib_context_set_drawable(im.menu2[i].w_id); 
                     /* draw the range */
                imlib_context_set_image(buffer3);
                imlib_free_image();
                buffer3 = imlib_create_image(im.width2+200, im.height+10);    
                imlib_context_set_image(buffer3);
                imlib_context_set_image(buffer3);
                imlib_free_image();
                buffer3 = imlib_create_image(im.width2+200, im.height+10);    
                imlib_context_set_image(buffer3);
                imlib_image_fill_color_range_rectangle(0,0, im.width2*4, im.height*2,-45.0);
                     /* free it */
                        //         imlib_free_color_range();
                imlib_context_set_image(buffer3);
                imlib_context_set_drawable(im.menu2[i].w_id); 
                imlib_render_image_on_drawable(0, 0); 
                imlib_context_set_font(im.font);
                imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
                if (text_w>=im.width2) 
                    imlib_text_draw(5,(im.height-text_h)/2,im.menu2[i].text);
                else
                    imlib_text_draw((im.width2-text_w)/2,(im.height-text_h)/2,im.menu2[i].text);
                /* set the buffer image as our current image */
                imlib_context_set_image(buffer3);
                imlib_render_image_on_drawable(0, 0); 
                imlib_context_set_image(buffer3);
                m=0;
                for (n=0;n<500;n++)
                {
                    if ((im.menu3[n].hide!=1) and (im.menu3[n].group==im.menu2[i].group))
                    {
                        im.menu3[n].w_id=XCreateWindow(disp,DefaultRootWindow(disp),im.x+im.width2+im.w_gap+(im.width3+im.w_gap)*(m),im.y+(im.h_gap+im.height)*(o+1),im.width3,im.height,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&button_attr);
                        XSelectInput(disp, im.menu3[n].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
                        XRaiseWindow(disp,im.menu3[n].w_id);
                        XMapWindow(disp, im.menu3[n].w_id);
                        imlib_context_set_drawable(im.menu3[n].w_id); 
                             /* draw the range */
                        imlib_context_set_image(buffer3);
                        imlib_free_image();
                        buffer3 = imlib_create_image(im.width3+200, im.height+10);    
                        imlib_context_set_image(buffer3);
                        imlib_image_fill_color_range_rectangle(0,0, im.width3*4, im.height*2,-45.0);
                             /* free it */
                                //         imlib_free_color_range();
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_font(im.font2);
                        imlib_get_text_size("√", &text_w, &text_h);
                        imlib_context_set_color(0, 0, 255, 255);
                        if (im.menu3[n].selected==1)
                            imlib_text_draw(1,(im.height-text_h)/2,"√");
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_font(im.font);
                        imlib_get_text_size(im.menu3[n].text, &text_w, &text_h);
                        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
                        if (text_w>=im.width3) 
                            imlib_text_draw(5,(im.height-text_h)/2,im.menu3[n].text);
                        else
                            imlib_text_draw((im.width3-text_w)/2,(im.height-text_h)/2,im.menu3[n].text);
                        /* set the buffer image as our current image */
                        imlib_context_set_image(buffer3);
                        imlib_render_image_on_drawable(0, 0); 
                        imlib_context_set_image(buffer3);
                        if (im.menu3[n].selected==1)
                            trans_button(disp,1,im.menu3[n].w_id);
                        else
                            trans_button(disp,0.65,im.menu3[n].w_id);
                        m=m+1;
                    }
                }
                o=o+1;
            }
        }
    }
    else if (mode==2)
    {
        hide_button(disp,im);
        creat_button(disp,im);
    }

}

int click_button(Display *disp,Window w_id,imenu &im)
{
    int i,n,i_return;

    i_return=-2;
    for (i=0;i<500;i++)
    {
        if (im.menu3[i].w_id==w_id)
        {
            if ((im.m_group_begin<0) or (im.menu3[i].group<im.m_group_begin) or (im.menu3[i].group>im.m_group_end))
            {
                for (n=0;n<500;n++)
                {
                    if (im.menu3[n].group==im.menu3[i].group)
                        im.menu3[n].selected=0;
                }
            }
            else
            {
                for (n=0;n<500;n++)
                {
                    if ((im.menu3[n].group>=im.m_group_begin) and (im.menu3[n].group<=im.m_group_end))
                        im.menu3[n].selected=0;
                }
            }
            im.menu3[i].selected=1;
            i_return=3;
            break;
        }
    }
    
    if (im.b_up.w_id==w_id)
    {
        if (im.t_group<=im.show_lines)
            im.t_group=0;
        else
            im.t_group=im.t_group-im.show_lines;
        i_return=4;
    }
    else if (im.b_down.w_id==w_id)
    {
        if (im.t_group+im.show_lines>=50)
            im.t_group=50-im.show_lines;
        else
            im.t_group=im.t_group+im.show_lines;
        i_return=4;
    }
    else if (im.menu4[0].w_id==w_id)
    {
        hide_button(disp,im);
        i_return=0;
    }
    else if (im.menu4[1].w_id==w_id)
    {
        destory_button(disp,im);
        i_return=1;
    }
    else if (im.menu4[2].w_id==w_id)
    {
        destory_button(disp,im);
        i_return=2;
    }
    if (i_return==3)
        filter_button(disp,im,0);
    if (i_return==4)
        filter_button(disp,im,1);
    return i_return;

}

int input_text(Display *disp,XEvent &event,imenu &im)
{
    char home[1024];
    sprintf(home,"%s",getenv("HOME"));
    Imlib_Image                 buffer3;
    int buf_len=0,i,text_w,text_h;
    char *buffer = (char *)malloc(buf_len * sizeof(char));
    unsigned char * old_sel = NULL;
    char st[1024];
    Atom selection = XA_PRIMARY;
//    Bool do_append = False;
    int len,n,m,x,y;
    KeySym keysym;
    Status status;
    Bool redraw = False;
//    char font_path[1024];
    int text_cw, text_ch;
    char s_l[1024],s_r[1024];
    if (im.input.have_xim==1)
    {
        len = XmbLookupString(im.ic, (XKeyPressedEvent*)&event, buffer, buf_len,
                              &keysym, &status);
        if (status == XBufferOverflow) {
            buf_len = len;
            buffer = (char *)realloc((char *)buffer,
                                        buf_len * sizeof(char));
                len = XmbLookupString(im.ic, (XKeyPressedEvent*)&event, buffer, buf_len,
                                            &keysym, &status);
        }
        redraw = False;
        switch (status) {
        case XLookupNone:
    //        printf("XLookupNone\n");
            break;
        case XLookupKeySym:
        case XLookupBoth:
    //        printf("XLookupBoth\n");
            /* Handle backspacing, and <Return> to exit */
            if (keysym == XK_Delete) {
                if (im.input.cur<=im.input.str_len)
                {
                    if ((unsigned char)im.input.tag_text[im.input.cur] < 0x80)
                    {
                        if (im.input.str_len > 0)
                        {
                            for (i=im.input.cur;i<im.input.str_len;i++)
                                im.input.tag_text[i]=im.input.tag_text[i+1];
                            im.input.str_len--;
                            redraw = True;
                        }
                    }
                    else
                    {
                        m=0;
                        if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur] >= 0xC0))
                        {
                            redraw = True;
                            for (n=im.input.cur+1;n<im.input.str_len;n++)
                            {
                                m++;
                                if (((unsigned char)im.input.tag_text[n] >= 0xC0) or ((unsigned char)im.input.tag_text[n] < 0x80) )
                                    break;
                                else if (((unsigned char)im.input.tag_text[n] >= 0x80) and ((unsigned char)im.input.tag_text[n] < 0xC0))
                                    continue;
                            }
                            im.input.str_len=im.input.str_len-m;
                        }
                        for (i=im.input.cur;i<im.input.str_len;i++)
                            im.input.tag_text[i]=im.input.tag_text[i+m];
                    }
                    im.input.tag_text[im.input.str_len]='\0';
                    redraw = True;
                }
                break;
            }
            if (keysym == XK_BackSpace) {
                if (im.input.cur > 0)
                {
                    if (im.input.cur>im.input.str_len) im.input.cur=im.input.str_len;
                    if ((unsigned char)im.input.tag_text[im.input.cur-1] < 0x80)
                    {
                        if (im.input.cur > 0)
                        {
                            for (i=im.input.cur;i<im.input.str_len;i++)
                                im.input.tag_text[i-1]=im.input.tag_text[i];
                            im.input.str_len--;
                            im.input.cur--;
                            redraw = True;
                        }
                    }
                    else
                    {
                        m=0;
                        if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        {
                            im.input.str_len--;
                            im.input.cur--;
                            m++;
                        }
                        if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        {
                            im.input.str_len--;
                            im.input.cur--;
                            m++;
                        }
                        if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        {
                            im.input.str_len--;
                            im.input.cur--;
                            m++;
                        }
                        if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        {
                            im.input.str_len--;
                            im.input.cur--;
                            m++;
                        }
                        if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        {
                            im.input.str_len--;
                            im.input.cur--;
                            m++;
                        }
                        if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0xC0))
                        {
                            im.input.str_len--;
                            im.input.cur--;
                            m++;
                        }
                        redraw = True;
                        for (i=im.input.cur;i<im.input.str_len;i++)
                            im.input.tag_text[i]=im.input.tag_text[i+m];
                    }
                    im.input.tag_text[im.input.str_len]='\0';
                }
                break;
            }
            if (keysym == XK_Escape)
            {
                im.input.tag_text[0]='\0';
                im.input.str_len=0;
                redraw=True;
                break;
            }
            if (keysym == XK_Left)
            {
                if (im.input.cur<=0)
                    im.input.cur=0;
                else
                {
                    if (im.input.tag_text[im.input.cur-1] == '\0')
                        im.input.cur=im.input.cur-1;
                    else if ((unsigned char)im.input.tag_text[im.input.cur-1] < 0x80)
                        im.input.cur=im.input.cur-1;
                    else
                    {
                        if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                            im.input.cur--;
                        if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                            im.input.cur--;
                        if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                            im.input.cur--;
                        if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                            im.input.cur--;
                        if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                            im.input.cur--;
                        if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0xC0))
                            im.input.cur--;
                    }
                }
                redraw=True;
                printf("XK_Left %d\n",im.input.cur);
                break;
            }
            if (keysym == XK_Right)
            {
                if (im.input.cur>=im.input.str_len)
                    im.input.cur=im.input.str_len+1;
                else
                {
                    for (i=im.input.cur;i<=im.input.str_len;i++)
                    {
                        if ((unsigned char)im.input.tag_text[i] < 0x80)
                        {
                            im.input.cur=im.input.cur+1;
                            break;
                        }
                        else if ((unsigned char)im.input.tag_text[i] >= 0xC0)
                        {
                            im.input.cur=im.input.cur+1;
                            continue;
                        }
                        else
                        {
                            for (n=im.input.cur;n<=im.input.str_len;n++)
                            {
                                if (((unsigned char)im.input.tag_text[n] >= 0x80) and ((unsigned char)im.input.tag_text[n] < 0xC0))
                                    im.input.cur=im.input.cur+1;
                                if (((unsigned char)im.input.tag_text[n] >= 0xC0) or ((unsigned char)im.input.tag_text[n] < 0x80))
                                {
                                    break;
                                }
                            }
                            break;
                        }
                    }
                }
                redraw=True;
                printf("XK_Right %d\n",im.input.cur);
                break;
            }
            if (keysym == XK_End)
            {
                printf("XK_End\n");
                im.input.cur=im.input.str_len+1;
                redraw=True;
                break;
            }
            if (keysym == XK_Home)
            {
                printf("XK_Home\n");
                im.input.cur=0;
                redraw=True;
                break;
            }
            if (keysym == XK_Insert)
            {
                printf("XK_Insert\n");
                if (im.input.insert==0)
                    im.input.insert=1;
                else
                    im.input.insert=0;
                redraw=True;
                break;
            }
    //                if (keysym == XK_Return) return 0;
            if (status == XLookupKeySym) break;
        case XLookupChars:
    //        printf("XLookupChars\n");
            printf("buffer:%s //len:%d\n",buffer,len);
            m=0;
            for(i=0; i < len; i++)
            {
                if ((unsigned char)buffer[i]==0x16) //ctrl-v
                {
    //                printf("ctrl-v\n");
                    old_sel = get_selection_text (disp,selection);
                    m=1;
                    if (old_sel)
                        sprintf (im.input.tag_text,"%s", old_sel);
                    for (n=0;n<1024;n++)
                    {
                        if (im.input.tag_text[n]=='\0') break;
                        if ((im.input.tag_text[n]=='\n') or (im.input.tag_text[n]=='\r'))
                        {
                            im.input.tag_text[n]='\0';
                            break;
                        }
                    }
                    im.input.str_len=n;
                    im.input.cur=n;
                    redraw = True;
                    break;
                }
            }
            if (m==1) break;

            for(i=0; i < len; i++)
            {
                st[i]=buffer[i];
            } 
            st[i]='\0';

            if (im.input.cur>=im.input.str_len)
            {
                sprintf(s_l,"%s",im.input.tag_text);
                s_r[0]='\0';
            }
            else
            {
                for (i=0;i<im.input.str_len;i++)
                {
                    s_l[i]=im.input.tag_text[i];
                    n=i;
                    if (n>=im.input.cur)
                        break;
                }
                s_l[n]='\0';
                if (im.input.insert==1)
                {
                    m=0;
                    for (i=n;i<=im.input.str_len;i++)
                    {
                        s_r[m]=im.input.tag_text[i];
                        m=m+1;
                    }
                    s_r[m]='\0';
                }
                else
                {
                    x=0;
                    for (m=0;m<len;m++)
                    {
                        if (((unsigned char)st[m] < 0x80) or ((unsigned char)st[m] >= 0xC0))
                            x=x+1;
                    }
                    y=0;
                    m=0;
                    for (i=im.input.cur;i<im.input.str_len;i++)
                    {
                        if (((unsigned char)im.input.tag_text[i] < 0x80) or ((unsigned char)im.input.tag_text[i] >= 0xC0))
                        {
                            x=x-1;
                            y=y+1;
                        }
                        if ((x>=0) and ((unsigned char)im.input.tag_text[i] >= 0xC0))
                        {
                            for (m=i+1;m<im.input.str_len;m++) 
                            {
                                if (((unsigned char)im.input.tag_text[m] >= 0x80) and ((unsigned char)im.input.tag_text[m] < 0xC0))
                                    y=y+1;
                                else
                                    break;
                            }
                        }
                        if (x<=0)
                            break;
                    }
                    x=0;
                    for (n=im.input.cur+y;n<im.input.str_len;n++)
                    {
                        s_r[x]=im.input.tag_text[n];
                        x=x+1;
                    }
                    s_r[x]='\0';
                }
            }
    //        printf("%s %s %s\n",s_l,st,s_r);
            sprintf(im.input.tag_text,"%s%s%s",s_l,st,s_r);
            if ((im.input.cur>=im.input.str_len) or (im.input.insert==1))
                im.input.str_len=im.input.str_len+len;
            else
                im.input.str_len=im.input.str_len+len-y;
            im.input.cur=im.input.cur+len;
            im.input.tag_text[im.input.str_len]='\0'; 
            redraw = True;
            break;
        }
    }
    else
    {
        len = XLookupString((XKeyPressedEvent*)&event, buffer, buf_len,
                              &keysym, 0);
        redraw = False;
        if (keysym == XK_Delete) {
            if (im.input.cur<=im.input.str_len)
            {
                if ((unsigned char)im.input.tag_text[im.input.cur] < 0x80)
                {
                    if (im.input.str_len > 0)
                    {
                        for (i=im.input.cur;i<im.input.str_len;i++)
                            im.input.tag_text[i]=im.input.tag_text[i+1];
                        im.input.str_len--;
                        redraw = True;
                    }
                }
                else
                {
                    m=0;
                    if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur] >= 0xC0))
                    {
                        redraw = True;
                        for (n=im.input.cur+1;n<im.input.str_len;n++)
                        {
                            m++;
                            if (((unsigned char)im.input.tag_text[n] >= 0xC0) or ((unsigned char)im.input.tag_text[n] < 0x80) )
                                break;
                            else if (((unsigned char)im.input.tag_text[n] >= 0x80) and ((unsigned char)im.input.tag_text[n] < 0xC0))
                                continue;
                        }
                        im.input.str_len=im.input.str_len-m;
                    }
                    for (i=im.input.cur;i<im.input.str_len;i++)
                        im.input.tag_text[i]=im.input.tag_text[i+m];
                }
                im.input.tag_text[im.input.str_len]='\0';
                redraw = True;
            }
        }
        else if (keysym == XK_BackSpace) {
            if (im.input.cur > 0)
            {
                if (im.input.cur>im.input.str_len) im.input.cur=im.input.str_len;
                if ((unsigned char)im.input.tag_text[im.input.cur-1] < 0x80)
                {
                    if (im.input.cur > 0)
                    {
                        for (i=im.input.cur;i<im.input.str_len;i++)
                            im.input.tag_text[i-1]=im.input.tag_text[i];
                        im.input.str_len--;
                        im.input.cur--;
                        redraw = True;
                    }
                }
                else
                {
                    m=0;
                    if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                    {
                        im.input.str_len--;
                        im.input.cur--;
                        m++;
                    }
                    if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                    {
                        im.input.str_len--;
                        im.input.cur--;
                        m++;
                    }
                    if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                    {
                        im.input.str_len--;
                        im.input.cur--;
                        m++;
                    }
                    if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                    {
                        im.input.str_len--;
                        im.input.cur--;
                        m++;
                    }
                    if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                    {
                        im.input.str_len--;
                        im.input.cur--;
                        m++;
                    }
                    if ((im.input.str_len > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0xC0))
                    {
                        im.input.str_len--;
                        im.input.cur--;
                        m++;
                    }
                    redraw = True;
                    for (i=im.input.cur;i<im.input.str_len;i++)
                        im.input.tag_text[i]=im.input.tag_text[i+m];
                }
                im.input.tag_text[im.input.str_len]='\0';
            }
        }
        else if (keysym == XK_Escape)
        {
            im.input.tag_text[0]='\0';
            im.input.str_len=0;
            redraw=True;
        }
        else if (keysym == XK_Left)
        {
            if (im.input.cur<=0)
                im.input.cur=0;
            else
            {
                if (im.input.tag_text[im.input.cur-1] == '\0')
                    im.input.cur=im.input.cur-1;
                else if ((unsigned char)im.input.tag_text[im.input.cur-1] < 0x80)
                    im.input.cur=im.input.cur-1;
                else
                {
                    if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        im.input.cur--;
                    if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        im.input.cur--;
                    if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        im.input.cur--;
                    if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        im.input.cur--;
                    if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0x80) and ((unsigned char)im.input.tag_text[im.input.cur-1] < 0xC0))
                        im.input.cur--;
                    if ((im.input.cur > 0) and ((unsigned char)im.input.tag_text[im.input.cur-1] >= 0xC0))
                        im.input.cur--;
                }
            }
            redraw=True;
            printf("XK_Left %d\n",im.input.cur);
        }
        else if (keysym == XK_Right)
        {
            if (im.input.cur>=im.input.str_len)
                im.input.cur=im.input.str_len+1;
            else
            {
                for (i=im.input.cur;i<=im.input.str_len;i++)
                {
                    if ((unsigned char)im.input.tag_text[i] < 0x80)
                    {
                        im.input.cur=im.input.cur+1;
                        break;
                    }
                    else if ((unsigned char)im.input.tag_text[i] >= 0xC0)
                    {
                        im.input.cur=im.input.cur+1;
                        continue;
                    }
                    else
                    {
                        for (n=im.input.cur;n<=im.input.str_len;n++)
                        {
                            if (((unsigned char)im.input.tag_text[n] >= 0x80) and ((unsigned char)im.input.tag_text[n] < 0xC0))
                                im.input.cur=im.input.cur+1;
                            if (((unsigned char)im.input.tag_text[n] >= 0xC0) or ((unsigned char)im.input.tag_text[n] < 0x80))
                            {
                                break;
                            }
                        }
                        break;
                    }
                }
            }
            redraw=True;
            printf("XK_Right %d\n",im.input.cur);
        }
        else if (keysym == XK_End)
        {
            printf("XK_End\n");
            im.input.cur=im.input.str_len+1;
            redraw=True;
        }
        else if (keysym == XK_Home)
        {
            printf("XK_Home\n");
            im.input.cur=0;
            redraw=True;
        }
        else if (keysym == XK_Insert)
        {
            printf("XK_Insert\n");
            if (im.input.insert==0)
                im.input.insert=1;
            else
                im.input.insert=0;
            redraw=True;
        }
//      else if (keysym == XK_Return) return 0;
        else
        {
//            printf("buffer:%s\n",buffer);
            m=0;
            if ((unsigned char)buffer[0]==0x16) //ctrl-v
            {
//                printf("ctrl-v\n");
                old_sel = get_selection_text (disp,selection);
                m=1;
                if (old_sel)
                    sprintf (im.input.tag_text,"%s", old_sel);
                for (n=0;n<1024;n++)
                {
                    if (im.input.tag_text[n]=='\0') break;
                    if ((im.input.tag_text[n]=='\n') or (im.input.tag_text[n]=='\r'))
                    {
                        im.input.tag_text[n]='\0';
                        break;
                    }
                }
                im.input.str_len=n;
                im.input.cur=n;
                redraw = True;
            }
            else
            {
                sprintf(buffer,"%s",XKeysymToString(keysym));
                printf("%s\n",buffer);
                if (buffer[1]!='\0')
                {
                    if (strcmp(buffer,"space")==0) sprintf(buffer," ");
                    else if (strcmp(buffer,"exclam")==0) sprintf(buffer,"!");
                    else if (strcmp(buffer,"quotedbl")==0) sprintf(buffer,"\"");
                    else if (strcmp(buffer,"numbersign")==0) sprintf(buffer,"#");
                    else if (strcmp(buffer,"dollar")==0) sprintf(buffer,"$");
                    else if (strcmp(buffer,"percent")==0) sprintf(buffer,"%%");
                    else if (strcmp(buffer,"ampersand")==0) sprintf(buffer,"&");
                    else if (strcmp(buffer,"apostrophe")==0) sprintf(buffer,"\'");
                    else if (strcmp(buffer,"parenleft")==0) sprintf(buffer,"(");
                    else if (strcmp(buffer,"parenright")==0) sprintf(buffer,")");
                    else if (strcmp(buffer,"asterisk")==0) sprintf(buffer,"*");
                    else if (strcmp(buffer,"plus")==0) sprintf(buffer,"+");
                    else if (strcmp(buffer,"comma")==0) sprintf(buffer,",");
                    else if (strcmp(buffer,"minus")==0) sprintf(buffer,"-");
                    else if (strcmp(buffer,"period")==0) sprintf(buffer,".");
                    else if (strcmp(buffer,"slash")==0) sprintf(buffer,"/");
                    else if (strcmp(buffer,"colon")==0) sprintf(buffer,":");
                    else if (strcmp(buffer,"semicolon")==0) sprintf(buffer,";");
                    else if (strcmp(buffer,"less")==0) sprintf(buffer,"<");
                    else if (strcmp(buffer,"equal")==0) sprintf(buffer,"=");
                    else if (strcmp(buffer,"greater")==0) sprintf(buffer,">");
                    else if (strcmp(buffer,"question")==0) sprintf(buffer,"?");
                    else if (strcmp(buffer,"at")==0) sprintf(buffer,"@");
                    else if (strcmp(buffer,"bracketleft")==0) sprintf(buffer,"[");
                    else if (strcmp(buffer,"backslash")==0) sprintf(buffer,"\\");
                    else if (strcmp(buffer,"bracketright")==0) sprintf(buffer,"]");
                    else if (strcmp(buffer,"asciicircum")==0) sprintf(buffer,"^");
                    else if (strcmp(buffer,"underscore")==0) sprintf(buffer,"_");
                    else if (strcmp(buffer,"grave")==0) sprintf(buffer,"`");
                    else if (strcmp(buffer,"braceleft")==0) sprintf(buffer,"{");
                    else if (strcmp(buffer,"bar")==0) sprintf(buffer,"|");
                    else if (strcmp(buffer,"braceright")==0) sprintf(buffer,"}");
                    else if (strcmp(buffer,"asciitilde")==0) sprintf(buffer,"~");   
                    else if (strcmp(buffer,"KP_Divide")==0) sprintf(buffer,"/");
                    else if (strcmp(buffer,"KP_Multiply")==0) sprintf(buffer,"*");
                    else if (strcmp(buffer,"KP_Subtract")==0) sprintf(buffer,"-");
                    else if (strcmp(buffer,"KP_Add")==0) sprintf(buffer,"+");
                    else if (strcmp(buffer,"KP_9")==0) sprintf(buffer,"9");
                    else if (strcmp(buffer,"KP_8")==0) sprintf(buffer,"8");
                    else if (strcmp(buffer,"KP_7")==0) sprintf(buffer,"7");
                    else if (strcmp(buffer,"KP_4")==0) sprintf(buffer,"4");
                    else if (strcmp(buffer,"KP_5")==0) sprintf(buffer,"5");
                    else if (strcmp(buffer,"KP_6")==0) sprintf(buffer,"6");
                    else if (strcmp(buffer,"KP_3")==0) sprintf(buffer,"3");
                    else if (strcmp(buffer,"KP_2")==0) sprintf(buffer,"2");
                    else if (strcmp(buffer,"KP_1")==0) sprintf(buffer,"1");
                    else if (strcmp(buffer,"KP_0")==0) sprintf(buffer,"0");
                    else if (strcmp(buffer,"KP_Decimal")==0) sprintf(buffer,".");
                    else
                    {
                        if (buffer[1]!='\0')
                        {
                            buffer[0]='\0';
                        }
                    }
                }
                
                if (im.input.cur>=im.input.str_len)
                {
                    sprintf(s_l,"%s",im.input.tag_text);
                    s_r[0]='\0';
                }
                else
                {
                    for (i=0;i<im.input.str_len;i++)
                    {
                        s_l[i]=im.input.tag_text[i];
                        n=i;
                        if (n>=im.input.cur)
                            break;
                    }
                    s_l[n]='\0';
                    if (im.input.insert==1)
                    {
                        m=0;
                        for (i=n;i<=im.input.str_len;i++)
                        {
                            s_r[m]=im.input.tag_text[i];
                            m=m+1;
                        }
                        s_r[m]='\0';
                    }
                    else
                    {
                        x=0;
                        for (m=0;m<len;m++)
                        {
                            if (((unsigned char)st[m] < 0x80) or ((unsigned char)st[m] >= 0xC0))
                                x=x+1;
                        }
                        y=0;
                        m=0;
                        for (i=im.input.cur;i<im.input.str_len;i++)
                        {
                            if (((unsigned char)im.input.tag_text[i] < 0x80) or ((unsigned char)im.input.tag_text[i] >= 0xC0))
                            {
                                x=x-1;
                                y=y+1;
                            }
                            if ((x>=0) and ((unsigned char)im.input.tag_text[i] >= 0xC0))
                            {
                                for (m=i+1;m<im.input.str_len;m++) 
                                {
                                    if (((unsigned char)im.input.tag_text[m] >= 0x80) and ((unsigned char)im.input.tag_text[m] < 0xC0))
                                        y=y+1;
                                    else
                                        break;
                                }
                            }
                            if (x<=0)
                                break;
                        }
                        x=0;
                        for (n=im.input.cur+y;n<im.input.str_len;n++)
                        {
                            s_r[x]=im.input.tag_text[n];
                            x=x+1;
                        }
                        s_r[x]='\0';
                    }
                }
    //        printf("%s %s %s\n",s_l,st,s_r);
                sprintf(im.input.tag_text,"%s%s%s",s_l,buffer,s_r);
                if ((im.input.cur>=im.input.str_len) or (im.input.insert==1))
                    im.input.str_len=im.input.str_len+len;
                else
                    im.input.str_len=im.input.str_len+len-y;
                im.input.cur=im.input.cur+len;
                im.input.tag_text[im.input.str_len]='\0'; 
                redraw = True;
            }
        }
    }
    /* do a very simple-minded redraw, if needed */

    if (redraw) {
//        printf("redraw\n");
        imlib_context_set_font(im.font);
        imlib_get_text_size(im.input.tag_text, &text_w, &text_h);
        imlib_context_set_drawable(im.input.w_ip); 
             /* draw the range */
        buffer3 = imlib_create_image(im.width_text+200, im.height+10);    
        imlib_context_set_image(buffer3);
        imlib_image_fill_color_range_rectangle(0,0,im.width_text+200, im.height+45,-45.0);
             /* free it */
                //         imlib_free_color_range();
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_font(im.font2);
        imlib_context_set_color(255, 0, 0, 255);
        if (im.input.cur>=im.input.str_len)
        {
            if (text_w<im.width_text-20)
                x=0;
            else
                x=im.width_text-text_w-20;
            if (im.input.insert==0)
            {
                imlib_get_text_size("△", &text_cw, &text_ch);
                imlib_text_draw(x+text_w+5-text_cw/2,im.height-(im.height-text_h)/2-5,"△");
            }
            else
            {
                imlib_get_text_size("▲", &text_cw, &text_ch);
                imlib_text_draw(x+text_w+5-text_cw/2,im.height-(im.height-text_h)/2-5,"▲");
            }
            sprintf(s_l,"%s",im.input.tag_text);
            s_r[0]='\0';
        }
        else
        {
            for (i=0;i<im.input.str_len;i++)
            {
                s_l[i]=im.input.tag_text[i];
                n=i;
                if (n>=im.input.cur)
                    break;
            }
            s_l[n]='\0';
            imlib_context_set_font(im.font);
            imlib_get_text_size(s_l, &text_w, &text_h);
            if (text_w<im.width_text-20)
                x=0;
            else
                x=im.width_text-text_w-20;
            imlib_context_set_font(im.font2);
            imlib_context_set_color(255, 0, 0, 255);
            if (im.input.insert==0)
            {
                imlib_get_text_size("△", &text_cw, &text_ch);
                imlib_text_draw(x+text_w+5-text_cw/2,im.height-(im.height-text_h)/2-5,"△");
            }
            else
            {
                imlib_get_text_size("▲", &text_cw, &text_ch);
                imlib_text_draw(x+text_w+5-text_cw/2,im.height-(im.height-text_h)/2-5,"▲");
            }
            int m=0;
            for (i=n;i<=im.input.str_len;i++)
            {
                s_r[m]=im.input.tag_text[i];
                m=m+1;
            }
            s_r[m]='\0';
        }
//        printf("%s▲%s\n",s_l,s_r);
        imlib_context_set_font(im.font);
        imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
        if (im.input.is_passwd==0)
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, bf_alpha);
            imlib_text_draw(x+5,(im.height-text_h)/2,im.input.tag_text);
        }
        else
        {
            imlib_context_set_color(bf_red, bf_green, bf_blue, 10);
            imlib_text_draw(x+5,(im.height-text_h)/2,im.input.tag_text);
        }
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer3);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer3);
//        printf("%d,%s\n",im.input.str_len,im.input.tag_text);
        imlib_context_set_image(buffer3);
        imlib_free_image();
    }
    return 0;
}

