
typedef struct _icon_ {
        int    id;
        Window        w_id;
        int           x;
        int           y;
        int           s_g;
        char    image[1024];
        char    tag[1024];
        char    apps[1024];
        char    title[1024];
        char    group[32];
        int           l_id;
        Imlib_Image                 buffer;
        Imlib_Image                 im_bg;
        Imlib_Image                 back;
        Imlib_Image                 bigback;
} icon;

Imlib_Image                     back;

/* nothing fancy */
int trans(double d, Window target_win)
{
    #define OPAQUE	0xffffffff
    #define OPACITY	"_NET_WM_WINDOW_OPACITY"
    unsigned int opacity;

    opacity = (unsigned int) (d * OPAQUE);
    XChangeProperty(disp, target_win, XInternAtom(disp, OPACITY, False), 
		        XA_CARDINAL, 32, PropModeReplace, 
		        (unsigned char *) &opacity, 1L);
    XSync(disp, False);
    return 0;
}

char full_path_icon[4096]="N/A";
#include "./rc_str.c"
char * find_icon_file(char * icon_name)
{
    FILE *fp=NULL;
    FILE *fp2=NULL;
    char buffer[4096];
    char icon_path[7][1024];
    char icon_find1[5][64];
    char icon_find2[10][64];
    int i,m,n;
    char icon_file[4096]="N/A";
    int have_find_icon=0;
    char s_dir[256]="";
    char icon_gtk3[1024]="N/A";
    char icon_gtk2[1024]="N/A";
    char home[1024];
    sprintf(home,"%s",getenv("HOME"));
    if ( strcmp(home,"") == 0 )
    {
        printf("fatal error: no /home/xxx found!\n");
        sprintf(full_path_icon,"N/A");
        return full_path_icon;
    }

    if (access(icon_name,0)!=-1)
        fp=fopen(icon_name,"r");
    if(fp!=NULL) 
    {
        fclose(fp);
        return icon_name;
    }    
    if (access("/etc/gtk-3.0/settings.ini",0)!=-1)
    {
        fp=fopen("/etc/gtk-3.0/settings.ini","r");
        if(fp==NULL) 
        {
            printf("can't open /etc/gtk-3.0/settings.ini\n");
        }
        else
        {
            fgets(buffer,4096,fp);
            for (i=0;i<4096;i++)
                if (buffer[i]=='\n') buffer[i]='\0';
            while ( ! feof(fp) )
            {
                if (check_rc(buffer,"gtk-icon-theme-name")==0 )
                {
                    ReplaceStr(buffer,"gtk-icon-theme-name = ","");
                    ReplaceStr(buffer,"gtk-icon-theme-name= ","");
                    ReplaceStr(buffer,"gtk-icon-theme-name =","");
                    ReplaceStr(buffer,"gtk-icon-theme-name=","");
                    ReplaceStr(buffer,"gtk-icon-theme-name","");
//                    printf("gtk3-icon-theme-name: %s\n",buffer);
                    sprintf(icon_gtk3,"/usr/share/%s/",buffer);
                }
                fgets(buffer,4096,fp);
                for (i=0;i<4096;i++)
                    if (buffer[i]=='\n') buffer[i]='\0';
            }
        }
        fclose(fp);
    }
    if (access("/etc/gtk-2.0/settings.ini",0)!=-1)
    {
        fp=fopen("/etc/gtk-2.0/settings.ini","r");
        if(fp==NULL) 
        {
            printf("can't open /etc/gtk-2.0/settings.ini\n");
        }
        else
        {
            fgets(buffer,4096,fp);
            for (i=0;i<4096;i++)
                if (buffer[i]=='\n') buffer[i]='\0';
            while ( ! feof(fp) )
            {
                if (check_rc(buffer,"gtk-icon-theme-name")==0 )
                {
                    ReplaceStr(buffer,"gtk-icon-theme-name = ","");
                    ReplaceStr(buffer,"gtk-icon-theme-name= ","");
                    ReplaceStr(buffer,"gtk-icon-theme-name =","");
                    ReplaceStr(buffer,"gtk-icon-theme-name=","");
                    ReplaceStr(buffer,"gtk-icon-theme-name","");
//                    printf("gtk2-icon-theme-name: %s\n",buffer);
                    sprintf(icon_gtk2,"/usr/share/%s/",buffer);
                }
                fgets(buffer,4096,fp);
                for (i=0;i<4096;i++)
                    if (buffer[i]=='\n') buffer[i]='\0';
            }
        }
        fclose(fp);
    }
    sprintf(icon_file,"%s/.icon-DE/icon-de.rc",home);
    if (access(icon_file,0)!=-1)
    {
        fp=fopen(icon_file,"r");
    }
    else if (access("usr/share/icon-DE/icon-de.rc",0)!=-1)
        fp=fopen("usr/share/icon-DE/icon-de.rc","r");
    if (fp==NULL)
    {
        printf("can't open ~/.icon-DE/icon-de.rc\n");
        sprintf(full_path_icon,"N/A");
        return full_path_icon;
    }
    fgets(buffer,4096,fp);
    for (i=0;i<4096;i++)
        if (buffer[i]=='\n') buffer[i]='\0';
    while ( ! feof(fp) )
    {
//        printf("%s\n",buffer);
        if (check_rc(buffer,"icon_path1:")==0 )
        {
            ReplaceStr(buffer,"icon_path1:","");
            if (strcmp(buffer,"GTK3_DEFAULT")==0 )
                sprintf(icon_path[0],"%s",icon_gtk3);
            else if (strcmp(buffer,"GTK2_DEFAULT")==0 )
                sprintf(icon_path[0],"%s",icon_gtk2);
            else    
                sprintf(icon_path[0],"%s",buffer);
        }

        if (check_rc(buffer,"icon_path2:")==0 )
        {
            ReplaceStr(buffer,"icon_path2:","");
            if (strcmp(buffer,"GTK3_DEFAULT")==0 )
                sprintf(icon_path[1],"%s",icon_gtk3);
            else if (strcmp(buffer,"GTK2_DEFAULT")==0 )
                sprintf(icon_path[1],"%s",icon_gtk2);
            else    
                sprintf(icon_path[1],"%s",buffer);
        }

        if (check_rc(buffer,"icon_path3:")==0 )
        {
            ReplaceStr(buffer,"icon_path3:","");
            if (strcmp(buffer,"GTK3_DEFAULT")==0 )
                sprintf(icon_path[2],"%s",icon_gtk3);
            else if (strcmp(buffer,"GTK2_DEFAULT")==0 )
                sprintf(icon_path[2],"%s",icon_gtk2);
            else    
                sprintf(icon_path[2],"%s",buffer);
        }

        if (check_rc(buffer,"icon_path4:")==0 )
        {
            ReplaceStr(buffer,"icon_path4:","");
            if (strcmp(buffer,"GTK3_DEFAULT")==0 )
                sprintf(icon_path[3],"%s",icon_gtk3);
            else if (strcmp(buffer,"GTK2_DEFAULT")==0 )
                sprintf(icon_path[3],"%s",icon_gtk2);
            else    
                sprintf(icon_path[3],"%s",buffer);
        }

        if (check_rc(buffer,"icon_path5:")==0 )
        {
            ReplaceStr(buffer,"icon_path5:","");
            if (strcmp(buffer,"GTK3_DEFAULT")==0 )
                sprintf(icon_path[4],"%s",icon_gtk3);
            else if (strcmp(buffer,"GTK2_DEFAULT")==0 )
                sprintf(icon_path[4],"%s",icon_gtk2);
            else    
                sprintf(icon_path[4],"%s",buffer);
        }

        if (check_rc(buffer,"icon_path6:")==0 )
        {
            ReplaceStr(buffer,"icon_path6:","");
            if (strcmp(buffer,"GTK3_DEFAULT")==0 )
                sprintf(icon_path[5],"%s",icon_gtk3);
            else if (strcmp(buffer,"GTK2_DEFAULT")==0 )
                sprintf(icon_path[5],"%s",icon_gtk2);
            else    
                sprintf(icon_path[5],"%s",buffer);
        }

        if (check_rc(buffer,"icon_path7:")==0 )
        {
            ReplaceStr(buffer,"icon_path7:","");
            if (strcmp(buffer,"GTK3_DEFAULT")==0 )
                sprintf(icon_path[6],"%s",icon_gtk3);
            else if (strcmp(buffer,"GTK2_DEFAULT")==0 )
                sprintf(icon_path[6],"%s",icon_gtk2);
            else    
                sprintf(icon_path[6],"%s",buffer);
        }

        if (check_rc(buffer,"icon_size1:")==0 )
            get_str(icon_find1[0],buffer,"icon_size1:");

        if (check_rc(buffer,"icon_size2:")==0 )
            get_str(icon_find1[1],buffer,"icon_size2:");

        if (check_rc(buffer,"icon_size3:")==0 )
            get_str(icon_find1[2],buffer,"icon_size3:");

        if (check_rc(buffer,"icon_size4:")==0 )
            get_str(icon_find1[3],buffer,"icon_size4:");

        if (check_rc(buffer,"icon_size5:")==0 )
            get_str(icon_find1[4],buffer,"icon_size5:");

        if (check_rc(buffer,"icon_kind1:")==0 )
            get_str(icon_find2[0],buffer,"icon_kind1:");

        if (check_rc(buffer,"icon_kind2:")==0 )
            get_str(icon_find2[1],buffer,"icon_kind2:");

        if (check_rc(buffer,"icon_kind3:")==0 )
            get_str(icon_find2[2],buffer,"icon_kind3:");

        if (check_rc(buffer,"icon_kind4:")==0 )
            get_str(icon_find2[3],buffer,"icon_kind4:");

        if (check_rc(buffer,"icon_kind5:")==0 )
            get_str(icon_find2[4],buffer,"icon_kind5:");

        if (check_rc(buffer,"icon_kind6:")==0 )
            get_str(icon_find2[5],buffer,"icon_kind6:");

        if (check_rc(buffer,"icon_kind7:")==0 )
            get_str(icon_find2[6],buffer,"icon_kind7:");

        if (check_rc(buffer,"icon_kind8:")==0 )
            get_str(icon_find2[7],buffer,"icon_kind8:");

        if (check_rc(buffer,"icon_kind9:")==0 )
            get_str(icon_find2[8],buffer,"icon_kind9:");

        if (check_rc(buffer,"icon_kinda:")==0 )
            get_str(icon_find2[9],buffer,"icon_kinda:");

        fgets(buffer,4096,fp);
        for (i=0;i<4096;i++)
            if (buffer[i]=='\n') buffer[i]='\0';
    }
    fclose(fp);
    have_find_icon=0;
//    printf("%s%s%s%s.png",icon_path[0],icon_find1[0],icon_find2[0],icon_name);
    for (i=0;i<7;i++)
    {
        for (m=0;m<5;m++)
        {
            for (n=0;n<10;n++)
            {
                sprintf(icon_file,"%s%s%s%s.png",icon_path[i],icon_find1[m],icon_find2[n],icon_name);
                if (access(icon_file,0)!=-1)
                {
//                    printf("FIND:%s\n",icon_file);
                    have_find_icon=1;
                    sprintf(full_path_icon,"%s",icon_file);
                    break;
                }
                sprintf(icon_file,"%s%s%s%s.xpm",icon_path[i],icon_find1[m],icon_find2[n],icon_name);
                if (access(icon_file,0)!=-1)
                {
//                    printf("FIND:%s\n",icon_file);
                    have_find_icon=1;
                    sprintf(full_path_icon,"%s",icon_file);
                    break;
                }
                sprintf(icon_file,"%s%s%s%s",icon_path[i],icon_find1[m],icon_find2[n],icon_name);
                if (access(icon_file,0)!=-1)
                {
//                    printf("FIND:%s\n",icon_file);
                    have_find_icon=1;
                    sprintf(full_path_icon,"%s",icon_file);
                    break;
                }
            }
            if (have_find_icon==1) break;
        }
        if (have_find_icon==0)
        {
            sprintf(icon_file,"%s%s.png",icon_path[i],icon_name);
            if (access(icon_file,0)!=-1)
            {
//                printf("FIND:%s\n",icon_file);
                have_find_icon=1;
                sprintf(full_path_icon,"%s",icon_file);
                break;
            }
            sprintf(icon_file,"%s%s.xpm",icon_path[i],icon_name);
            if (access(icon_file,0)!=-1)
            {
//                printf("FIND:%s\n",icon_file);
                have_find_icon=1;
                sprintf(full_path_icon,"%s",icon_file);
                break;
            }
            sprintf(icon_file,"%s%s",icon_path[i],icon_name);
            if (access(icon_file,0)!=-1)
            {
//                printf("FIND:%s\n",icon_file);
                have_find_icon=1;
                sprintf(full_path_icon,"%s",icon_file);
                break;
            }
        } else
            break;
    }
//    printf("%s\n",icon_name);
    if (have_find_icon==0)
    for (i=0;i<7;i++)
    {
        sprintf(icon_file,"%sindex.theme",icon_path[i]);
        if (access(icon_file,0)!=-1)
        {
            fp2=fopen(icon_file,"r");
            if(fp2==NULL) 
            {
                printf("can't open %sindex.theme\n",icon_path[i]);
            }
            else
            {
                fgets(buffer,4096,fp2);
                for (n=0;n<4096;n++)
                if (buffer[n]=='\n') buffer[n]='\0';
                while ( ! feof(fp2) )
                {
                    if (check_rc(buffer,"Directories")==0 )
                    {
                        ReplaceStr(buffer,"Directories = ","");
                        ReplaceStr(buffer,"Directories= ","");
                        ReplaceStr(buffer,"Directories =","");
                        ReplaceStr(buffer,"Directories=","");
                        ReplaceStr(buffer,"Directories","");
                        break;
                    }
                    fgets(buffer,4096,fp2);
                        for (n=0;n<4096;n++)
                    if (buffer[n]=='\n') buffer[n]='\0';
                }
            }
            fclose(fp2);
            for (m=0;m<256;m++)
                s_dir[m]='\0';
            for (m=0;m<4096;m++)
            {
                if ((buffer[m]!=',') and (buffer[m]!='\0'))
                {
                    sprintf(s_dir,"%s%c",s_dir,buffer[m]);
                } else
                {
                    sprintf(icon_file,"%s%s/%s",icon_path[i],s_dir,icon_name);
                    //printf("%s%s/%s\n",icon_path[i],s_dir,icon_name);
                    if (access(icon_file,0)!=-1)
                    {
        //                printf("%s\n",icon_file);
                        have_find_icon=1;
                        sprintf(full_path_icon,"%s",icon_file);
                        break;
                    }
                    sprintf(icon_file,"%s%s/%s.png",icon_path[i],s_dir,icon_name);
                    if (access(icon_file,0)!=-1)
                    {
//                        printf("%s\n",icon_file);
                        have_find_icon=1;
                        sprintf(full_path_icon,"%s",icon_file);
                        break;
                    }

                    sprintf(icon_file,"%s%s/%s.xpm",icon_path[i],s_dir,icon_name);
                    if (access(icon_file,0)!=-1)
                    {
//                       printf("%s\n",icon_file);
                        have_find_icon=1;
                        sprintf(full_path_icon,"%s",icon_file);
                        break;
                    }
                    if (buffer[m]=='\0') break;
                    for (n=0;n<256;n++)
                        s_dir[n]='\0';
                }
            }
            if (have_find_icon==1)
                break;
            else
            {
                for (n=0;n<256;n++)
                    s_dir[n]='\0';
            }
        }
    }
    return full_path_icon;

}

void Creat_icon(int screenX,int screenY,int size,int gc,int l_id,char * picname,int lowerraise,double trans_icon,int autohideSubbutton, vector<icon> &icon_l)
{
    int w=size;
    int h=size;
    attr.override_redirect=True;
    icon_l[gc].id=gc;
    icon_l[gc].w_id=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,size,size,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
    icon_l[gc].x=screenX;
    icon_l[gc].y=screenY;
    icon_l[gc].l_id=l_id;
    XSelectInput(disp, icon_l[gc].w_id, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
    XMapWindow(disp, icon_l[gc].w_id);

    if(lowerraise==0)
         XLowerWindow(disp,icon_l[gc].w_id);
    if ((lowerraise==1) or (lowerraise==2))
         XRaiseWindow(disp,icon_l[gc].w_id);
    trans(trans_icon,icon_l[gc].w_id);
    imlib_context_set_drawable(icon_l[gc].w_id);
    imlib_context_set_image(back);
    icon_l[gc].buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);
    icon_l[gc].im_bg = imlib_load_image(find_icon_file(picname));
    if (icon_l[gc].im_bg == NULL)
        icon_l[gc].im_bg = imlib_load_image("/usr/share/icon-DE/iconcache/face-smile.png");
    imlib_context_set_drawable(icon_l[gc].w_id);
    imlib_context_set_image(icon_l[gc].im_bg);
    imlib_context_set_blend(1);
    int is=imlib_image_get_width();
    int ih=imlib_image_get_height();
    int d1=size-is;
    d1=d1/2;
    int d2=size-ih;
    d2=d2/2;

    imlib_context_set_image(back);
    imlib_render_image_on_drawable(0, 0);
    imlib_context_set_image(icon_l[gc].im_bg);
    imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
    icon_l[gc].bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);

    imlib_context_set_image(back);
    imlib_render_image_on_drawable(0, 0);
    imlib_context_set_image(icon_l[gc].im_bg);

    imlib_render_image_on_drawable(d1, d2);
    icon_l[gc].back=imlib_create_image_from_drawable( 0,0,0,w,h,1);
    XSync(disp, False);
    if (autohideSubbutton==1)
         XMoveWindow(disp,icon_l[gc].w_id,-size+2 , screenY);
    if (autohideSubbutton==2)
         XMoveWindow(disp,icon_l[gc].w_id,-size/2 , screenY);
}

void Destroy_icon(int n_begin,int n_end,vector<icon> &icon_l)
{
    int n,m;
    for (n=n_begin;n<n_end;n++)
    {
        if (icon_l[n].w_id!=0)
        {
            imlib_context_set_drawable(icon_l[n].w_id);
            imlib_context_set_image(icon_l[n].im_bg);
            imlib_free_image(); 
            imlib_context_set_image(icon_l[n].back);
            imlib_free_image(); 
            imlib_context_set_image(icon_l[n].bigback);
            imlib_free_image(); 
            imlib_context_set_image(icon_l[n].buffer);
            imlib_free_image(); 
            XDestroyWindow(disp,icon_l[n].w_id);
            icon_l[n].w_id=0;
            icon_l[n].s_g=0;
            icon_l[n].l_id=0;
            icon_l[n].id=0;
            icon_l[n].x=0;
            icon_l[n].y=0;
            sprintf(icon_l[n].group,"0");
            for (m=0;m<1024;m++)
            {
                icon_l[n].image[m]='\0';
                icon_l[n].tag[m]='\0';
                icon_l[n].apps[m]='\0';
                icon_l[n].title[m]='\0';
            }
        }
    }
}
void icon_filter(int x,int y,int i,int lowerraise,int mytoggle,vector<icon> &icon_l)
{
    int xl,yl;
    char bump[128];
    Imlib_Image                temp, temp2;
    if (icon_l[i].w_id!=0)
    {
        imlib_context_set_drawable(icon_l[i].w_id); 
        if(mytoggle == 1)
        {
            imlib_context_set_image(icon_l[i].bigback);
            xl=x-24;
            yl=y-24;
        }else{
            imlib_context_set_image(icon_l[i].back);
            xl=x-10;
            yl=y-10;
        }
        imlib_context_set_blend(1);
        temp = imlib_clone_image();
        imlib_context_set_image(temp);
        sprintf(bump,"bump_map_point(x=[],y=[],map=""/usr/share/icon-DE/iconcache/blend0.jpg);");
        if (lowerraise!=2)
            sprintf(bump,"bump_map_point(x=[],y=[],map=""/usr/share/icon-DE/iconcache/blend.jpg);");
        imlib_apply_filter
            (bump, &xl, &yl);
        imlib_context_set_image(icon_l[i].back);
        imlib_render_image_on_drawable(0, 0);
        temp2 = icon_l[i].im_bg;
        icon_l[i].im_bg = temp;
        imlib_context_set_image(icon_l[i].im_bg);
        imlib_context_set_blend(1);
        imlib_render_image_on_drawable(0, 0);
        icon_l[i].im_bg = temp2;
        imlib_context_set_image(temp);
        imlib_free_image(); 
    }
}

